SystemOrganization addCategory: #'Passport-Http-Squeak'!
SystemOrganization addCategory: #'Passport-Kernel'!
SystemOrganization addCategory: #'Passport-Magnitude-Numbers'!
SystemOrganization addCategory: #'Passport-SharedPool'!

SharedPool subclass: #Passport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-SharedPool'!

!SocketStream methodsFor: '*Passport-System-Squeak-stream in' stamp: 'PaulDeBruicker 8/19/2011 15:09'!
position
	^lastRead! !

!String methodsFor: '*Passport-converting' stamp: 'Alan Lovejoy 4/2/2006 15:30'!
asResourcePath
	^ResourcePath fromString: self! !

Error subclass: #HttpError
	instanceVariableNames: 'responseCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

!HttpError class methodsFor: 'exceptionInstantiator' stamp: 'Alan Lovejoy 3/29/2006 22:30'!
signal: signalerText responseCode: responseCode
	"Signal the occurrence of an exceptional condition with a specified textual description."

	^ self new 
		responseCode: responseCode;
		signal: signalerText! !

!HttpError methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/29/2006 22:32'!
responseCode
	^responseCode! !

!HttpError methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/29/2006 22:31'!
responseCode: httpResponseCode
	responseCode := httpResponseCode! !

!Number methodsFor: '*Passport-private-arithmetic' stamp: 'Chronos 1/14/2007 18:41'!
addedToInfinitesimal: anInfinitesimal
	^self! !

!Number methodsFor: '*Passport-private-arithmetic' stamp: 'Chronos 1/14/2007 18:41'!
addedToInfinity: anInfinity
	^anInfinity! !

!Number methodsFor: '*Passport-private-arithmetic' stamp: 'Chronos 1/14/2007 19:50'!
dividingInfinitesimal: anInfinitesimal
	self isZero ifTrue: [^ZeroDivide signal].
	^self negative == anInfinitesimal negative
		ifTrue: [anInfinitesimal abs]
		ifFalse: [anInfinitesimal negated]! !

!Number methodsFor: '*Passport-private-arithmetic' stamp: 'Chronos 1/14/2007 19:50'!
dividingInfinity: anInfinity
	self isZero ifTrue: [^ZeroDivide signal].
	^self negative == anInfinity negative
		ifTrue: [anInfinity abs]
		ifFalse: [anInfinity negated]! !

!Number methodsFor: '*Passport-testing' stamp: 'Chronos 1/14/2007 12:36'!
isInfinitesimal
	^false! !

!Number methodsFor: '*Passport-testing' stamp: 'Chronos 1/14/2007 14:55'!
isInfinity
	^self isInfinite! !

!Number methodsFor: '*Passport-private-arithmetic' stamp: 'Chronos 1/14/2007 18:41'!
multipliedByInfinitesimal: anInfinitesimal
	^self negative == anInfinitesimal negative
		ifTrue: [anInfinitesimal abs]
		ifFalse: [anInfinitesimal negated]! !

!Number methodsFor: '*Passport-private-arithmetic' stamp: 'Chronos 1/14/2007 19:36'!
multipliedByInfinity: anInfinity
	self isZero ifTrue: [^PassportNotANumber canonical].
	^self negative == anInfinity negative
		ifTrue: [anInfinity abs]
		ifFalse: [anInfinity negated]! !

!Number methodsFor: '*Passport-private-arithmetic' stamp: 'Chronos 1/14/2007 18:39'!
subtractedFromInfinitesimal: anInfinitesimal
	^self negated! !

!Number methodsFor: '*Passport-private-arithmetic' stamp: 'Chronos 1/14/2007 18:40'!
subtractedFromInfinity: anInfinity
	^anInfinity! !

Number subclass: #PassportMetanumber
	instanceVariableNames: 'lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Magnitude-Numbers'!

!PassportMetanumber class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Passport'! !

!PassportMetanumber class methodsFor: 'instance creation' stamp: ''!
new
	^self shouldNotImplement! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
< aMagnitude 
	"Answer whether the receiver is less than the argument."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison < 0]! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
<= otherMagnitude 
	"Answer whether the receiver is less than or equal to the argument."

	^(self > otherMagnitude) not! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
= otherMagnitude
	self == otherMagnitude ifTrue: [^true].
	^(self compareTo: otherMagnitude) = 0! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
> aMagnitude 
	"Answer whether the receiver is greater than the argument."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison > 0]! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
>= otherMagnitude 
	"Answer whether the receiver is greater than or equal to the argument."

	^(self < otherMagnitude) not! !

!PassportMetanumber methodsFor: 'arithmetic' stamp: ''!
abs

	^self! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 12:14'!
adaptToFloat: value andSend: operatorMessage
	^(PassportNotAMetanumber value: value) perform: operatorMessage with: self! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 12:14'!
adaptToFraction: value andSend: operatorMessage
	^(PassportNotAMetanumber value: value) perform: operatorMessage with: self! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 12:14'!
adaptToInteger: value andSend: operatorMessage
	^(PassportNotAMetanumber value: value) perform: operatorMessage with: self! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 12:14'!
adaptToScaledDecimal: value andSend: operatorMessage
	^(PassportNotAMetanumber value: value) perform: operatorMessage with: self! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 19:20'!
addedToNotAMetanumber: notAMetanumber
	^self! !

!PassportMetanumber methodsFor: 'converting' stamp: ''!
asDouble
	^self! !

!PassportMetanumber methodsFor: 'converting' stamp: ''!
asFloat
	^self! !

!PassportMetanumber methodsFor: 'converting' stamp: ''!
asInteger
	^self! !

!PassportMetanumber methodsFor: 'converting' stamp: ''!
asMetaNumber
	^self! !

!PassportMetanumber methodsFor: 'converting' stamp: ''!
asRational
	^self! !

!PassportMetanumber methodsFor: 'converting' stamp: ''!
asScaledDecimal: newScale
	^self! !

!PassportMetanumber methodsFor: 'private' stamp: ''!
assertMutability
	lock == nil ifFalse: [self signalMutationException]! !

!PassportMetanumber methodsFor: 'initialize-release' stamp: ''!
beImmutable
	"Make the receiver immutable.  Idempotent.  Must answer the receiver."

	lock == nil 
		ifTrue: 
			[self canonicalize.
			lock := #immutable]! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
between: min and: max 
	"Answer whether the receiver is less than or equal to the argument, max,
	and greater than or equal to the argument, min."

	^self >= min and: [self <= max]! !

!PassportMetanumber methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	"By default, do nothing"! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
compareTo: otherMagnitude
	"Compare the value of the receiver to that of <otherMagnitude>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <otherMagnitude> are the same.)"

	^self subclassResponsibility! !

!PassportMetanumber methodsFor: 'copying' stamp: ''!
copy
	"Answer a copy of the receiver which 1) is mutable,  2) compares (#=) as equal to the receiver, and 3) satisfies the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the behavior of the copy it answers in response to this message will not be changed, and b) whenever the copy answered by the receiver in response to this message mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the behavior of the receiver will not be changed.  An associative reference is one where the semantics of the reference are defined by the object identity (#==) of the referenced object.  An attributive reference is one where the semantics of the reference are defined by the value (#=) of the referenced object."

	"Subclasses should override this message for only one reason: to raise a 'NotCopyable' exception.  To change the behavior of #copy, subimplment #postCopy."


	^self shallowCopy postCopy! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 19:21'!
divisionOfNotAMetanumber: notAMetanumber
	^self! !

!PassportMetanumber methodsFor: 'testing' stamp: ''!
even
	^false! !

!PassportMetanumber methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	"By default, do nothing"! !

!PassportMetanumber methodsFor: 'testing' stamp: ''!
isImmutable
	^lock ~~ nil! !

!PassportMetanumber methodsFor: 'private' stamp: ''!
isImmutable: aBoolean
	"Prevent VW from making me immutable at the VM level, because that's much too strict and draconian."

	aBoolean ifTrue: [self beImmutable]

	"I can't become mutable--and I'm always mutable in the VW sense, anyway."! !

!PassportMetanumber methodsFor: 'testing' stamp: ''!
isMutable
	^lock == nil! !

!PassportMetanumber methodsFor: 'testing' stamp: ''!
isZero
	^false! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
max: otherMagnitude 
	"Answer the receiver or the argument, whichever has the greater magnitude."

	self > otherMagnitude
		ifTrue: [^self]
		ifFalse: [^otherMagnitude]! !

!PassportMetanumber methodsFor: 'comparing' stamp: ''!
min: otherMagnitude 
	"Answer the receiver or the argument, whichever has the lesser magnitude."

	self < otherMagnitude
		ifTrue: [^self]
		ifFalse: [^otherMagnitude]! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 19:22'!
multipliedByNotAMetanumber: notAMetanumber 
	^self! !

!PassportMetanumber methodsFor: 'testing' stamp: ''!
negative
	^false! !

!PassportMetanumber methodsFor: 'private' stamp: ''!
nilFields
	"Store nil into all pointer fields of the receiver."

	EnvironmentFacade current makeMutable: self.
	super nilFields! !

!PassportMetanumber methodsFor: 'testing' stamp: ''!
odd
	^false! !

!PassportMetanumber methodsFor: 'testing' stamp: ''!
positive
	^false! !

!PassportMetanumber methodsFor: 'private' stamp: ''!
postCopy
	"PRECONDTION: The receiver has just been instantiated as a #shallowCopy of another object.  
	POSTCONDITION: In response to this message, the receiver is required to make itself satisfy the following conditions and constraints: 1) It must be mutable,  2) It must compare (#=) as equal to the object from which it was shallowCopied, and 3) It must satisfy the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the object from which it was shallowCopied must not be changed, and b) whenever the object from which the receiver was shallowCopied mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the receiver must not be changed.  An associative reference is one where the semantics of the reference depend in any way on the object identity (#==) of the referenced object.  An attributive reference is one where any referenced object with the same value can transparently be substituted for any other such value-equivalent object without causing any error."

	"Subclasses may need to subimplement this message in order to satisfy the required semantics.  All subimplementers should send #postCopy to super."

	lock := nil.
	EnvironmentFacade current makeMutable: self! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 13:33'!
printOn: aStream base: base
	self printOn: aStream! !

!PassportMetanumber methodsFor: 'mathematical functions' stamp: ''!
raisedToInteger: anInteger 
	^self! !

!PassportMetanumber methodsFor: 'error signalling' stamp: ''!
signal: anExceptionFactory message: message
	^EnvironmentFacade signal: anExceptionFactory message: message contextName: self class name! !

!PassportMetanumber methodsFor: 'error signalling' stamp: ''!
signalMutationException
	^self signal: Error message: 'Attempt to mutate an immutable instance'! !

!PassportMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 19:23'!
subtractedFromNotAMetanumber: notAMetanumber
	^self! !

!PassportMetanumber methodsFor: 'truncation and roundoff' stamp: ''!
truncated
	^self! !

PassportMetanumber subclass: #PassportNotANumber
	instanceVariableNames: ''
	classVariableNames: 'Canonical'
	poolDictionaries: ''
	category: 'Passport-Magnitude-Numbers'!

!PassportNotANumber class methodsFor: 'constants' stamp: ''!
canonical
	Canonical == nil ifTrue: [Canonical := self basicNew].
	^Canonical! !

!PassportNotANumber class methodsFor: 'class initialization' stamp: ''!
initialize
	Canonical := nil! !

!PassportNotANumber methodsFor: 'arithmetic' stamp: ''!
* aNumber
	^self! !

!PassportNotANumber methodsFor: 'arithmetic' stamp: ''!
+ aNumber
	^self! !

!PassportNotANumber methodsFor: 'arithmetic' stamp: ''!
- aNumber
	^self! !

!PassportNotANumber methodsFor: 'arithmetic' stamp: ''!
/ aNumber
	^self! !

!PassportNotANumber methodsFor: 'private-arithmetic' stamp: ''!
addedToInfinitesimal: anInfinitesimal
	^self! !

!PassportNotANumber methodsFor: 'private-arithmetic' stamp: ''!
addedToInfinity: anInfinity
	^self! !

!PassportNotANumber methodsFor: 'comparing' stamp: ''!
compareTo: otherMagnitude
	"Compare the value of the receiver to that of <otherMagnitude>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <otherMagnitude> are the same.)"

	^-1! !

!PassportNotANumber methodsFor: 'private-arithmetic' stamp: ''!
dividingInfinitesimal: anInfinitesimal
	^self! !

!PassportNotANumber methodsFor: 'private-arithmetic' stamp: ''!
dividingInfinity: anInfinity
	^self! !

!PassportNotANumber methodsFor: 'comparing' stamp: ''!
hash
	^16383 hash! !

!PassportNotANumber methodsFor: 'testing' stamp: ''!
isNaN
	^true! !

!PassportNotANumber methodsFor: 'private-arithmetic' stamp: ''!
multipliedByInfinitesimal: anInfinitesimal
	^self! !

!PassportNotANumber methodsFor: 'private-arithmetic' stamp: ''!
multipliedByInfinity: anInfinity
	^self! !

!PassportNotANumber methodsFor: 'printing' stamp: ''!
printOn: stream
	stream nextPutAll: 'NaN'! !

!PassportNotANumber methodsFor: 'private' stamp: ''!
printOn: aStream printPolicy: aNumberPrintPolicy
	" *** This method was defined by Number as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	self error: 'Subclass responsibility stub not reimplemented'! !

!PassportNotANumber methodsFor: 'testing' stamp: ''!
strictlyPositive
	^false! !

!PassportNotANumber methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfinitesimal: anInfinitesimal
	^self! !

!PassportNotANumber methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfinity: anInfinity
	^self! !

PassportMetanumber subclass: #PassportSignedMetanumber
	instanceVariableNames: 'isNegative'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Magnitude-Numbers'!

PassportSignedMetanumber subclass: #PassportInfinitesimal
	instanceVariableNames: ''
	classVariableNames: 'Negative Positive'
	poolDictionaries: ''
	category: 'Passport-Magnitude-Numbers'!

!PassportInfinitesimal class methodsFor: 'class initialization' stamp: ''!
initialize
	"PassportInfinitesimal initialize."

	Positive := nil.
	Negative := nil.! !

!PassportInfinitesimal class methodsFor: 'constants' stamp: ''!
negative
	Negative == nil ifTrue: [Negative := self basicNew beNegative].
	^Negative! !

!PassportInfinitesimal class methodsFor: 'constants' stamp: ''!
positive
	Positive == nil ifTrue: [Positive := self basicNew bePositive].
	^Positive! !

!PassportInfinitesimal class methodsFor: 'unit test' stamp: ''!
testDoIts
	"0 > PassportInfinitesimal positive 
	PassportInfinitesimal positive < 0
	0 < PassportInfinitesimal positive 
	PassportInfinitesimal positive > 0
	0 > PassportInfinitesimal negative 
	PassportInfinitesimal negative < 0
	0 < PassportInfinitesimal negative 
	PassportInfinitesimal negative > 0
	PassportInfinitesimal positive < PassportInfinity negative 
	PassportInfinitesimal negative > PassportInfinity positive

	7 + PassportInfinitesimal positive
	PassportInfinitesimal positive + 7
	7 - PassportInfinitesimal positive
	PassportInfinitesimal positive - 7
	7 * PassportInfinitesimal positive
	PassportInfinitesimal positive * 7
	7 / PassportInfinitesimal positive
	PassportInfinitesimal positive / 7

	7 + PassportInfinitesimal negative
	PassportInfinitesimal negative + 7
	7 - PassportInfinitesimal negative
	PassportInfinitesimal negative - 7
	7 * PassportInfinitesimal negative
	PassportInfinitesimal negative * 7
	7 / PassportInfinitesimal negative
	PassportInfinitesimal negative / 7

	-7 + PassportInfinitesimal positive
	PassportInfinitesimal positive + -7
	-7 - PassportInfinitesimal positive
	PassportInfinitesimal positive - -7
	-7 * PassportInfinitesimal positive
	PassportInfinitesimal positive * -7
	-7 / PassportInfinitesimal positive
	PassportInfinitesimal positive / -7

	-7 + PassportInfinitesimal negative
	PassportInfinitesimal negative + -7
	-7 - PassportInfinitesimal negative
	PassportInfinitesimal negative - -7
	-7 * PassportInfinitesimal negative
	PassportInfinitesimal negative * -7
	-7 / PassportInfinitesimal negative
	PassportInfinitesimal negative / -7"! !

!PassportInfinitesimal methodsFor: 'arithmetic' stamp: ''!
* factor 

	^factor multipliedByInfinitesimal: self! !

!PassportInfinitesimal methodsFor: 'arithmetic' stamp: ''!
+ addend 

	^addend addedToInfinitesimal: self! !

!PassportInfinitesimal methodsFor: 'arithmetic' stamp: ''!
- subtrahend 

	^subtrahend subtractedFromInfinitesimal: self! !

!PassportInfinitesimal methodsFor: 'arithmetic' stamp: ''!
/ divisor 

	^divisor dividingInfinitesimal: self! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: ''!
addedToInfinitesimal: anInfinitesimal
	^isNegative == anInfinitesimal negative
		ifTrue: [self]
		ifFalse: [PassportNotANumber canonical]! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: ''!
addedToInfinity: anInfinity
	^anInfinity! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 11:57'!
addedToNotAMetanumber: notAMetanumber
	^notAMetanumber isZero 
		ifTrue: [self]
		ifFalse: [notAMetanumber]! !

!PassportInfinitesimal methodsFor: 'converting' stamp: ''!
asDouble
	^0.0 asDouble! !

!PassportInfinitesimal methodsFor: 'converting' stamp: ''!
asFloat
	^0.0! !

!PassportInfinitesimal methodsFor: 'converting' stamp: ''!
asInteger
	^0! !

!PassportInfinitesimal methodsFor: 'converting' stamp: ''!
asRational
	^PassportNotANumber canonical! !

!PassportInfinitesimal methodsFor: 'comparing' stamp: ''!
compareTo: otherMagnitude
	"Compare the value of the receiver to that of <otherMagnitude>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <otherMagnitude> are the same.)"

	self == otherMagnitude ifTrue: [^0].
	^[otherMagnitude compareToInfinitesimal: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == otherMagnitude and: [ex message selector == #compareToInfinitesimal:])
					ifTrue: [ex return: (isNegative ifTrue: [otherMagnitude < 0 ifTrue: [1] ifFalse: [-1]] ifFalse: [otherMagnitude > 0 ifTrue: [-1] ifFalse: [1]])]
					ifFalse: [ex pass]]! !

!PassportInfinitesimal methodsFor: 'private-comparing' stamp: ''!
compareToInfinitesimal: anInfinitesimal
	^anInfinitesimal negative 
		ifTrue: [isNegative ifTrue: [0] ifFalse: [-1]]
		ifFalse: [isNegative ifTrue: [1] ifFalse: [0]]! !

!PassportInfinitesimal methodsFor: 'private-comparing' stamp: ''!
compareToInfinity: anInfinity 
	^anInfinity negative ifTrue: [-1] ifFalse: [1]! !

!PassportInfinitesimal methodsFor: 'private-comparing' stamp: 'Chronos 1/14/2007 11:58'!
compareToNotAMetanumber: notAMetanumber 
	^ isNegative
		ifTrue: [notAMetanumber < 0
					ifTrue: [-1]
					ifFalse: [1]]
		ifFalse: [notAMetanumber > 0
					ifTrue: [1]
					ifFalse: [-1]]! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: ''!
dividingInfinitesimal: anInfinitesimal
	^PassportNotANumber canonical! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: ''!
dividingInfinity: anInfinity
	^isNegative == anInfinity negative
		ifTrue: [isNegative ifTrue: [anInfinity abs] ifFalse: [anInfinity]]
		ifFalse: [isNegative ifTrue: [anInfinity negated] ifFalse: [anInfinity]]! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 11:57'!
divisionOfNotAMetanumber: notAMetanumber
	notAMetanumber isZero ifTrue: [^0].
	^PassportInfinity polarity: notAMetanumber negative == self negative! !

!PassportInfinitesimal methodsFor: 'testing' stamp: ''!
isInfinitesimal
	^true! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: ''!
multipliedByInfinitesimal: anInfinitesimal
	^isNegative == anInfinitesimal negative
		ifTrue: [isNegative ifTrue: [self abs] ifFalse: [self]]
		ifFalse: [isNegative ifTrue: [self] ifFalse: [anInfinitesimal]]! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: ''!
multipliedByInfinity: anInfinity
	^PassportNotANumber canonical! !

!PassportInfinitesimal methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	stream nextPutAll: 'infinitesimal'! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfinitesimal: anInfinitesimal
	^isNegative == anInfinitesimal negative
		ifTrue: [PassportNotANumber canonical]
		ifFalse: [anInfinitesimal]! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfinity: anInfinity
	^anInfinity! !

!PassportInfinitesimal methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 11:58'!
subtractedFromNotAMetanumber: notAMetanumber
	^notAMetanumber isZero 
		ifTrue: [self negated]
		ifFalse: [notAMetanumber]! !

!PassportInfinitesimal methodsFor: 'truncation and roundoff' stamp: ''!
truncated
	^0! !

PassportSignedMetanumber subclass: #PassportInfinity
	instanceVariableNames: ''
	classVariableNames: 'Negative Positive'
	poolDictionaries: ''
	category: 'Passport-Magnitude-Numbers'!

!PassportInfinity commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005 by Alan L. Lovejoy.  All Rights Reserved. Usage is strictly controlled by the Chronos License (which is included in the distribution as the contents of the file <chronos-license.txt>.)

!

!PassportInfinity class methodsFor: 'class initialization' stamp: ''!
initialize
	"PassportInfinity initialize."

	Positive := nil.
	Negative := nil.! !

!PassportInfinity class methodsFor: 'constants' stamp: ''!
negative
	Negative == nil ifTrue: [Negative := self basicNew beNegative].
	^Negative! !

!PassportInfinity class methodsFor: 'constants' stamp: ''!
positive
	Positive == nil ifTrue: [Positive := self basicNew bePositive].
	^Positive! !

!PassportInfinity class methodsFor: 'unit test' stamp: ''!
testDoIts
	"1 > PassportInfinity positive 
	PassportInfinity positive < 1
	1 < PassportInfinity positive 
	PassportInfinity positive > 1
	1 > PassportInfinity negative 
	PassportInfinity negative < 1
	1 < PassportInfinity negative 
	PassportInfinity negative > 1
	PassportInfinity positive < PassportInfinity negative 
	PassportInfinity negative > PassportInfinity positive

	7 + PassportInfinity positive
	PassportInfinity positive + 7
	7 - PassportInfinity positive
	PassportInfinity positive - 7
	7 * PassportInfinity positive
	PassportInfinity positive * 7
	7 / PassportInfinity positive
	PassportInfinity positive / 7

	7 + PassportInfinity negative
	PassportInfinity negative + 7
	7 - PassportInfinity negative
	PassportInfinity negative - 7
	7 * PassportInfinity negative
	PassportInfinity negative * 7
	7 / PassportInfinity negative
	PassportInfinity negative / 7

	-7 + PassportInfinity positive
	PassportInfinity positive + -7
	-7 - PassportInfinity positive
	PassportInfinity positive - -7
	-7 * PassportInfinity positive
	PassportInfinity positive * -7
	-7 / PassportInfinity positive
	PassportInfinity positive / -7

	-7 + PassportInfinity negative
	PassportInfinity negative + -7
	-7 - PassportInfinity negative
	PassportInfinity negative - -7
	-7 * PassportInfinity negative
	PassportInfinity negative * -7
	-7 / PassportInfinity negative
	PassportInfinity negative / -7"! !

!PassportInfinity methodsFor: 'arithmetic' stamp: ''!
* factor 

	^factor multipliedByInfinity: self! !

!PassportInfinity methodsFor: 'arithmetic' stamp: ''!
+ addend 
	^addend addedToInfinity: self! !

!PassportInfinity methodsFor: 'arithmetic' stamp: ''!
- subtrahend 

	^subtrahend subtractedFromInfinity: self! !

!PassportInfinity methodsFor: 'arithmetic' stamp: ''!
/ divisor 

	^divisor dividingInfinity: self! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: ''!
addedToInfinitesimal: anInfinitesimal
	^self! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: ''!
addedToInfinity: anInfinity
	^isNegative == anInfinity negative
		ifTrue: [self]
		ifFalse: [PassportNotANumber canonical]! !

!PassportInfinity methodsFor: 'comparing' stamp: ''!
compareTo: otherMagnitude
	"Compare the value of the receiver to that of <otherMagnitude>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <otherMagnitude> are the same.)"

	self == otherMagnitude ifTrue: [^0].
	^[otherMagnitude compareToInfinity: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == otherMagnitude and: [ex message selector == #compareToInfinity:])
					ifTrue: [ex return: (isNegative ifTrue: [-1] ifFalse: [1])]
					ifFalse: [ex pass]]! !

!PassportInfinity methodsFor: 'private-comparing' stamp: ''!
compareToInfinitesimal: anInfinitesimal
	^isNegative ifTrue: [1] ifFalse: [-1]! !

!PassportInfinity methodsFor: 'private-comparing' stamp: ''!
compareToInfinity: anInfinity 
	^anInfinity negative 
		ifTrue: [isNegative ifTrue: [0] ifFalse: [-1]]
		ifFalse: [isNegative ifTrue: [1] ifFalse: [0]]! !

!PassportInfinity methodsFor: 'private-comparing' stamp: 'Chronos 1/14/2007 11:44'!
compareToNotAMetanumber: notAMetanumber
	^isNegative 
		ifTrue: [1]
		ifFalse: [-1]! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: ''!
dividingInfinitesimal: anInfinitesimal
	^isNegative == anInfinitesimal negative
		ifTrue: [isNegative ifTrue: [anInfinitesimal abs] ifFalse: [anInfinitesimal]]
		ifFalse: [isNegative ifTrue: [anInfinitesimal negated] ifFalse: [anInfinitesimal]]! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: ''!
dividingInfinity: anInfinity
	^PassportNotANumber canonical! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 11:18'!
divisionOfNotAMetanumber: notAMetanumber

	notAMetanumber isZero ifTrue: [^0].
	^PassportInfinitesimal polarity: notAMetanumber negative == self negative! !

!PassportInfinity methodsFor: 'testing' stamp: ''!
isInfinite
	^true! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: ''!
multipliedByInfinitesimal: anInfinitesimal
	^PassportNotANumber canonical! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: ''!
multipliedByInfinity: anInfinity 
	^isNegative == anInfinity negative
		ifTrue: [isNegative ifTrue: [self abs] ifFalse: [self]]
		ifFalse: [isNegative ifTrue: [self] ifFalse: [anInfinity]]! !

!PassportInfinity methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	stream nextPutAll: 'infinity'! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfinitesimal: anInfinitesimal
	^self! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfinity: anInfinity
	^isNegative == anInfinity negative
		ifTrue: [PassportNotANumber canonical]
		ifFalse: [anInfinity]! !

!PassportInfinity methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 11:15'!
subtractedFromNotAMetanumber: notAMetanumber

	^self negated! !

!PassportSignedMetanumber class methodsFor: 'accessing' stamp: ''!
polarity: polarity 
	^polarity ifTrue: [self positive] ifFalse: [self negative]! !

!PassportSignedMetanumber methodsFor: 'arithmetic' stamp: ''!
abs
	^isNegative ifTrue: [self class positive] ifFalse: [self]! !

!PassportSignedMetanumber methodsFor: 'initialize-release' stamp: ''!
beNegative
	self assertMutability.
	isNegative := true! !

!PassportSignedMetanumber methodsFor: 'initialize-release' stamp: ''!
bePositive
	self assertMutability.
	isNegative := false! !

!PassportSignedMetanumber methodsFor: 'comparing' stamp: ''!
hash
	^isNegative hash! !

!PassportSignedMetanumber methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	self assertMutability.	
	isNegative := false.! !

!PassportSignedMetanumber methodsFor: 'private-arithmetic' stamp: 'Chronos 1/14/2007 19:22'!
multipliedByNotAMetanumber: notAMetanumber 
	^notAMetanumber isZero 
		ifTrue: [0]
		ifFalse: [notAMetanumber negative ifTrue: [self negated] ifFalse: [self]]! !

!PassportSignedMetanumber methodsFor: 'arithmetic' stamp: ''!
negated
	^isNegative ifTrue: [self class positive] ifFalse: [self class negative]! !

!PassportSignedMetanumber methodsFor: 'testing' stamp: ''!
negative
	^isNegative! !

!PassportSignedMetanumber methodsFor: 'testing' stamp: ''!
positive
	^isNegative not! !

!PassportSignedMetanumber methodsFor: 'printing' stamp: ''!
printOn: stream
	isNegative
		ifTrue: [stream nextPut: $-]
		ifFalse: [stream nextPut: $+].! !

!ScaledDecimal class methodsFor: '*passport' stamp: 'PaulDeBruicker 6/6/2011 09:20'!
numerator: numerator denominator: denominator scale: scale
	"ScaledDecimal numerator: 1 denominator: 1000000 scale: 9"

	^ self newFromNumber: numerator / denominator scale: scale! !

!SequenceableCollection methodsFor: '*Passport-converting' stamp: 'Alan Lovejoy 3/19/2006 16:42'!
newReadWriteStream
	"Answer a readStream on the receiver.  Subclasses can provide their own kinds of Stream here."

	^ReadWriteStream on: self! !

Object subclass: #EnvironmentFacade
	instanceVariableNames: ''
	classVariableNames: 'NotAValue PlatformClass ResourcePathFacadeFactoryReferences RestartNotificationSubscribers'
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!EnvironmentFacade class methodsFor: 'namespace operations' stamp: ''!
addImport: importedNamespacePath in: importingNamespace private: isPrivate
	"Cause the <importingNamespace> to 'import' from the namespace whose hierarchical name key is represented (in a syntactically-portable manner) by the pathname-array <importedNamespacePath>. Ideally, this should be done by means of dynamic delegation from <importingNamespace> to the namespace specified by <importedNamespacePath>.  However, if necessary, it may also be achieved by copying the bindings (key->value associations) from the namespace specified by <importedNamespacePath> into the <importingNamespace>, or even by duplicating the key->value entries.

	The <importedNamespacePath> parameter (representing the hierarchical name key of a namespace) will be an Array of Symbols. The first Symbol will be the name of a namespace accessible from the global namespace (and may even be the name of the global namespace itself.)  Each subsequent Symbol will be the name of a namespace accessible from the previous namespace.  So, if there is a namespace defined in the global namespace named #Chronos, which contains a namespace named #ChronosTemporalRatioConstants, then the hierarchical name key identifing the #ChronosTemporalRatioConstants namespace would be the Array #(Chronos ChronosTemporalRatioConstants). In this way, it is possible to portably specify hierarchical namespace pathnames without knowing or caring about the synatax used for such hierarchical names by the host Smalltalk system."

	| importedNamespace |
	importedNamespace := importedNamespacePath inject: self globalNamespace into: [:ns :key | ns at: key].
	importedNamespace associationsDo: [:association | importingNamespace removeKey: association key ifAbsent: []; add: association]! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicCancelImageRestartNotificationSubscriptionFor: subscriber
	RestartNotificationSubscribers == nil ifTrue: [^self].
	RestartNotificationSubscribers removeKey: subscriber ifAbsent: []! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicNewLineToConsole
	Transcript cr! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicRegisterForStartupNotification
	"Make it so that whenever the Smalltalk image is restarted after a snapshot, the receiver will be sent the message #handleRestart.

	NOTE: This method is intended for use by image-based Smalltalk implementations.  It may or may not have any utility in the case of non-image-based Smalltalk systems."

	^self subclassResponsibility! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicRelease
	"Ensure that the receiver disconnets from its environment."

	"EnvironmentFacade basicRelease"

	self unregisterForStartupNotification! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicReportToConsole: contextName message: message newLineCount: newLineCount tabCount: tabCount
	"EnvironmentFacade current reportToConsole: 'Test' message: 'Hello, world' newLineCount: 1 tabCount: 0"
	"EnvironmentFacade current reportToConsole: 'Test' message: 'Hello, world' newLineCount: 0 tabCount: 2"

	newLineCount timesRepeat: [Transcript cr].
	tabCount timesRepeat: [Transcript tab].
	tabCount < 1 ifTrue: [Transcript show: '## '; show: contextName; show: ': '].
	Transcript show: message! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicSendImageRestartNotificationsToSubscribers
	| notificationMessage |
	RestartNotificationSubscribers == nil ifTrue: [^self].
	RestartNotificationSubscribers keys do: 
			[:subscriber | 
			(subscriber == nil or: 
					[subscriber = 0 or: 
							[(subscriber isBehavior ifTrue: [subscriber] ifFalse: [subscriber class]) 
								isObsolete]]) 
				ifTrue: [RestartNotificationSubscribers removeKey: subscriber ifAbsent: []]
				ifFalse: 
					[notificationMessage := RestartNotificationSubscribers at: subscriber.
					[subscriber perform: notificationMessage] on: Error
						do: 
							[:ex | 
							self 
								reportException: ex
								message: 'Image restart notification failure when sending ' 
										, notificationMessage , ' to ' 
										, subscriber printString]]]! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicSignal: anExceptionFactory message: message contextName: contextName
	"Using <anExceptionFactory>, raise an exception with the given <message>"

	| stream |
	stream := (String new: 12) writeStream.
	stream
		nextPut: ${;
		nextPutAll: contextName;
		nextPutAll: '} ';
		nextPutAll: message.
	^anExceptionFactory signal: stream contents! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicSubscribe: subscriber forImageRestartNotificationSending: restartNotificationMessage 
	RestartNotificationSubscribers == nil ifTrue: [self setRestartNotificationSubscribers].
	RestartNotificationSubscribers at: subscriber put: restartNotificationMessage! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
basicUnregisterForStartupNotification
	"Make it so that whenever the Smalltalk image is restarted after a snapshot, the receiver will NOT be sent the message #install (nor otherwise notified.)

	NOTE: This method is intended for use by image-based Smalltalk implementations.  It may or may not have any utility in the case of non-image-based Smalltalk systems."

	^self subclassResponsibility! !

!EnvironmentFacade class methodsFor: 'class initialization' stamp: ''!
beCurrent
	PlatformClass := self.
	self defineScaledDecimalInGlobalNamespace! !

!EnvironmentFacade class methodsFor: 'image restart' stamp: ''!
cancelImageRestartNotificationSubscriptionFor: subscriber
	self current basicCancelImageRestartNotificationSubscriptionFor: subscriber! !

!EnvironmentFacade class methodsFor: 'accessing' stamp: ''!
current
	"EnvironmentFacade current"

	PlatformClass == nil ifTrue: [self setPlatformClass].
	^PlatformClass == nil ifTrue: [self] ifFalse: [PlatformClass]! !

!EnvironmentFacade class methodsFor: 'global variable bindings' stamp: ''!
defineScaledDecimalInGlobalNamespace
	"EnvironmentFacade current defineScaledDecimalInGlobalNamespace"

	| nativeScaledDecimalClass |
	nativeScaledDecimalClass := self nativeScaledDecimalClass.
	nativeScaledDecimalClass == nil ifTrue: [^self].
	self
		defineVariable: #ScaledDecimal
		in: self globalNamespace
		withValue: nativeScaledDecimalClass
		constant: true
		category: #'Chronos-Aliases'
		rebindIfPresent: false
		onCollision: [].! !

!EnvironmentFacade class methodsFor: 'namespace operations' stamp: 'PaulDeBruicker 3/7/2011 19:06'!
defineVariable: key in: aNamespace withValue: value constant: constant category: aCategory rebindIfPresent: rebindIfPresent onCollision: collisionAction 
	"Define a binding (key->value association) in the namespace <aNamespace> (which may just be a Dictionary,) whose key is <key>, and whose value is <value>.  If <constant> is true (and if constant/immutable bindings are supported by the functionality of <aNamespace>,) make the binding constant (immutable.) If supported by the functionality of <aNamespace>, place the binding in the semantic category <category>.  

	If there already exists a binding in <aNamespace> with the given <key>, then:

		1) If the value associated with <key> is the same object as <value>, then just answer <value>.  
		2) If the value associated with <key> is nil, then:
			If there is also a binding in the Undeclared namespace whose key is <key>, set <value> as the value of the binding in the Undeclared namespace, and then move the binding (which might be an Association instance, or else an object that supports Association-like behavior and/or protocol) from the Undeclared namespace to <namespace>. Otherwise, set <value> as the value of the binding already present in <aNamespace>.
		3) If the value associated with <key> is neither nil nor the same object as <value>, but if <rebindIfPresent> is true, then remove any binding whose key is <key> from the Undeclared namespace, and reset the value of the binding in <aNamespace> whose key is <key> to the value <value>.
		4) If the value associated with <key> is neither nil nor the same object as <value>, and if <rebindIfPresent> is also false, then do not change the value of the existing binding, but instead invoke the zero-argument block <collisionAction> (and answer the result.)"

	| presentValue |
	presentValue := aNamespace at: key ifAbsent: [self notAValue].
	^presentValue == value 
		ifTrue: [value]
		ifFalse: 
			[(rebindIfPresent or: [presentValue == self notAValue or: [presentValue == nil]]) 
				ifTrue: 
					[presentValue == self notAValue 
						ifTrue: 
							[(Undeclared includesKey: key) 
								ifTrue: [aNamespace declare: key from: Undeclared.
									"self halt." ]]
						ifFalse: [Undeclared removeKey: key ifAbsent: []].
					aNamespace at: key put: value]
				ifFalse: [collisionAction value]]! !

!EnvironmentFacade class methodsFor: 'character constants' stamp: ''!
euroCurrencyCharIfNone: ifNone
	"Answer the Character value that represents the symbol for the Euro currency.  If the Smalltalk execution environment does not support such a character value, then answer the result of evaluating the <ifNone> block."
	
	^ifNone value! !

!EnvironmentFacade class methodsFor: 'code complation/execution' stamp: ''!
evaluateExpression: smalltalkExpression
	^Compiler evaluate: smalltalkExpression! !

!EnvironmentFacade class methodsFor: 'namespace operations' stamp: ''!
fullyQualifiedNameOfClass: aClass
	"Answer the fully-qualified (usable anywhere) name of <aClass>."

	"ChronosEnvironment canonical fullyQualifiedNameOfClass: Timepoint"

	^aClass name! !

!EnvironmentFacade class methodsFor: 'accessing' stamp: ''!
globalNamespace
	"Answer the namespace canonically (or most generally) used for the purpose of defining and accessing classes by the host Smalltalk implementation."

	^Smalltalk! !

!EnvironmentFacade class methodsFor: 'accessing' stamp: ''!
globalNamespaceName
	"Answer the name of the namespace canonically (or most generally) used for the purpose of defining and accessing classes by the host Smalltalk implementation."

	^#Smalltalk! !

!EnvironmentFacade class methodsFor: 'image restart' stamp: ''!
handleRestart
	self invalidateResourcePathFacades.
	self sendImageRestartNotificationsToSubscribers! !

!EnvironmentFacade class methodsFor: 'class initialization' stamp: ''!
initialize
	"EnvironmentFacade initialize."

	NotAValue := Object new.
	self release.! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
initializeResourcePathFacadeFactoryReferences

	"{EnvironmentFacade current initializeResourcePathFacadeFactoryReferences}"

	ResourcePathFacadeFactoryReferences := IdentityDictionary new.! !

!EnvironmentFacade class methodsFor: 'resource paths' stamp: ''!
invalidateResourcePathFacades

	"{EnvironmentFacade invalidateResourcePathFacades}"

	self current initializeResourcePathFacadeFactoryReferences.
	ResourcePathContext invalidateFacades.! !

!EnvironmentFacade class methodsFor: 'accessing' stamp: ''!
key
	"EnvironmentFacade current key"

	^#unknown! !

!EnvironmentFacade class methodsFor: 'mutability' stamp: ''!
makeImmutable: anObject
	"Make the argument immutable.  Answer the argumnt--NOT A COPY!!. If the host Smalltalk environment doesn't support immutable objects, then just answer the argument as-is."

	^anObject! !

!EnvironmentFacade class methodsFor: 'mutability' stamp: ''!
makeMutable: anObject
	"Make the argument mutable.  Answer the argumnt--NOT A COPY!!. If the host Smalltalk environment doesn't support immutable objects, then just answer the argument as-is."

	^anObject! !

!EnvironmentFacade class methodsFor: 'namespace operations' stamp: ''!
namespaceOfClass: aClass
	^aClass environment! !

!EnvironmentFacade class methodsFor: 'class binding' stamp: 'PaulDeBruicker 03/07/2011 13:01'!
nativeScaledDecimalClass
	"Answer the class that implements the ANSI-Smallltalk <ScaledDecimal> protocol in the native Smalltalk environment.  Answer nil if none."

	^(Pathname components: #(#ScaledDecimal)) value! !

!EnvironmentFacade class methodsFor: 'console operations' stamp: ''!
newLineToConsole
	self current basicNewLineToConsole! !

!EnvironmentFacade class methodsFor: 'object creation' stamp: 'PaulDeBruicker 3/9/2011 10:30'!
newWeakDictionary
	
	^IdentityDictionary new! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
notAValue
	NotAValue == nil ifTrue: [NotAValue := Object new].
	^NotAValue! !

!EnvironmentFacade class methodsFor: 'accessing' stamp: ''!
passportNamespace
	"Answer the namespace used for Passport."

	^(Pathname components: (Array with: self passportNamespaceName)) value! !

!EnvironmentFacade class methodsFor: 'accessing' stamp: ''!
passportNamespaceName
	"Answer the name of the namespace used for Passport."

	^#Passport! !

!EnvironmentFacade class methodsFor: 'system operations' stamp: ''!
performGarbageCollection
	^Smalltalk garbageCollect! !

!EnvironmentFacade class methodsFor: 'namespace operations' stamp: ''!
purgeUnusedBindingsFromUndeclaredNamespace
	"Remove any bindings (associations) from the Undeclared namespace (Dictionary) for which there are no active references in the system codebase."

	^self subclassResponsibility! !

!EnvironmentFacade class methodsFor: 'class initialization' stamp: ''!
registerForStartupNotification
	"Make it so that whenever the Smalltalk image is restarted after a snapshot, the receiver's 'PlatformClass' will be sent the message #handleRestart.

	NOTE: This method is intended for use by image-based Smalltalk implementations.  It may or may not have any utility in the case of non-image-based Smalltalk systems."

	"EnvironmentFacade registerForStartupNotification"

	^self current basicRegisterForStartupNotification! !

!EnvironmentFacade class methodsFor: 'class initialization' stamp: ''!
release
	"The message #release must be sent to EnvironmentFacade whenever Passport is about to be removed from the system (image.)  It is the responsibility of subimplementors to ensure that this message is sent at the appropriate time."

	"EnvironmentFacade release"

	PlatformClass == nil ifFalse: [PlatformClass basicRelease].
	PlatformClass := nil.
	self allSubclassesDo: [:subclass | subclass basicRelease]! !

!EnvironmentFacade class methodsFor: 'exception operations' stamp: ''!
reportException: exception message: message
	self
		reportToConsole: message;
		reportToConsole: exception description newLineCount: 1 tabCount: 1! !

!EnvironmentFacade class methodsFor: 'console operations' stamp: ''!
reportToConsole: message
	"EnvironmentFacade reportToConsole: 'Hello, world'"

	self reportToConsole: message newLineCount: 1! !

!EnvironmentFacade class methodsFor: 'console operations' stamp: ''!
reportToConsole: contextName message: message
	"EnvironmentFacade reportToConsole: 'Hello, world'"

	self reportToConsole: contextName message: message newLineCount: 1! !

!EnvironmentFacade class methodsFor: 'console operations' stamp: ''!
reportToConsole: contextName message: message newLineCount: newLineCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 2"

	self reportToConsole: contextName message: message newLineCount: newLineCount tabCount: 0! !

!EnvironmentFacade class methodsFor: 'console operations' stamp: ''!
reportToConsole: contextName message: message newLineCount: newLineCount tabCount: tabCount
	"EnvironmentFacade reportToConsole: 'Test' message: 'Hello, world' newLineCount: 1 tabCount: 0"
	"EnvironmentFacade reportToConsole: 'Test' message: 'Hello, world' newLineCount: 0 tabCount: 2"

	self current basicReportToConsole: contextName message: message newLineCount: newLineCount tabCount: tabCount! !

!EnvironmentFacade class methodsFor: 'console operations' stamp: ''!
reportToConsole: message newLineCount: newLineCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 2"

	self reportToConsole: message newLineCount: newLineCount tabCount: 0! !

!EnvironmentFacade class methodsFor: 'console operations' stamp: ''!
reportToConsole: message newLineCount: newLineCount tabCount: tabCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 0 tabCount: 2"

	self reportToConsole: 'Passport' message: message newLineCount: newLineCount tabCount: tabCount! !

!EnvironmentFacade class methodsFor: 'namespace operations' stamp: ''!
resolveClassFromFullyQualifiedName: className ifAbsent: ifAbsentBlock
	"Answwer the class whose fully-qualfied (usable anywhere) name is <name>."

	^self globalNamespace at: className ifAbsent: ifAbsentBlock! !

!EnvironmentFacade class methodsFor: 'class binding' stamp: ''!
resourcePathFacadeFactoryReferenceAt: protocolSymbol ifAbsent: ifAbsent
	ResourcePathFacadeFactoryReferences == nil ifTrue: [self initializeResourcePathFacadeFactoryReferences].
	^ResourcePathFacadeFactoryReferences at: protocolSymbol ifAbsent: ifAbsent! !

!EnvironmentFacade class methodsFor: 'image restart' stamp: ''!
sendImageRestartNotificationsToSubscribers
	self current basicSendImageRestartNotificationsToSubscribers! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
setPlatformClass
	"Set the concrete subclass of the reciever whose implmentation is specific to the current Smalltalk platform and usage context."

	"This version of the method assumes that any subclass of the receiver is competent to perform the function requested. If you're porting Passport from one Smalltalk platform to another, this method must be subimplemented by all direct subclasses so that all (direct) subimplementations will correctly set the  PlatformClass to be the subclass of EnvironmentFacade appropriate for the particular version of the Smalltalk environment/platform into which Passport finds itself being loaded when #setPlatformClass is sent to the receiver (or any direct subclass.)  The code to figure out which version of Squeak, or of Dolphin, or or VAST, or of ST/X (etc) on which the code is running is of course specific to each Smalltalk flavor.  Also, how many different subclasses of EnvironmentFacade may be needed in order to handle all the versions of a particular Smalltalk environment, and which specific subclass of EnvironmentFacade is optimal for each version, depends on the platform.  

	As the person doing the port, how far into the past you wish to provide support is up to you.  Support for previous (or future) versions can always be added later."

	self subclasses do: [:any | ^any setPlatformClass]! !

!EnvironmentFacade class methodsFor: 'private' stamp: ''!
setRestartNotificationSubscribers
	RestartNotificationSubscribers := IdentityDictionary new! !

!EnvironmentFacade class methodsFor: 'exception operations' stamp: ''!
signal: anExceptionFactory message: message
	"Using <anExceptionFactory>, raise an exception with the given <message>"

	^self signal: anExceptionFactory message: message contextName: self name! !

!EnvironmentFacade class methodsFor: 'exception operations' stamp: ''!
signal: anExceptionFactory message: message contextName: contextName
	"Using <anExceptionFactory>, raise an exception with the given <message>"

	^self current basicSignal: anExceptionFactory message: message contextName: contextName! !

!EnvironmentFacade class methodsFor: 'exception operations' stamp: ''!
signalError: message
	"Using the general 'Error' exception factory, raise an exception with the given <message>"

	^self signal: Error message: message! !

!EnvironmentFacade class methodsFor: 'image restart' stamp: ''!
subscribe: subscriber forImageRestartNotificationSending: restartNotificationMessage 
	self cancelImageRestartNotificationSubscriptionFor: subscriber.
	self current basicSubscribe: subscriber forImageRestartNotificationSending: restartNotificationMessage! !

!EnvironmentFacade class methodsFor: 'class initialization' stamp: ''!
unregisterForStartupNotification
	"Make it so that whenever the Smalltalk image is restarted after a snapshot, the receiver's 'PlatformClass' will NOT be sent the message #install (nor otherwise notified.)

	NOTE: This method is intended for use by image-based Smalltalk implementations.  It may or may not have any utility in the case of non-image-based Smalltalk systems."

	^self current basicUnregisterForStartupNotification! !

!EnvironmentFacade class methodsFor: 'queries' stamp: ''!
valueOfEnvironmentVariableAt: envVarKey
	"Answer the value of the environment variable whose key (name) is <envVarKey>. If the host system does not support environment variables, then answer nil."

	^''! !

!EnvironmentFacade class methodsFor: 'accessing' stamp: ''!
versionNumber
	"EnvironmentFacade current versionNumber"

	^self subclassResponsibility! !

!Object methodsFor: '*Passport-testing' stamp: 'avi 2/18/2006 17:35'!
isSequenceable
	^ false! !

!Object methodsFor: '*Passport-testing' stamp: 'f 2/25/2006 13:51'!
respondsToArithmetic
	^self isNumber! !

Object subclass: #PassportObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

PassportObject subclass: #ExternalResourceRepository
	instanceVariableNames: 'defaultBroker references aliases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!ExternalResourceRepository class methodsFor: 'instance creation' stamp: ''!
defaultBroker: aResourceBroker 
	^self new defaultBroker: aResourceBroker! !

!ExternalResourceRepository class methodsFor: 'private' stamp: ''!
newReferenceTo: key 
	^LocalResourceReference new key: key! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
aResourceBroker: aResourceBroker
	defaultBroker := aResourceBroker! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
alias: canonicalKey as: aliasingKey 
	| reference |
	canonicalKey = aliasingKey 
		ifFalse: [(aliases at: canonicalKey ifAbsentPut: [IdentitySet new]) add: aliasingKey].
	^(self referenceAt: aliasingKey
		ifNone: 
			[reference := self newReference: canonicalKey.
			^references at: aliasingKey put: reference]) 
				key: canonicalKey! !

!ExternalResourceRepository methodsFor: 'private' stamp: ''!
aliasMap
	^aliases! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
aliasedKeys
	^aliases keys! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
aliasingKeys
	| aliasingKeys |
	aliasingKeys := IdentitySet new.
	aliases do: [:set | aliasingKeys addAll: set].
	^aliasingKeys! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
aliasingKeysOf: canonicalKey
	^(aliases at: canonicalKey ifAbsent: [^IdentitySet new]) copy! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
at: aKey
	^self at: aKey ifAbsent: [self signalError: 'Key not found: ', aKey printString]! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
at: aKey ifAbsent: ifAbsent 
	| reference value | 
	^(self 
		referenceAt: aKey
		ifNone: 
			[reference := self newReference: aKey.
			value := reference valueIfNone: [^ifAbsent value].
			self at: aKey putReference: reference.
			^value]) valueIfNone: ifAbsent! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
at: aKey ifAbsentPut: valueBlock 
	| reference canonicalKey aliasingKeys |
	reference := self referenceAt: aKey ifNone: [^(self referenceAt: aKey) value: valueBlock value].
	canonicalKey := reference key.
	^reference valueIfNoneThenAt: aKey
		put: 
			[aKey = canonicalKey 
				ifFalse: 
					[aliasingKeys := aliases at: canonicalKey ifAbsent: [].
					aliasingKeys == nil ifFalse: [aliasingKeys remove: aKey]].
			valueBlock value]! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
at: aKey put: aValue
	| reference canonicalKey  |
	reference := self referenceAt: aKey.
	canonicalKey := reference key.
	aKey = canonicalKey
		ifTrue: [reference value: aValue]
		ifFalse: 
			[reference key: aKey value: aValue.
			(aliases at: canonicalKey ifAbsent: [^aValue]) remove: aKey].
	^aValue! !

!ExternalResourceRepository methodsFor: 'accessing-references' stamp: ''!
at: aKey putReference: aResourceReference
	| canonicalKey |
	canonicalKey := aResourceReference key.
	aKey = canonicalKey ifFalse: [(aliases at: canonicalKey ifAbsentPut: [IdentitySet new]) add: aKey].
	^references at: aKey put: aResourceReference! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
canonicalKeyAt: aKey ifNone: ifNone

	^(self referenceAt: aKey ifNone: [^ifNone value]) key! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/3/2011 08:42'!
canonicalKeys
	| canonicalKeys |
	canonicalKeys := self keys asOrderedCollection.
	aliases do: [:set | set do: [:aliasingKey | canonicalKeys remove: aliasingKey ifAbsent: []]].
	^canonicalKeys asArray! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
defaultBroker
	^defaultBroker! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
defaultBroker: aResourceBroker
	defaultBroker := aResourceBroker! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
define: aKey 
	^self referenceAt: aKey! !

!ExternalResourceRepository methodsFor: 'enumerating' stamp: ''!
do: block1 
	self referencesDo: [:reference | block1 value: reference value]! !

!ExternalResourceRepository methodsFor: 'testing' stamp: ''!
includesKey: key
	| reference |
	reference := self referenceAt: key ifNone: [^false].
	^reference valueIsDefined! !

!ExternalResourceRepository methodsFor: 'initialize-release' stamp: ''!
initialize
	defaultBroker := self class.
	references := IdentityDictionary new.
	aliases := IdentityDictionary new.! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
keys
	^references keys! !

!ExternalResourceRepository methodsFor: 'enumerating' stamp: ''!
keysAndReferencesDo: block2 
	references keysAndValuesDo: block2! !

!ExternalResourceRepository methodsFor: 'enumerating' stamp: ''!
keysAndValuesDo: block2 
	self keysAndReferencesDo: [:key :reference | block2 value: key value: reference value]! !

!ExternalResourceRepository methodsFor: 'enumerating' stamp: ''!
keysDo: block1 
	references keysDo: block1! !

!ExternalResourceRepository methodsFor: 'private' stamp: ''!
newReference: key
	^self newReference: key mediator: self defaultBroker! !

!ExternalResourceRepository methodsFor: 'private' stamp: ''!
newReference: key mediator: mediator
	^mediator newReferenceTo: key! !

!ExternalResourceRepository methodsFor: 'accessing-references' stamp: ''!
referenceAt: key
	^references at: key ifAbsentPut: [self newReference: key]! !

!ExternalResourceRepository methodsFor: 'accessing-references' stamp: ''!
referenceAt: key ifNone: ifNone
	^references at: key ifAbsent: ifNone! !

!ExternalResourceRepository methodsFor: 'enumerating' stamp: ''!
referencesDo: block1 
	references do: block1! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
removeAliasesOf: canonicalKey 
	| aliasingKeys |
	aliasingKeys := aliases at: canonicalKey ifAbsent: [].
	aliasingKeys == nil
		ifFalse: [aliasingKeys do: [:alias | self removeKey: alias ifAbsent: []]].
	aliases removeKey: canonicalKey ifAbsent: []! !

!ExternalResourceRepository methodsFor: 'removing' stamp: ''!
removeKey: aKey 
	^self removeKey: aKey ifAbsent: [self signalError: 'Key not found: ', aKey printString]! !

!ExternalResourceRepository methodsFor: 'removing' stamp: ''!
removeKey: key ifAbsent: ifNone 
	| reference canonicalKey value |
	reference := self referenceAt: key ifNone: [^ifNone value].
	references removeKey: key.
	canonicalKey := reference key.
	^key = canonicalKey 
		ifTrue: 
			[value := reference removeIfAbsent: [].
			self removeAliasesOf: key.
			value]
		ifFalse: 
			[(aliases at: canonicalKey ifAbsent: [^nil]) remove: key.
			nil].! !

!ExternalResourceRepository methodsFor: 'accessing' stamp: ''!
size
	^references size! !

!ExternalResourceRepository methodsFor: 'actions' stamp: ''!
writeAliasesOn: stream 
	aliases keysAndValuesDo: 
			[:key :aliasSet | 
			stream
				nextPutAll: key;
				nextPut: $:.
			aliasSet do: 
					[:alias | 
					stream
						space;
						nextPutAll: alias].
			stream cr]! !

!ExternalResourceRepository methodsFor: 'actions' stamp: ''!
writeCanonicalKeysOn: stream 
	self canonicalKeys asSortedCollection 
		do: [:key | stream nextPutAll: key; cr]! !

PassportObject subclass: #HttpOperation
	instanceVariableNames: 'cr lf parameterContinuators protocolVersion contentLength contentType parameters value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

HttpOperation class
	instanceVariableNames: 'specialParameters'!

HttpOperation class
	instanceVariableNames: 'specialParameters'!

!HttpOperation class methodsFor: 'class initialization' stamp: 'Alan Lovejoy 4/1/2006 12:09'!
initialize
	specialParameters := nil! !

!HttpOperation class methodsFor: 'class initialization' stamp: ''!
initializeAll
	"HttpOperation initializeAll"
	
	self initialize.
	self subclasses do: [:class | class initializeAll]! !

!HttpOperation class methodsFor: 'private' stamp: ''!
setSpecialParameters

	specialParameters := Dictionary new.
	specialParameters 
		at: 'content-type' put: #contentType:;
		at: 'content-length' put: #contentLength:
		! !

!HttpOperation class methodsFor: 'accessing' stamp: ''!
specialParameters
	specialParameters == nil ifTrue: [self setSpecialParameters].
	^specialParameters! !

!HttpOperation methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:00'!
basicContentLength
	^contentLength! !

!HttpOperation methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:00'!
basicContentType
	^contentLength! !

!HttpOperation methodsFor: 'printing' stamp: 'Alan Lovejoy 4/3/2006 21:20'!
basicPrintParametersOn: stream 
	self
		parametersDo: 
			[:key :pValue | 
				stream 
					nextPutAll: key;
				 	nextPutAll: ': '.
				pValue isString
					ifTrue: [stream nextPutAll: pValue]
					ifFalse: [pValue printOn: stream].
				stream nextPutAll: String crlf]! !

!HttpOperation methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:05'!
basicProtocolVersion
	^protocolVersion! !

!HttpOperation methodsFor: 'accessing' stamp: ''!
contentLength
	^contentLength == nil
		ifTrue: [value == nil ifTrue: [0] ifFalse: [value size]]
		ifFalse: [contentLength]! !

!HttpOperation methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 11:55'!
contentLength: anIntegerOrStringOrNil 
	contentLength := anIntegerOrStringOrNil == nil
		ifFalse: 
			[anIntegerOrStringOrNil isString
				ifTrue: [anIntegerOrStringOrNil asNumber]
				ifFalse: [anIntegerOrStringOrNil]]! !

!HttpOperation methodsFor: 'accessing' stamp: ''!
contentType
	^contentType == nil ifTrue: ['application/octet-stream'] ifFalse: [contentType]! !

!HttpOperation methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 11:55'!
contentType: aString 
	contentType := aString! !

!HttpOperation methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 19:13'!
defaultProtocolVersion
	^'HTTP/1.1'! !

!HttpOperation methodsFor: 'testing' stamp: 'Alan Lovejoy 4/1/2006 12:14'!
hasValue
	^value notNil! !

!HttpOperation methodsFor: 'initialize-release' stamp: ''!
initialize
	cr := Character cr.
	lf := Character lf.
	parameterContinuators := String with: $ with: Character tab.
	protocolVersion := self defaultProtocolVersion.
	contentLength := nil.
	contentType := nil.
	parameters := nil.
	value := nil
	! !

!HttpOperation methodsFor: 'initialize-release' stamp: ''!
initializeFrom: anHttpOperation
	protocolVersion := anHttpOperation basicProtocolVersion.
	parameters := anHttpOperation parameters.
	contentType := anHttpOperation basicContentType.
	contentLength := anHttpOperation basicContentLength.
	value  := anHttpOperation value.
! !

!HttpOperation methodsFor: 'parsing' stamp: ''!
nextParameterLineFrom: stream 
	"Answer a String containing the next line of text from the Stream <stream>. Do not include the end-of-line character(s) in the answered String. Leave the <stream> positioned at the beginning of the next line. Only accept the sequence CR LF as a line separator."

	| lineStream atEnd |
	lineStream := (String new: 89) writeStream.
	atEnd := stream atEnd.
	[atEnd] 
		whileFalse: 
			[(stream peekFor: cr)
				ifTrue: 
					[stream peekFor: lf.
					atEnd := stream atEnd or: [(parameterContinuators includes: stream peek) not]]
				ifFalse:
					[(stream peekFor: lf)
						ifTrue: [atEnd := stream atEnd or: [(parameterContinuators includes: stream peek) not]]
						ifFalse: 
							[lineStream nextPut: stream next.
							atEnd := stream atEnd]]].
	^lineStream contents! !

!HttpOperation methodsFor: 'accessing-parameters' stamp: ''!
parameterAt: canonicalKey ifAbsent: ifAbsent
	parameters == nil ifTrue: [^ifAbsent value].
	^parameters at: canonicalKey ifAbsent: ifAbsent! !

!HttpOperation methodsFor: 'accessing-parameters' stamp: ''!
parameterAt: key put: pValue 
	| canonicalKey special |
	parameters == nil ifTrue: [parameters := Dictionary new].
	canonicalKey := key asLowercase.
	special := self specialParameters at: canonicalKey ifAbsent: [].
	special == nil
		ifTrue: [parameters at: canonicalKey put: pValue]
		ifFalse: [self perform: special with: pValue]! !

!HttpOperation methodsFor: 'accessing-parameters' stamp: ''!
parameters
	^parameters! !

!HttpOperation methodsFor: 'accessing-parameters' stamp: ''!
parameters: aDictionary
	parameters := aDictionary! !

!HttpOperation methodsFor: 'enumerating' stamp: 'Alan Lovejoy 4/1/2006 12:14'!
parametersDo: block2
	parameters == nil 
		ifFalse: [parameters keysAndValuesDo: block2]! !

!HttpOperation methodsFor: 'parsing' stamp: ''!
parseParametersFrom: stream
	| line key |
	[line := self nextParameterLineFrom: stream.
	line isEmpty] 
		whileFalse: 
			[line := line readStream.
			UtilityFunction skipSeparators: line.
			key := line upTo: $:.
			UtilityFunction skipSeparators: line.
			line atEnd ifTrue: [^self signal: HttpError message: 'Incomplete/invalid header received from correspondent'].
			self parameterAt: key put: line upToEnd withBlanksTrimmed].
! !

!HttpOperation methodsFor: 'parsing' stamp: ''!
parseResourceFrom: stream 
	| transferEncoding writeStream size |
	stream peekFor: cr.
	(stream peekFor: lf)
		ifFalse: [stream atEnd ifTrue: [^ self signal: HttpError message: 'Connection closed by correspondent']].

	value := nil.
	transferEncoding := self transferEncoding.
	transferEncoding = 'chunked'
		ifTrue:
			[writeStream := (String new: (4096 max: self contentLength)) writeStream.
			[| number |
			number := UtilityFunction nextFrom: stream while: [:ch | ch isDigit or: [ch asLowercase between: $a and: $f]].
			size := Integer readFrom: number asUppercase readStream base: 16.
			size > 0] whileTrue:
				[UtilityFunction skipToNextLineOf: stream.
				size timesRepeat: 
					[stream atEnd ifTrue: [^ self signal: HttpError message: 'Connection closed by correspondent'].
					writeStream nextPut: stream next]. "Note that `SocketStream>>next:` does not work correctly"
				UtilityFunction skipToNextLineOf: stream.
				stream atEnd ifTrue: [^ self signal: HttpError message: 'Connection closed by correspondent']].
			self parseParametersFrom: stream.
			UtilityFunction skipToNextLineOf: stream.
			value := writeStream contents]
		ifFalse:
			[value := stream upToEnd]
		
! !

!HttpOperation methodsFor: 'parsing' stamp: 'Alan Lovejoy 4/1/2006 18:00'!
parseResourcePathFrom: stream relativeTo: resourcePath
	^ResourcePath 
		from: stream
		defaultProtocol: #relative 
		protocolAndSuffixStreamInto: 
			[:protocol :suffixStream |
			| context facade |
			protocol == #relative
				ifTrue:
					[context := self resourcePathContext copy.
					resourcePath setNonDefaultSpecifiedAttributesAsDefaultsInContext: context.
					facade := context facadeAt: resourcePath protocol]
				ifFalse: [facade := self resourcePathContext facadeAt: protocol].
			facade constructResourcePathFromStream: suffixStream].
! !

!HttpOperation methodsFor: 'printing' stamp: ''!
printParametersOn: stream 
	contentType == nil ifFalse: [stream nextPutAll: 'Content-type: '; nextPutAll: self contentType; nextPutAll: String crlf].
	contentLength == nil ifFalse: [stream nextPutAll: 'Content-length: '; print: self contentLength; nextPutAll: String crlf].
	self basicPrintParametersOn: stream 
! !

!HttpOperation methodsFor: 'printing' stamp: 'Alan Lovejoy 4/1/2006 11:58'!
printResourceOn: stream
	stream nextPutAll: String crlf.
	value == nil ifFalse: [stream nextPutAll: value]! !

!HttpOperation methodsFor: 'accessing' stamp: ''!
protocolVersion
	^protocolVersion == nil ifTrue: ['HTTP/?.?'] ifFalse: [protocolVersion]! !

!HttpOperation methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 12:06'!
protocolVersion: aString
	protocolVersion := aString! !

!HttpOperation methodsFor: 'accessing-parameters' stamp: ''!
removeParameterAt: key
	| canonicalKey special |
	parameters == nil ifTrue: [^self].
	canonicalKey := key asLowercase.
	special := self specialParameters at: canonicalKey ifAbsent: [].
	special == nil
		ifTrue: [parameters removeKey: canonicalKey ifAbsent: []]
		ifFalse: [self perform: special with: nil]! !

!HttpOperation methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:07'!
specialParameters
	^self class specialParameters! !

!HttpOperation methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 12:13'!
transferEncoding
	
	^(self parameterAt: 'transfer-encoding' ifAbsent: [^nil]) asLowercase! !

!HttpOperation methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 17:36'!
transferEncoding: aString
	
	aString == nil
		ifTrue: [self removeParameterAt: 'transfer-encoding']
		ifFalse: [self parameterAt: 'transfer-encoding' put: aString asLowercase]! !

!HttpOperation methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 11:56'!
value
	^value! !

!HttpOperation methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 11:57'!
value: aString
	value := aString! !

HttpOperation subclass: #PPHttpRequest
	instanceVariableNames: 'method resourcePath correspondent acceptableMimeTypes user password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

PPHttpRequest subclass: #HttpClientSideRequest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

!HttpClientSideRequest methodsFor: 'response' stamp: ''!
basicResponseFromServer
	^self correspondent
		connectionStreamDo: 
			[:connectionStream | 
				self printOn: connectionStream.
				self readResponseFrom: connectionStream]! !

!HttpClientSideRequest methodsFor: 'private' stamp: ''!
bindCorrespondent
	proxy == nil
		ifTrue: [correspondent := NetworkCorrespondent hostname: self requestHostname port: self requestPort]
		ifFalse: [correspondent := proxy].! !

!HttpClientSideRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:59'!
correspondent
	correspondent == nil ifTrue: [self bindCorrespondent].
	^correspondent! !

!HttpClientSideRequest methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	proxy := nil.
! !

!HttpClientSideRequest methodsFor: 'initialize-release' stamp: ''!
initializeFrom: anHttpRequest
	super initializeFrom: anHttpRequest.
	self proxy: anHttpRequest proxy.
! !

!HttpClientSideRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 18:58'!
invalidateCorrespondent
	correspondent := nil! !

!HttpClientSideRequest methodsFor: 'testing' stamp: 'Alan Lovejoy 4/1/2006 18:47'!
isUsingProxy
	^proxy notNil! !

!HttpClientSideRequest methodsFor: 'private' stamp: 'ALL 7/9/2006 21:37'!
newResponse
	^PPHttpResponse to: self! !

!HttpClientSideRequest methodsFor: 'printing' stamp: 'Alan Lovejoy 4/1/2006 18:53'!
printAuthorizationOn: stream
	user == nil ifTrue: [^self].
	stream 
		nextPut: 'Authorization: Basic ';
		nextPutAll: (Authorizer new encode: user password: (password == nil ifTrue: [''] ifFalse: [password]));
		nextPutAll: String crlf! !

!HttpClientSideRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:44'!
proxy
	^proxy! !

!HttpClientSideRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:44'!
proxy: anInternetService
	proxy := anInternetService.
	self invalidateCorrespondent! !

!HttpClientSideRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:44'!
proxyServerName
	^proxy == nil ifFalse: [proxy hostname]! !

!HttpClientSideRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:45'!
proxyServerPort
	^proxy == nil ifFalse: [proxy port]! !

!HttpClientSideRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 20:56'!
readResponseFrom: connectionStream
	^self readResponseHeaderFrom: connectionStream! !

!HttpClientSideRequest methodsFor: 'private' stamp: ''!
readResponseHeaderFrom: connectionStream
	| response |
	response := self newResponse.
	[response parseHeaderFrom: connectionStream.
	response isContinue] whileTrue.
	^response! !

!HttpClientSideRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:58'!
resourcePath: aResourcePath
	super resourcePath: aResourcePath.
	self invalidateCorrespondent! !

!HttpClientSideRequest methodsFor: 'response' stamp: ''!
responseFromServer
	| response effectiveRequest pathSet |
	response := self basicResponseFromServer.
	effectiveRequest := self.
	[response requiresRedirection] 
		whileTrue: 
			[pathSet == nil ifTrue: [pathSet := Set new].
			pathSet add: effectiveRequest resourcePath.
			effectiveRequest := response asRedirectedRequest.
			(pathSet includes: effectiveRequest resourcePath)
				ifTrue: [^self signal: HttpError message: 'Recursive redirection detected']
				ifFalse: [response := effectiveRequest responseFromServer]].
	^response! !

HttpClientSideRequest subclass: #HttpHeadRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

!HttpHeadRequest methodsFor: 'converting' stamp: 'Alan Lovejoy 3/31/2006 20:55'!
asRedirectedToOther
	^self copy! !

!HttpHeadRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:23'!
canonicalMethod
	^'HEAD'! !

!HttpHeadRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:37'!
defaultAcceptableMimeTypes
	^nil! !

!HttpHeadRequest methodsFor: 'testing' stamp: 'Alan Lovejoy 3/31/2006 20:51'!
isHeadRequest
	^true! !

HttpClientSideRequest subclass: #HttpPutRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

!HttpPutRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:23'!
canonicalMethod
	^'PUT'! !

!HttpPutRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:37'!
defaultAcceptableMimeTypes
	^nil! !

!HttpPutRequest methodsFor: 'testing' stamp: 'Alan Lovejoy 4/1/2006 02:24'!
isPutRequest
	^true! !

!HttpPutRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 22:36'!
readResponseFrom: connectionStream
	| response |
	response := super readResponseFrom: connectionStream.
	response isError ifTrue: [response signalError].
	^response! !

HttpClientSideRequest subclass: #HttpResourceRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

HttpResourceRequest subclass: #HttpGetRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

!HttpGetRequest methodsFor: 'converting' stamp: ''!
asGetRequest
	^self copy! !

!HttpGetRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:24'!
canonicalMethod
	^'GET'! !

!HttpGetRequest methodsFor: 'testing' stamp: 'Alan Lovejoy 3/31/2006 20:51'!
isGetRequest
	^true! !

HttpResourceRequest subclass: #HttpPostRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

!HttpPostRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:24'!
canonicalMethod
	^'PUT'! !

!HttpPostRequest methodsFor: 'testing' stamp: 'Alan Lovejoy 4/1/2006 02:23'!
isPostRequest
	^true! !

!HttpResourceRequest methodsFor: 'private' stamp: ''!
readResponseFrom: connectionStream
	| response |
	response := super readResponseFrom: connectionStream.
	response isError ifTrue: [response signalError].
	response isSuccessful ifTrue: [response parseResourceFrom: connectionStream].
	^response! !

PPHttpRequest subclass: #HttpServerSideRequest
	instanceVariableNames: 'baseResourcePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

!HttpServerSideRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:17'!
baseResourcePath
	^baseResourcePath! !

!HttpServerSideRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:18'!
baseResourcePath: aResourcePath
	baseResourcePath := aResourcePath.
! !

!HttpServerSideRequest methodsFor: 'accessing' stamp: ''!
corrspondent: aNetworkCorrespondent
	correspondent := aNetworkCorrespondent! !

!HttpServerSideRequest methodsFor: 'accessing' stamp: ''!
defaultResourcePathContext
	^self baseResourcePath resourcePathContext! !

!HttpServerSideRequest methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	baseResourcePath := ResourcePath fromString: '/' withContext: self defaultResourcePathContext 
! !

!HttpServerSideRequest methodsFor: 'initialize-release' stamp: ''!
initializeFrom: anHttpRequest
	super initializeFrom: anHttpRequest.
	self baseResourcePath: anHttpRequest baseResourcePath

! !

!HttpServerSideRequest methodsFor: 'parsing' stamp: ''!
parseHeaderFrom: stream 
	self parseMethodLineFrom: stream.
	parameters := nil.
	self parseParametersFrom: stream! !

!HttpServerSideRequest methodsFor: 'parsing' stamp: ''!
parseMethodLineFrom: stream
	stream atEnd ifTrue: [^self signal: HttpError message: 'Connection closed by correspondent'].
	self method: (UtilityFunction nextFrom: stream until: [:ch | ch isSeparator]).
	UtilityFunction skipSeparators: stream.
	stream atEnd ifTrue: [^self signal: HttpError message: 'Connection closed by correspondent'].
	self resourcePath: (self parseResourcePathFrom: stream relativeTo: self baseResourcePath).
	UtilityFunction skipSeparators: stream.
	stream atEnd ifTrue: [^self signal: HttpError message: 'Connection closed by correspondent'].
	self protocolVersion: (UtilityFunction nextFrom: stream until: [:ch | ch isSeparator]).
	UtilityFunction skipToNextLineOf: stream
! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
acceptableMimeTypes
	^acceptableMimeTypes == nil ifTrue: [#('*/*')] ifFalse: [acceptableMimeTypes]! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 12:33'!
acceptableMimeTypes: aSetOfStrings
	acceptableMimeTypes := aSetOfStrings == nil ifTrue: [#('*/*')] ifFalse: [aSetOfStrings]! !

!PPHttpRequest methodsFor: 'converting' stamp: ''!
asGetRequest
	^HttpGetRequest new initializeFrom: self! !

!PPHttpRequest methodsFor: 'converting' stamp: 'Alan Lovejoy 4/1/2006 02:20'!
asRedirected
	^self copy! !

!PPHttpRequest methodsFor: 'converting' stamp: 'Alan Lovejoy 3/31/2006 20:54'!
asRedirectedToOther
	^self asGetRequest! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:20'!
baseResourcePath
	^self resourcePath! !

!PPHttpRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:23'!
canonicalMethod
	^nil! !

!PPHttpRequest methodsFor: 'testing' stamp: 'Alan Lovejoy 4/1/2006 19:09'!
connectionClosedOnlyWhenExplicitlyRequested
	^self protocolVersion ~= 'HTTP/1.0'! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
correspondent
	^correspondent! !

!PPHttpRequest methodsFor: 'private' stamp: 'Alan Lovejoy 4/1/2006 12:36'!
defaultAcceptableMimeTypes
	^#('*/*')! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
defaultResourcePathContext
	^ResourcePathContext default! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
hostname
	^self correspondent hostname! !

!PPHttpRequest methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	self setMethod.
	resourcePath := nil.
	correspondent := nil.
	acceptableMimeTypes := self defaultAcceptableMimeTypes.
	user := nil.
	password := nil.

! !

!PPHttpRequest methodsFor: 'initialize-release' stamp: ''!
initializeFrom: anHttpRequest
	super initializeFrom: anHttpRequest.
	self canonicalMethod == nil ifTrue: [method := anHttpRequest method].
	self resourcePath: anHttpRequest resourcePath.
	self acceptableMimeTypes: anHttpRequest acceptableMimeTypes.
	self user: anHttpRequest user.
	self password: anHttpRequest password.

! !

!PPHttpRequest methodsFor: 'testing' stamp: ''!
isGetRequest
	^self method = 'GET'! !

!PPHttpRequest methodsFor: 'testing' stamp: ''!
isHeadRequest
	^self method = 'HEAD'! !

!PPHttpRequest methodsFor: 'testing' stamp: ''!
isPostRequest
	^self method = 'POST'! !

!PPHttpRequest methodsFor: 'testing' stamp: ''!
isPutRequest
	^self method = 'PUT'! !

!PPHttpRequest methodsFor: 'testing' stamp: 'Alan Lovejoy 4/2/2006 13:00'!
isUsingProxy
	^false! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
method
	^method! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
method: aString
	method == nil ifFalse: [self canonicalMethod == nil ifFalse: [self signalError: 'The method of the receiver cannot be changed']].
	method := aString! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:55'!
password
	^password! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:55'!
password: aString
	password := aString! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
port
	^self correspondent port! !

!PPHttpRequest methodsFor: 'printing' stamp: ''!
printAcceptableMimeTypeHeadersOn: stream
	acceptableMimeTypes == nil ifTrue: [^self].
	acceptableMimeTypes do: [:mimeType | stream nextPutAll: 'ACCEPT: '; nextPutAll: mimeType; nextPutAll: String crlf]! !

!PPHttpRequest methodsFor: 'printing' stamp: ''!
printAuthorizationOn: stream
	user == nil ifTrue: [^self].
	stream 
		nextPut: 'Authorization: Basic ';
		nextPutAll: (Authorizer new encode: user password: (password == nil ifTrue: [''] ifFalse: [password]));
		nextPutAll: String crlf! !

!PPHttpRequest methodsFor: 'printing' stamp: ''!
printHostHeaderOn: stream
	stream 
		nextPutAll: 'Host: ';
		nextPutAll: self requestHostname.
	resourcePath hasDefaultPort 
		ifFalse:
			[stream
				nextPut: $:;
				print: self requestPort].
	stream nextPutAll: String crlf
	! !

!PPHttpRequest methodsFor: 'printing' stamp: ''!
printMethodLineOn: stream
	stream
		nextPutAll: self method;
		space.
	self printRequestPathOn: stream.
	stream
		space;
		nextPutAll: self protocolVersion;
		nextPutAll: String crlf! !

!PPHttpRequest methodsFor: 'printing' stamp: ''!
printOn: stream
	self printMethodLineOn: stream.
	self printAuthorizationOn: stream.
	self printUserAgentHeaderOn: stream.
	self printAcceptableMimeTypeHeadersOn: stream.
	self printHostHeaderOn: stream.
	self printParametersOn: stream.
	stream nextPutAll: String crlf.
	self printResourceOn: stream.
	stream flush! !

!PPHttpRequest methodsFor: 'printing' stamp: ''!
printParametersOn: stream 
	super printParametersOn: stream.
	self connectionClosedOnlyWhenExplicitlyRequested 
		ifTrue: [stream nextPutAll: 'Connection: close'; nextPutAll: String crlf]! !

!PPHttpRequest methodsFor: 'printing' stamp: ''!
printRequestPathOn: stream 
	self isUsingProxy
		ifTrue: [resourcePath printOn: stream]
		ifFalse: 
			[resourcePath printNamespaceAndPathnameOn: stream.
			resourcePath hasQuery
				ifTrue: 
					[stream 
						nextPut: $?;
						nextPutAll: resourcePath queryString]]
	! !

!PPHttpRequest methodsFor: 'printing' stamp: 'Alan Lovejoy 4/1/2006 02:25'!
printResourceOn: stream
	"By default, do nothing"! !

!PPHttpRequest methodsFor: 'printing' stamp: ''!
printUserAgentHeaderOn: stream
	stream 
		nextPutAll: HTTPSocket userAgentString;
		nextPutAll: String crlf! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:45'!
proxy
	^nil! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:26'!
requestHostname
	^resourcePath hostname! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
requestPath
	| path |
	path := resourcePath pathname printString.
	^ resourcePath hasQuery
		ifTrue: [path , '?' , resourcePath queryString]
		ifFalse: [path size = 0
					ifTrue: ['/']
					ifFalse: [path]]! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:26'!
requestPort
	^resourcePath port! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/30/2006 20:17'!
resourcePath
	^resourcePath! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
resourcePath: aResourcePath
	resourcePath := aResourcePath.
! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
resourcePathContext
	^resourcePath == nil ifTrue: [self defaultResourcePathContext] ifFalse: [resourcePath resourcePathContext]! !

!PPHttpRequest methodsFor: 'accessing' stamp: ''!
resourcePathFacade
	^resourcePath == nil ifTrue: [self resourcePathContext facadeAt: #http] ifFalse: [resourcePath resourcePathFacade]! !

!PPHttpRequest methodsFor: 'private' stamp: ''!
setMethod
	method := self canonicalMethod! !

!PPHttpRequest methodsFor: 'private' stamp: ''!
specialParameters
	^self class specialParameters! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:55'!
user
	^user! !

!PPHttpRequest methodsFor: 'accessing' stamp: 'Alan Lovejoy 4/1/2006 18:55'!
user: aString
	user := aString! !

HttpOperation subclass: #PPHttpResponse
	instanceVariableNames: 'request statusCode statusReason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Http-Squeak'!

!PPHttpResponse class methodsFor: 'instance creation' stamp: ''!
to: anHttpRequest 
	^ self new request: anHttpRequest! !

!PPHttpResponse methodsFor: 'converting' stamp: ''!
asMimeDocument
	^ MIMEDocument
		contentType: 
			(self contentType = MIMEDocument defaultContentType
				ifTrue: [MIMEDocument guessTypeFromName: self resourcePath suffixString]
				ifFalse: [self contentType])
		content: self value
		url: self resourcePath printString! !

!PPHttpResponse methodsFor: 'converting' stamp: ''!
asRedirectedRequest
	| redirectionUrl redirectionPath redirectedRequest |
	redirectionUrl := self parameterAt: 'location' ifAbsent: [^self signal: HttpError message: 'Invalid redirection -- redirection URL not specified (expected header parameter=Location:)'].
	redirectionPath := self parseResourcePathFrom: redirectionUrl readStream relativeTo: self resourcePath.
	redirectedRequest := self statusCode = 303 
		ifTrue: [self request asRedirectedToOther] 
		ifFalse: [self request asRedirected].
	self statusCode = 305
		ifTrue: [redirectedRequest proxy: (NetworkCorrespondent hostname: redirectionPath hostname port: redirectionPath port)] 
		ifFalse: [redirectedRequest resourcePath: redirectionPath].
	^redirectedRequest
	! !

!PPHttpResponse methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	request = nil.
	statusCode := nil.
	statusReason := nil.
	! !

!PPHttpResponse methodsFor: 'initialize-release' stamp: ''!
initializeFrom: anHttpResponse
	super initializeFrom: anHttpResponse.
	request := anHttpResponse request.
	statusCode := anHttpResponse statusCode.
	statusReason := anHttpResponse statusReason.! !

!PPHttpResponse methodsFor: 'testing' stamp: ''!
isClientError
	^self statusCode between: 400 and: 499! !

!PPHttpResponse methodsFor: 'testing' stamp: 'Alan Lovejoy 3/31/2006 22:12'!
isContinue
	^self statusCode = 101! !

!PPHttpResponse methodsFor: 'testing' stamp: ''!
isError
	^self statusCode between: 400 and: 599! !

!PPHttpResponse methodsFor: 'testing' stamp: ''!
isInformational
	^self statusCode between: 100 and: 199! !

!PPHttpResponse methodsFor: 'testing' stamp: ''!
isServerError
	^self statusCode between: 500 and: 599! !

!PPHttpResponse methodsFor: 'testing' stamp: ''!
isSuccessful
	^self statusCode between: 200 and: 299! !

!PPHttpResponse methodsFor: 'parsing' stamp: ''!
parseHeaderFrom: stream 
	self parseStatusLineFrom: stream.
	self isError
		ifFalse: 
			[parameters := nil.
			self parseParametersFrom: stream]! !

!PPHttpResponse methodsFor: 'parsing' stamp: ''!
parseStatusLineFrom: stream
	stream atEnd ifTrue: [^self signal: HttpError message: 'Connection closed by correspondent'].
	self protocolVersion: (UtilityFunction nextFrom: stream until: [:ch | ch isSeparator]).
	UtilityFunction skipSeparators: stream.
	stream atEnd ifTrue: [^self signal: HttpError message: 'Connection closed by correspondent'].
	self statusCode: (UtilityFunction nextFrom: stream until: [:ch | ch isSeparator]) asNumber.
	UtilityFunction skipSeparators: stream.
	stream atEnd ifTrue: [^self signal: HttpError message: 'Connection closed by correspondent'].
	self statusReason: (UtilityFunction nextFrom: stream until: [:ch | ch isSeparator]).
	UtilityFunction skipToNextLineOf: stream
	
	


	
	
! !

!PPHttpResponse methodsFor: 'printing' stamp: ''!
printOn: stream
	self printStatusLineOn: stream.
	self printParametersOn: stream.
	stream nextPutAll: String crlf.
	self printResourceOn: stream! !

!PPHttpResponse methodsFor: 'printing' stamp: ''!
printResourceOn: stream
	value == nil ifFalse: [stream nextPutAll: value].
	stream nextPutAll: String crlf! !

!PPHttpResponse methodsFor: 'printing' stamp: ''!
printStatusLineOn: stream
	stream 
		nextPutAll: self protocolVersion;
		space;
		print: self statusCode;
		space;
		nextPutAll: self statusReason;
		nextPutAll: String crlf.
		! !

!PPHttpResponse methodsFor: 'accessing' stamp: ''!
protocolVersion
	^protocolVersion == nil ifTrue: [request == nil ifTrue: ['HTTP/?.?'] ifFalse: [request protocolVersion]] ifFalse: [protocolVersion]! !

!PPHttpResponse methodsFor: 'resource stream creation' stamp: 'Alan Lovejoy 4/1/2006 22:32'!
readStream
	^self value readStream! !

!PPHttpResponse methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/31/2006 00:01'!
request
	^request! !

!PPHttpResponse methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/31/2006 00:02'!
request: anHttpRequest
	request := anHttpRequest! !

!PPHttpResponse methodsFor: 'testing' stamp: ''!
requiresRedirection
	^self statusCode between: 300 and: 399! !

!PPHttpResponse methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/31/2006 22:34'!
resourcePath
	^self request resourcePath! !

!PPHttpResponse methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/31/2006 22:35'!
resourcePathContext
	^self request resourcePathContext! !

!PPHttpResponse methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/31/2006 22:36'!
resourcePathFacade
	^self request resourcePathFacade! !

!PPHttpResponse methodsFor: 'error signalling' stamp: ''!
signalError
	^HttpError signal: self statusReason responseCode: self statusCode! !

!PPHttpResponse methodsFor: 'private' stamp: ''!
specialParameters
	^self class specialParameters! !

!PPHttpResponse methodsFor: 'accessing' stamp: ''!
statusCode
	^statusCode == nil ifTrue: [0] ifFalse: [statusCode]! !

!PPHttpResponse methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/31/2006 00:31'!
statusCode: anHTTPStatusCodeNumber
	statusCode := anHTTPStatusCodeNumber! !

!PPHttpResponse methodsFor: 'accessing' stamp: ''!
statusReason
	^statusReason == nil ifTrue: ['unknown'] ifFalse: [statusReason]! !

!PPHttpResponse methodsFor: 'accessing' stamp: 'Alan Lovejoy 3/31/2006 00:31'!
statusReason: aString
	statusReason := aString! !

PassportObject subclass: #Immutable
	instanceVariableNames: 'lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!Immutable commentStamp: '<historical>' prior: 0!
Immutable

	Concept:

		Immutable is an abstract class whose concrete subclasses will have instances that can become immutable.  

		When an object is immutable, its attributes/properties cannot be changed. In other words, the value of an immutable object is invariant: it must always be value-equal to the same thing.  HOWEVER, the instance variables of an instance of Immutable that has been made immutable may, in some situations, change the values they contain--although that should only occur when it would not result in any change to the value (public attributes/proprerties) of the object. In other words, the immutability exhibited by an immutable instance of Immutable constrains its externally-visible, "black box," encapsulated public behavior, and does not constrain its internal, private mechanisms. 

	Usage:

		Because Smalltalk has no way to atomically create an instance of a class that also initializes the attributes of the instance to arbitrary values as specified in the parameters of an instance creation message, the instance creation API of Immutable must provide at least one instance creation message that results in a **mutable** instance of an Immutable.  Consequently, the class message #basicNew must result in a new **mutable** instance of Immutable. The class message #new should also result in a new **mutable** instance, unless it is appropriate to fulliy initialize an instance to its final canonical state simply by sending the message #initialize to the instance (this condition is normally satisfied only by singletons (or objects that logically could be singletons.))

		To instantiate and initialize an **immutable** instance of Immutable, it is necessary to first create a mutable instance of Immutable, send initialization messages to the instance, and only then make the instance immutable. Typically, instance creation messages other than #new and #basicNew would be implemented to do just that. 

		An instance of Immutable should be created and initialized in some "private" scope, such that only the creator has a reference to the object. It should be made immutable before it is "published" or "exported" outside the private scope of its creator.

		Since mutational methods must be provided in the API of an Immutable (so that newly-created instances can be initialized before being made immutable,) immutability cannot be implemented simply by not providing mutational instance messages.  Therefore, to implement immutability, when a mutational message is sent to an immutable instance of Immutable, an exception must be raised, and the value of the receiver must remain unchanged.

		To determine the mutability status of an instance of Immutable, the messages #isMutable and #isImmutable may be sent to the instance.

		To make an instance of Immutable immutable, send it the message #beImmutable.  This message is idempotent (i.e., sending it to an instance that is already immutable is a no-op.)

		It is required that a copy of an Immutable (obtained by sending the ANSI-standard message #copy to an instance) have the same value as the original, and it is also required that the copy be **mutable**.  To get a mutable version of an Immutable, such that a copy is only created if the original is immutable, send the message #asMutable.  To get an immutable version of an Immutable, such that the original's status will not be changed from mutable to immutable, send the message #asImmutable.

	Motivation:
		
		There are two essential benefits to having objects that can become immutable:

			1. Immutable objects provide an invariant of fundamental importance--their value cannot change. Value-invariant objects can safely be used as the value of an attributive reference. An attributive reference is one where the semantics of the reference is defined by the value of the referenced object, and not by its identity. In contrast, an associative reference is one where the semantics of the reference is defined by the identity of the referenced object, and not by its value.  For example, a Set points to its elements using an attributive reference, whereas an IdentitySet points to its elements using an associative reference. When the value of an attributive reference is a mutable object, there is always the danger that a change in the value (attributes, properties, state) of the referenced object will have undesired and/or unexpected side effects.  Typically, programs and programmers either ignore this danger (which can lead to obscure bugs that are hard to diagnose,) or else spend considerable effort trying to either prevent or otherwise deal with such mutations. So immutability either significantly simplifies the logic for managing attributive references to objects, and/or eliminates a common source of logic errors.

			2. Because instances of Immutable must initially be mutable, but can then become immutable, their lifecycle has two stages.  Mutational operations are limited to the mutable stage of the lifecycle.  The typical usage pattern would be to create a vanilla instance, initialize it as desired, and then make it immutable. Consequently, it is both natural and extremely advantageous to not require that mutable instances conform to or satisfy the same constraints involving the values of their instance variables as would be applied to immutable instances. In other words, it is not necessary to require that mutable instances of Immutable be continuously kept in canonical form, or have valid internal state. Instead, the distinction between mutable and immutable serves quite well to also distinguish between objects where there is no requirement or guarantee that they be in canonical form from those where canonical/valid internal state must be guaranteed. This follows from the fact that the sole purpose of the mutable state of the lifecycle is initialization of the object. One benefit of immutability, then, is that the logic of mutational methods can be simplified--sometimes quite significantly--because they can be implemented as initializations that don't need to worry (as much or at all) about canonical form and/or the validity of internal state, instead of being implemented as "in flight" mutations where rigorous inter-variable validity and/or canonical form must be maintained at all times.

	Implementation:

		Instance Variables

		lock	<Symbol | nil>	Indicates whether the object is immutable: if nil, the object is mutable, otherwise it's immutable.

	Subclassing:

		Since it is not permitted to change the value represented by an instance of Immutable once it has been made immutable, it may be necessary to set one or more of the instance variables of an Immutable to some canonical, default or derived value before the object is made immutable (in order to avoid a situation where an immutable object is not in a valid state.)  To accomplish this, subclasses should subimplement the method #canonicalize.  The message #canonicalize will be sent to an instance just before it is made immutable.

		If a subclass implements any instance method that mutates any instance variable whose value establishes the value (attributes/properties) of an instance, then said subclass must ensure that the value of any such value-defining instance variable is never changed once an instance has been made immutable.  To aid in this, Immutable defines the method #assertMutability, which will raise an exception if sent to an immutable instance of Immutable. It is recommended that mutational methods invoke 'self assertMutatibility' before actually mutating the value of an instance.

		To distinguish the mutational methods of an Immutable from those of an alyways-mutable object, a different naming convention should be used for "setter" methods than is standard Smalltalk practice.  The standard Smalltalk convention is to name a method that sets the attribute "foo" #foo: (where the new value of the "foo" attribute is the argument.)  For an Immutable, the convention used by the Chronos codebase is that the method that sets the value of the "foo" attribute should be named #setFoo:--and such methods must answer the receiver.  Additionally, a method named #foo: may optionally also be provided, but the semantics of setter methods named in that style are as follows: If the receiver is currently mutable, then sending either #foo: or #setFoo: should have exactly the same effects; however, if the receiver is currently immutable, then sending #setFoo: should result in a "modification not permitted" exception, and sending #foo: should result in a new copy of the receiver being created and answered whose "foo" attribute has been set to the value of the argument (leaving the receiver unchanged.)
		

		
	

	

	



!

!Immutable methodsFor: 'converting' stamp: ''!
asImmutable
	^self isMutable 
		ifTrue: [self copy beImmutable]
		ifFalse: [self]! !

!Immutable methodsFor: 'converting' stamp: ''!
asMutable
	^self isMutable 
		ifTrue: [self]
		ifFalse: [self copy]! !

!Immutable methodsFor: 'private' stamp: ''!
assertMutability
	lock == nil ifFalse: [self signalMutationException]! !

!Immutable methodsFor: 'initialize-release' stamp: ''!
beImmutable
	"Make the receiver immutable.  Idempotent.  Must answer the receiver."

	lock == nil 
		ifTrue: 
			[self canonicalize.
			lock := #immutable]! !

!Immutable methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	"By default, do nothing"! !

!Immutable methodsFor: 'copying' stamp: 'PaulDeBruicker 03/04/2011 14:10'!
copy
	"Answer a copy of the receiver which 1) is mutable,  2) compares (#=) as equal to the receiver, and 3) satisfies the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the behavior of the copy it answers in response to this message will not be changed, and b) whenever the copy answered by the receiver in response to this message mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the behavior of the receiver will not be changed.  An associative reference is one where the semantics of the reference are defined by the object identity (#==) of the referenced object.  An attributive reference is one where the semantics of the reference are defined by the value (#=) of the referenced object."

	"Subclasses should override this message for only one reason: to raise a 'NotCopyable' exception.  To change the behavior of #copy, subimplment #postCopy."


	^self shallowCopy postCopy! !

!Immutable methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	self assertMutability.! !

!Immutable methodsFor: 'testing' stamp: ''!
isImmutable
	^lock ~~ nil! !

!Immutable methodsFor: 'private' stamp: ''!
isImmutable: aBoolean
	"Prevent VW from making me immutable at the VM level, because that's much too strict and draconian."

	aBoolean ifTrue: [self beImmutable]

	"I can't become mutable--and I'm always mutable in the VW sense, anyway."! !

!Immutable methodsFor: 'testing' stamp: ''!
isMutable
	^lock == nil! !

!Immutable methodsFor: 'private' stamp: ''!
nilFields
	"Store nil into all pointer fields of the receiver."

	EnvironmentFacade current makeMutable: self.
	super nilFields! !

!Immutable methodsFor: 'private' stamp: ''!
postCopy
	"PRECONDTION: The receiver has just been instantiated as a #shallowCopy of another object.  
	POSTCONDITION: In response to this message, the receiver is required to make itself satisfy the following conditions and constraints: 1) It must be mutable,  2) It must compare (#=) as equal to the object from which it was shallowCopied, and 3) It must satisfy the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the object from which it was shallowCopied must not be changed, and b) whenever the object from which the receiver was shallowCopied mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the receiver must not be changed.  An associative reference is one where the semantics of the reference depend in any way on the object identity (#==) of the referenced object.  An attributive reference is one where any referenced object with the same value can transparently be substituted for any other such value-equivalent object without causing any error."

	"Subclasses may need to subimplement this message in order to satisfy the required semantics.  All subimplementers should send #postCopy to super."

	lock := nil.
	EnvironmentFacade current makeMutable: self! !

!Immutable methodsFor: 'error signalling' stamp: ''!
signalMutationException
	^self signal: Error message: 'Attempt to mutate an immutable instance'! !

Immutable subclass: #PassportMagnitude
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
< aMagnitude 
	"Answer whether the receiver is less than the argument."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison < 0]! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
<= otherMagnitude 
	"Answer whether the receiver is less than or equal to the argument."

	^(self > otherMagnitude) not! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
= otherMagnitude
	self == otherMagnitude ifTrue: [^true].
	^(self compareTo: otherMagnitude) = 0! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
> aMagnitude 
	"Answer whether the receiver is greater than the argument."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison > 0]! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
>= otherMagnitude 
	"Answer whether the receiver is greater than or equal to the argument."

	^(self < otherMagnitude) not! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
between: min and: max 
	"Answer whether the receiver is less than or equal to the argument, max,
	and greater than or equal to the argument, min."

	^self >= min and: [self <= max]! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
compareTo: otherMagnitude
	"Compare the value of the receiver to that of <otherMagnitude>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <otherMagnitude> are the same.)"

	^self subclassResponsibility! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
hash
	"Answer a SmallInteger that is equal to the hash value of any object that is equal to (=) the receiver. 
	When two objects are not =, their hash values may or may not be the same.
	The hash value may change whenever any attribute of the receiver changes."

	^self subclassResponsibility! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
max: otherMagnitude 
	"Answer the receiver or the argument, whichever has the greater magnitude."

	self > otherMagnitude
		ifTrue: [^self]
		ifFalse: [^otherMagnitude]! !

!PassportMagnitude methodsFor: 'comparing' stamp: ''!
min: otherMagnitude 
	"Answer the receiver or the argument, whichever has the lesser magnitude."

	self < otherMagnitude
		ifTrue: [^self]
		ifFalse: [^otherMagnitude]! !

PassportMagnitude subclass: #PassportNotAMetanumber
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Magnitude-Numbers'!

!PassportNotAMetanumber class methodsFor: 'instance creation' stamp: 'Chronos 1/14/2007 11:10'!
new
	^self shouldNotImplement! !

!PassportNotAMetanumber class methodsFor: 'instance creation' stamp: 'Chronos 1/14/2007 11:10'!
value: aNumber
	^self basicNew
		setValue: aNumber;
		beImmutable! !

!PassportNotAMetanumber methodsFor: 'arithmetic' stamp: 'Chronos 1/14/2007 19:09'!
* aMetanuber
	^aMetanuber multipliedByNotAMetanumber: value! !

!PassportNotAMetanumber methodsFor: 'arithmetic' stamp: 'Chronos 1/14/2007 19:09'!
+ aMetanuber
	^aMetanuber addedToNotAMetanumber: value! !

!PassportNotAMetanumber methodsFor: 'arithmetic' stamp: 'Chronos 1/14/2007 19:09'!
- aMetanuber
	^aMetanuber subtractedFromNotAMetanumber: value! !

!PassportNotAMetanumber methodsFor: 'arithmetic' stamp: 'Chronos 1/14/2007 19:08'!
/ aMetanuber
	^aMetanuber divisionOfNotAMetanumber: value! !

!PassportNotAMetanumber methodsFor: 'comparing' stamp: 'Chronos 1/14/2007 11:59'!
compareTo: otherMagnitude
	"Compare the value of the receiver to that of <otherMagnitude>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <otherMagnitude> are the same.)"

	self == otherMagnitude ifTrue: [^0].
	^[otherMagnitude compareToNotAMetanumber: value]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == otherMagnitude and: [ex message selector == #compareToNotAMetanumber:])
					ifTrue: [ex return: (value > otherMagnitude ifTrue: [1] ifFalse: [value < otherMagnitude ifTrue: [-1] ifFalse: [0]])]
					ifFalse: [ex pass]]! !

!PassportNotAMetanumber methodsFor: 'private-comparing' stamp: 'Chronos 1/14/2007 11:59'!
compareToNotAMetanumber: notAMetanumber
	^value - notAMetanumber! !

!PassportNotAMetanumber methodsFor: 'comparing' stamp: 'Chronos 1/14/2007 11:33'!
hash
	"Answer a SmallInteger that is equal to the hash value of any object that is equal to (=) the receiver. 
	When two objects are not =, their hash values may or may not be the same.
	The hash value may change whenever any attribute of the receiver changes."

	^value hash! !

!PassportNotAMetanumber methodsFor: 'testing' stamp: 'Chronos 1/14/2007 11:24'!
isZero
	^value isZero! !

!PassportNotAMetanumber methodsFor: 'testing' stamp: 'Chronos 1/14/2007 11:24'!
negative
	^value negative! !

!PassportNotAMetanumber methodsFor: 'testing' stamp: 'Chronos 1/14/2007 11:24'!
positive
	^value positive! !

!PassportNotAMetanumber methodsFor: 'initialize-release' stamp: 'Chronos 1/14/2007 11:09'!
setValue: aNumber
	self assertMutability.
	value := aNumber! !

!PassportNotAMetanumber methodsFor: 'accessing' stamp: 'Chronos 1/14/2007 11:09'!
value
	^value! !

PassportMagnitude subclass: #Pathname
	instanceVariableNames: 'components'
	classVariableNames: 'Empty'
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!Pathname commentStamp: '<historical>' prior: 0!
Pathname

	Concept:
		
		A pathname is a hierarchical key referencing some value in a hierarchy of namespaces.  Mathematically, it is an N-tuple of N keys whose sequence specifies a dereferencing path through a lattice of namespaces.  Specifically, given the namespaces Root, Alpha and Beta, where Root is the pre-agreed starting point for dereferencing keys in a particular context, where Alpha is a namespace defined in Root, where Beta is a namespace defined in Alpha, and where gamma is some value defined in Beta, then the pathname (Alpha, Beta, gamma) is a 3-tuple hierarchical key (or pathname) that specifies the value that results from using Root to dereference Alpha, then using Alpha to dereference Beta, and finally using Beta to dereference gamma.

		A common example of a pathname would be a filename.  For example, the UNIX filename /usr/local/bin/tool is a 4-tuple hierarchical key whose components are (usr, local, bin, tool).  Similarly, the Windows filename WINDOWS\I386\SYSTEM32\NTDLL.DLL is a 4-tuple hierarchical key whose components are (WINDOWS, I386, SYSTEM32, NTDLL.DLL). In either case, the first component of the pathname is dereferenced using a standard or pre-agreed namespace (in the context of filenames, this is usually either the "root directory" or else the "current directory.") So, in the given filename examples, both "usr" and "WINDOWS" refer to "namespaces" defined in the "root" namespace (or "root directory.")  Applying the same pattern, "local" refers to a namespace (directory) that is defined in the "user" namespace (directory,) and "I386" refers to a namespace (directory) that is defined in the "WINDOWS" namespace (directory.) Inductively applying the same dereferencing strategy ultimately results in dereferencing the file named "tool" from the namespace (directory) "bin," and the file named "NTDLL.DLL" from the namespace (directory) "SYSTEM32." Note that all but the final component of a pathname must be able to function as namespaces by which to dereference the value of the next key in the sequence. In the case of a file pathname, this means that all but the final component of the pathname must refer to a "file directory."

		It is common practice to represent pathnames by means of encoded Strings--especially in the case of file pathnames. However, in order to represent any hierarchical key as a String, a syntax must be defined which makes it possible to distinguish the components of the hierarchical key from each other.  For this purpose, UNIX filenames use a "/" character, Windows filenames use a "\" character, and Macintosh (HFS+) filenames use a ":" character. And other syntax is used in domains other than filenames.  Such syntactical differences make it difficult to represent pathnames in a portable way.

		Instances of Pathname are intended to represent hierarchical keys, such as file pathnames, in a syntax-independent form. Additionally, an instance of Pathname, unlike a String instance, provides protocol and behavior appropriate to the function and purpose of a hierarchical key/pathname.

		Pathname inherits from Immutable (which see.) Once initialized, a Pathname instance becomes immutable.

	Usage:

		A Pathname is a sequence of components, where each component is a String (or a String-like object, such as a Symbol or a Text).  

		A Pathname can be created directly from an Array of Strings, by sending the message #components: to the class with an Array of Strings as the argument {Pathname components: #('usr' 'local' 'bin' 'tool')}. A Pathname can also be created by parsing an encoded String, by sending the message #fromString:separator: to the class, with the encoded String as the first argument and the "separator character" as the second argument {Pathname fromString: 'foo/bar/mitzvah' separator: $/} {Pathname fromString: 'foo\bar\mitzvah' separator: $\}.

		Instance protocol is provided by which to:

			* Enumerate the components;
			* Extract a subsquence of the components;
			* Create a new Pathname by appending a suffix; 
			* Create a new Pathname by removing a component;
			* Create a new Pathname that is a subsequence of the components of another;
			* Create a new Pathname that is a prefix of another; and
			* Create a new Pathname that is a suffix of another.

		Examples (executable):
			
			(Pathname components: #('usr' 'local' 'bin' 'tool')) withFirst
			(Pathname components: #('usr' 'local' 'bin' 'tool')) withLast
			(Pathname components: #('usr' 'local' 'bin' 'tool')) withAllButFirst
			(Pathname components: #('usr' 'local' 'bin' 'tool')) withAllButLast
			(Pathname components: #('usr' 'local' 'bin' 'tool')) prefixTo: 3
			(Pathname components: #('usr' 'local' 'bin' 'tool')) suffixFrom: 2
			(Pathname components: #('usr' 'local' 'bin' 'tool')) from: 2 to: 3
			(Pathname components: #('usr' 'local' 'bin' 'tool')) removing: 'local'
			(Pathname components: #('foo' 'bar')) appending: 'baz'
			(Pathname components: #('foo' 'bar')) appendingAll: #('and' 'grill')
			(Pathname components: #('foo' 'bar')) appendingPathname: (Pathname components: #('and' 'grill'))
			(Pathname components: #('foo' 'bar')), 'baz'
			(Pathname components: #('foo' 'bar')), #('and' 'grill')
			(Pathname components: #('foo' 'bar')), (Pathname components: #('and' 'grill'))

	Motivation:
		
		To provide a representation of a hierarchical key/pathname that is syntax-neutral; to provide protocol/behavior specific and appropriate to a value whose function/purpose is a hierarchical key/pathname--but with an implementation that is independent of any particular domain (e.g., file pathnames.)

	Implementation:

		Instance Variables

			components		<Array of String> The components of the hierarchical key/pathname represented by the instance.

!

!Pathname class methodsFor: 'instance creation' stamp: ''!
components: anArray
	^self new
		setComponents: anArray;
		beImmutable! !

!Pathname class methodsFor: 'accessing' stamp: ''!
empty
	Empty == nil ifTrue: [Empty := self new beImmutable].
	^Empty! !

!Pathname class methodsFor: 'instance creation' stamp: ''!
fromString: aString 
	^self readFrom: aString readStream! !

!Pathname class methodsFor: 'instance creation' stamp: ''!
fromString: aString separator: separator 
	"{Pathname fromString: 'foo/bar/mitzvah' separator: $/}"

	^self 
		fromString: aString
		separator: separator
		transformer: nil! !

!Pathname class methodsFor: 'instance creation' stamp: ''!
fromString: aString separator: separator transformer: block1 
	"{Pathname fromString: 'foo/bar/mitzvah' separator: $/ transformer: [:component | component asUppercase]}"

	^self 
		readFrom: aString readStream
		separator: separator
		transformer: block1! !

!Pathname class methodsFor: 'class initialization' stamp: ''!
initialize
	Empty := nil! !

!Pathname class methodsFor: 'instance creation' stamp: ''!
readFrom: stream
	"{Pathname readFrom: 'foo/bar/mitzvah' readStream}"

	^self readFrom: stream separator: $/! !

!Pathname class methodsFor: 'instance creation' stamp: ''!
readFrom: stream separator: separator 
	"{Pathname readFrom: 'foo/bar/mitzvah' readStream separator: $/}"

	^self readFrom: stream separator: separator transformer: nil! !

!Pathname class methodsFor: 'instance creation' stamp: ''!
readFrom: stream separator: separator transformer: block1
	"{Pathname readFrom: 'foo/bar/mitzvah' readStream separator: $/ transformer: [:component | component asUppercase]}"

	^self components: (UtilityFunction componentsFromStream: stream separator: separator transformer: block1)! !

!Pathname methodsFor: 'path operations' stamp: ''!
, aPathname
	^[aPathname appendToPathname: self] 
		on: MessageNotUnderstood
		do: 
			[:ex | 
			aPathname isString 
				ifTrue: [self appending: aPathname]
				ifFalse: [self appendingAll: aPathname]]! !

!Pathname methodsFor: 'initialize-release' stamp: ''!
append: aComponent
	(UtilityFunction isNilOrEmpty: aComponent) ifTrue: [^self].
	self assertMutability.
	components := components copyWith: aComponent! !

!Pathname methodsFor: 'initialize-release' stamp: ''!
appendAll: aComponentArray
	(UtilityFunction isNilOrEmpty: aComponentArray) ifTrue: [^self].
	self assertMutability.
	components := components, aComponentArray! !

!Pathname methodsFor: 'initialize-release' stamp: ''!
appendPathname: aPathname 
	| stream |
	(UtilityFunction isNilOrEmpty: aPathname) ifTrue: [^self].
	self assertMutability.
	stream := (Array new: components size + aPathname componentCount) writeStream.
	components do: [:each | stream nextPut: each].
	aPathname componentsDo: [:each | stream nextPut: each].
	components := stream contents! !

!Pathname methodsFor: 'private' stamp: ''!
appendToPathname: aPathname
	^aPathname appendingPathname: self! !

!Pathname methodsFor: 'private' stamp: ''!
appendToResourcePath: aResourcePath
	^aResourcePath appendingPathname: self! !

!Pathname methodsFor: 'path operations' stamp: ''!
appending: aComponent
	^self copy
		append: aComponent;
		beImmutable! !

!Pathname methodsFor: 'path operations' stamp: ''!
appendingAll: aComponentArray
	^self copy
		appendAll: aComponentArray;
		beImmutable! !

!Pathname methodsFor: 'path operations' stamp: ''!
appendingExtension: aString 
	| suffix |
	suffix := components size = 0 
				ifTrue: [^self appending: aString]
				ifFalse: [components last].
	^(self copy)
		setLastComponent: suffix , aString;
		beImmutable! !

!Pathname methodsFor: 'path operations' stamp: ''!
appendingPathname: aPathname
	^self copy
		appendPathname: aPathname;
		beImmutable! !

!Pathname methodsFor: 'converting' stamp: ''!
asArray
	^components copy! !

!Pathname methodsFor: 'converting' stamp: ''!
asPathname
	^self! !

!Pathname methodsFor: 'converting' stamp: ''!
asResourcePath

	^ResourcePath pathname: self! !

!Pathname methodsFor: 'comparing' stamp: ''!
compareTo: aPathname
	"Compare the value of the receiver to that of <aPathname>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aPathname> are the same.)"

	self == aPathname ifTrue: [^0].
	^[aPathname compareToPathname: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == aPathname and: [ex message selector == #compareToPathname:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!Pathname methodsFor: 'private-comparing' stamp: ''!
compareToPathname: aPathname
	| limit thisComponentCount thatComponentCount |
	self isEmpty
		ifTrue: [^aPathname isEmpty ifTrue: [0] ifFalse: [1]]
		ifFalse: [aPathname isEmpty ifTrue: [^-1]].
	limit := (thisComponentCount := self componentCount) min: (thatComponentCount := aPathname componentCount).
	1 to: limit do: [:index |
		| thisComponent  thatComponent |
		thisComponent := self componentAt: index.
		thatComponent := aPathname componentAt: index.
		thatComponent > thisComponent ifTrue: [^1].
		thatComponent < thisComponent ifTrue: [^-1].
	].
	^thatComponentCount - thisComponentCount! !

!Pathname methodsFor: 'accessing' stamp: ''!
componentAt: index
	^(components at: index) copy! !

!Pathname methodsFor: 'accessing' stamp: ''!
componentCount
	^components size! !

!Pathname methodsFor: 'accessing' stamp: ''!
components
	^components copy! !

!Pathname methodsFor: 'enumerating' stamp: ''!
componentsDo: block1
	components do: [:component | block1 value: component copy]! !

!Pathname methodsFor: 'accessing' stamp: ''!
componentsFrom: firstIndex to: lastIndex 
	| stream |
	firstIndex > lastIndex ifTrue: [^nil].
	stream := Array new: lastIndex - firstIndex + 1.
	self 
		componentsFrom: firstIndex
		to: lastIndex
		do: [:component | stream nextPut: component].
	^stream contents! !

!Pathname methodsFor: 'enumerating' stamp: ''!
componentsFrom: firstIndex to: lastIndex do: block1 
	firstIndex to: lastIndex
		do: [:index | block1 value: (self componentAt: index)]! !

!Pathname methodsFor: 'queries' stamp: ''!
extensionUsingSeparator: extensionSeparator ifNone: ifNone 
	^self 
		usingSeparator: extensionSeparator
		lastComponentAndExtenstionIndexInto: 
			[:lastComponent :index | 
			lastComponent copyFrom: index + 1 to: lastComponent size]
		ifNone: ifNone! !

!Pathname methodsFor: 'accessing' stamp: ''!
firstComponentIfNone: ifNone
	^components size = 0
		ifTrue: [ifNone value]
		ifFalse: [self componentAt: 1]! !

!Pathname methodsFor: 'path operations' stamp: ''!
from: firstIndex to: lastIndex
	^self copy
		setComponents: (components copyFrom: firstIndex to: lastIndex);
		beImmutable! !

!Pathname methodsFor: 'testing' stamp: ''!
hasExtensionUsingSeparator: extensionSeparator
	^self 
		usingSeparator: extensionSeparator
		lastComponentAndExtenstionIndexInto: [:lastComponent :index | true]
		ifNone: [false]! !

!Pathname methodsFor: 'comparing' stamp: ''!
hash
	^components hash! !

!Pathname methodsFor: 'testing' stamp: ''!
includesComponent: aComponent
	^components includes:  aComponent! !

!Pathname methodsFor: 'accessing' stamp: ''!
indexOfComponent: aComponent ifAbsent: ifAbsent
	^components indexOf: aComponent ifAbsent: ifAbsent! !

!Pathname methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	components := #()! !

!Pathname methodsFor: 'testing' stamp: ''!
isDefined
	"Assuming the receiver represents a hierarchical key of a value in a namespace defined in the current image's environment, answer whether or not the binding (variable, constant, value, thing) specified by the key is defined."

	"(Pathname fromString: 'Object') isDefined"
	"(Pathname fromString: 'Chronos/Timepoint') isDefined"
	"(Pathname fromString: 'Smalltalk/Array') isDefined"

	components size < 1 ifTrue: [^false].
	components inject: EnvironmentFacade current globalNamespace into: [:namespace :key | namespace at: key asSymbol ifAbsent: [^false]].
	^true! !

!Pathname methodsFor: 'testing' stamp: ''!
isEmpty
	^components isEmpty! !

!Pathname methodsFor: 'accessing' stamp: ''!
lastComponentIfNone: ifNone
	^components size = 0
		ifTrue: [ifNone value]
		ifFalse: [self componentAt: components size]! !

!Pathname methodsFor: 'private' stamp: ''!
postCopy
	"PRECONDTION: The receiver has just been instantiated as a #shallowCopy of another object.  
	POSTCONDITION: In response to this message, the receiver is required to make itself satisfy the following conditions and constraints: 1) It must be mutable,  2) It must compare (#=) as equal to the object from which it was shallowCopied, and 3) It must satisfy the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the object from which it was shallowCopied must not be changed, and b) whenever the object from which the receiver was shallowCopied mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the receiver must not be changed.  An associative reference is one where the semantics of the reference depend in any way on the object identity (#==) of the referenced object.  An attributive reference is one where any referenced object with the same value can transparently be substituted for any other such value-equivalent object without causing any error."

	"Subclasses may need to subimplement this message in order to satisfy the required semantics.  All subimplementers should send #postCopy to super."

	super postCopy.
	components := components copy.! !

!Pathname methodsFor: 'path operations' stamp: ''!
prefixTo: lastIndex
	^self from: 1 to: lastIndex! !

!Pathname methodsFor: 'printing' stamp: ''!
printOn: stream
	self printOn: stream usingSeparator: $/! !

!Pathname methodsFor: 'printing' stamp: ''!
printOn: stream usingSeparator: separator 
	^self printOn: stream usingSeparator: separator andTransformer: [:component | component asString]! !

!Pathname methodsFor: 'printing' stamp: ''!
printOn: stream usingSeparator: separator andTransformer: block1
	| componentCount |
	componentCount := self componentCount.
	componentCount > 0 
		ifTrue: 
			[self 
				componentsFrom: 1
				to: componentCount - 1
				do: 
					[:component | 
					stream nextPutAll: (block1 value: component).
					stream nextPut: separator].
			stream nextPutAll: (block1 value: (self componentAt: componentCount))]! !

!Pathname methodsFor: 'printing' stamp: ''!
printStringUsingSeparator: separator
	^self printStringUsingSeparator: separator andTransformer: [:component | component asString]! !

!Pathname methodsFor: 'printing' stamp: ''!
printStringUsingSeparator: separator andTransformer: block1
	| stream |
	stream := (String new: 12) writeStream.
	self printOn: stream usingSeparator: separator andTransformer: block1.
	^stream contents! !

!Pathname methodsFor: 'path operations' stamp: ''!
removing: aComponent
	^self copy
		setComponents: (components copyWithout: aComponent);
		beImmutable! !

!Pathname methodsFor: 'initialize-release' stamp: ''!
setComponents: aComponentArray
	self assertMutability.
	components := aComponentArray == nil ifTrue: [#()] ifFalse: [aComponentArray copy]! !

!Pathname methodsFor: 'initialize-release' stamp: ''!
setLastComponent: aComponent
	self assertMutability.
	components size > 0
		ifTrue: [components at: components size put: aComponent]
		ifFalse: [self append: aComponent]! !

!Pathname methodsFor: 'path operations' stamp: ''!
suffixFrom: firstIndex
	^self from: firstIndex to: self componentCount! !

!Pathname methodsFor: 'private' stamp: ''!
usingSeparator: extensionSeparator lastComponentAndExtenstionIndexInto: block2 ifNone: ifNone
	| lastComponent index |
	lastComponent := self lastComponentIfNone: [^ifNone value].
	index := lastComponent lastIndexOf: extensionSeparator ifAbsent: [^ifNone value].
	index <= 1 ifTrue: [^ifNone value "It is best if filenames of the form 'foo' or '.foo' are considered to have no extension"].
	^block2 value: lastComponent value: index! !

!Pathname methodsFor: 'accessing' stamp: ''!
value
	"Assuming the receiver represents a hierarchical key of a value in a namespace defined in the current image's environment, answer the value at that key.  If there is no such key in the environment at the specified path, raise an Exception."

	"(Pathname fromString: 'Object') value"
	"(Pathname fromString: 'Chronos/Timepoint') value"
	"(Pathname fromString: 'Smalltalk/Array') value"

	^self valueIfNone: [self signalError: 'Key not found']! !

!Pathname methodsFor: 'accessing' stamp: ''!
valueIfNone: ifNoneAction 
	"Assuming the receiver represents a hierarchical key of a value in a namespace defined in the current image's environment, answer the value at that key. If there is no such key in the environment at the specified path, answer the result of evaluating <ifNoneAction>."

	"(Pathname fromString: 'Object') valueIfNone: []"
	"(Pathname fromString: 'Chronos/Timepoint' ) valueIfNone: []"
	"(Pathname fromString: 'Smalltalk/Array') valueIfNone: []"

	^self valueIn: EnvironmentFacade current globalNamespace  ifNone: ifNoneAction! !

!Pathname methodsFor: 'accessing' stamp: ''!
valueIn: namespace
	"Assuming the receiver represents a hierarchical key of a value in a namespace defined in the current image's environment, answer the value at that key.  If there is no such key in the environment at the specified path, raise an Exception."

	"(Pathname fromString: 'Object') value"
	"(Pathname fromString: 'Chronos/Timepoint') value"
	"(Pathname fromString: 'Smalltalk/Array') value"

	^self valueIn: namespace ifNone: [self signalError: 'Key not found']! !

!Pathname methodsFor: 'accessing' stamp: ''!
valueIn: namespace ifNone: ifNoneAction 
	"Assuming the receiver represents a hierarchical key of a value in a namespace defined in the current image's environment, answer the value at that key. If there is no such key in the environment at the specified path, answer the result of evaluating <ifNoneAction>."

	"(Pathname fromString: 'Object') valueIfNone: []"
	"(Pathname fromString: 'Chronos/Timepoint' ) valueIfNone: []"
	"(Pathname fromString: 'Smalltalk/Array') valueIfNone: []"

	components size < 1 ifTrue: [^ifNoneAction value].
	^components inject: namespace
		into: [:ns :key | ns at: key asSymbol ifAbsent: [^ifNoneAction value]]! !

!Pathname methodsFor: 'path operations' stamp: ''!
withAllButFirst
	| componentCount |
	componentCount := self componentCount.
	^componentCount > 1 
		ifTrue: [self suffixFrom: 2]
		ifFalse: 
			[componentCount > 0 
				ifTrue: 
					[(self copy)
						initialize;
						beImmutable]
				ifFalse: [self]]! !

!Pathname methodsFor: 'path operations' stamp: ''!
withAllButLast
	| componentCount |
	componentCount := self componentCount.
	^componentCount > 1 
		ifTrue: [self prefixTo: componentCount - 1]
		ifFalse: 
			[componentCount > 0 
				ifTrue: 
					[(self copy)
						initialize;
						beImmutable]
				ifFalse: [self]]! !

!Pathname methodsFor: 'path operations' stamp: ''!
withFirst
	^self componentCount > 1 
		ifTrue: 
			[(self copy)
				setComponents: (Array with: components first);
				beImmutable]
		ifFalse: [self]! !

!Pathname methodsFor: 'path operations' stamp: ''!
withLast
	^self componentCount > 1 
		ifTrue: 
			[(self copy)
				setComponents: (Array with: components last);
				beImmutable]
		ifFalse: [self]! !

!Pathname methodsFor: 'path operations' stamp: ''!
withoutExtension: extensionSeparator 
	^self 
		usingSeparator: extensionSeparator
		lastComponentAndExtenstionIndexInto: 
			[:lastComponent :index | 
			(self copy)
				setLastComponent: (lastComponent copyFrom: 1 to: index - 1);
				beImmutable]
		ifNone: [self]! !

PassportMagnitude subclass: #ResourcePath
	instanceVariableNames: 'context protocol hostname port user password namespace pathname query fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!ResourcePath commentStamp: '<historical>' prior: 0!
ResourcePath

	Concept:

		Instances of ResourcePath represent pathnames to files or other external/remote/persistent resources (e.g., LDAP namespace entries.) Unlike a String, an instance of ResourcePath provides protocol and behavior appropriate to the function and purpose of an object that identifies ("references") an external file/resource. Additionally, ResourcePaths provide a much more portable way to represent and manipulate pathames of external/persistent/remote resources in a platform-independent way. 

		ResourcePath inherits from Immutable (which see.) Once initialized, a ResourcePath instance becomes immutable.

	Usage:

		A ResourcePath has three attributes: a hostname, a namepace and a pathname.  

		The hostname attribute identifies the network-addressable host on which the resource (e.g., a file) resides. 

		The namespace attribute represents the platform-specific prefix of the full resource pathname--it's a String whose syntax is that of the native/host filesystem (or other resource storage/retrieval system.) Although the namespace String can contain any prefix of the full resource pathname, up to and including the pathname in its entirety, the intent is that it should only contain whatever pathname prefix is minimally necessary to specify the "root" volume/device/drive/directory/naming-context of the full resource pathname (because that's always the part of a resource pathname whose syntax differs from that of  the rest of the pathname (if it does,) and because it's the part that generally cannot be syntactically translated between different systems for the storage/retrieval of external/remote/persistent resources due to the differences in the ways that such systems conceptualize, model, name and specify their root namespace or namespaces--such differences are not just syntactical.) 

		The namespace attribute MUST identify a resource that serves as a directory--in other words, the resource named by the namespace String must function as a namespace containing named resources (examples: a virtual root directory, a directory or folder, a JNDI Context, a drive, a volume, or a device.).

		If the namespace attribute is nil, then the ResourcePath is interpreted as relatitive to the "current directory" (or whatever namespace is currently the default.)  Conversely, if the namespace attribute is NOT nil, then the ResourcePath is interpreted as an absolute pathname. Consequently, a non-nil namepace attribute must be a syntactically-valid specification of the prefix of an absolute resource pathname. Absolute ResourcePaths (whose namespace attributes are non-nil) are generally NOT portable between systems. Absolute pathname prefixes should be obtained at runtime from platform-specific configuration data.

		The pathname attribute contains a platform-independent representation of the resource pathname. It's represented by an instance of Pathname (which see.) The pathname attribute is intended to contain the part of a file pathname that can be translated between systems solely by means of syntactical changes (i.e., replacing one separator character with another: "foo/bar/baz" -> "foo\bar\baz" -> ":foo:bar:baz".)

		So the Windows file pathname "\\gandalf\c:\foo\bar" would be canonically represented by a ResourcePath whose hostname attribute would be #gandalf, whose namespace attribute would be 'c:\' and whose pathname attribute would be ('foo' 'bar'). The UNIX file pathname "/usr/local/bin" would be canonically represented by a ResourcePath whose hostname would be #localhost, whose namspace would be '/' and whose pathname would be ('usr' 'local' 'bin').

		Instance protocol is provided by which to access, enumerate and manipulate the pathname structure of a ResourcePath, such as the following types of operations:

			* Enumerate the prefixes of a ResourcePath's pathname (first to last, last to first);
			* Create a new ResourcePath that is a prefix of another; 
			* Create a new ResourcePath that is a suffix of another;
			* Create a new ResourcePath by appending a suffix; and
			* Create a new ResourcePath by appending or removing an "extension" to/from the final component of the pathname.

		Instance protocol is also provided by which to perform the following types of operations on the resource referenced (specified, named) by a ResourcePath:

			* Retrieve the status/attributes of the referenced resource (whether or not the resource exists, whether or not it is a directory (namespace,) its size in bytes, what resources it contains if it happens to be a directory);
			* Move the resource so that it will be located at a different pathname;
			* Rename the resource;
			* Copy the resource to a new location;
			* Delete the resource;
			* Create a directory whose pathname will be that represented by the ResourcePath;
			* Open a read or write stream for reading or writing the contents of the resource as a sequence of values (usually characters or bytes, but potentially anything.).

		See the comments of the individual methods for more information.

	Motivation:

		ResourcePath provides a standard, portable API by wich external/persistent/remote resources can be named and accessed, by which resource pathnames can be manipulated, and by which hierarchical structures containing resources can be navigated.  

	Implementation:

		Operations that are system-dependent, such as moving a resource, opening a stream on the contents of a resource, enumerating the contents of a directory, or accessing the size of a resource, are all delegated to the ChronosSystemFacade singleton (see the class comment of ChronosSystemFacade.)  The ChronosSystemFacade singleton also prodes the characters used by the native resource storage/retrieval system (e.g., the native filesystem) to separate pathname components and pathname extensions.

		Instance Variables

			hostname 		<Symbol>		A Symbol representing the network-addressable hostname of the internet node on which the resource referenced by the instance resides. Default value=#localhost.
			namespace 		<String>		A String that identifies the absolute pathname of a root namespace (volume, device, drive, directory, naming context) in which the resource referenced by the instance resides.  If the instance represents a relative  pathname (relative to the current directory,) then <namespace> is nil. If the instance is an absolute pathname, then the value should specify (as a String using native syntax) a syntactically-valid absolute pathname (which will be interpreted as a prefix to the <pathname>.) Canonically, <namespace> is either nil, or else does no more than name some root volume, device, drive, directory or naming context. The value of <namespace>, if it is not nil, MUST name a resource that functions as a namespace containing named resources.
			pathname 		<Pathname>	A Pathname instance that represents the "pure pathname" suffix of the resource pathname represented by the receiver.  The "hostname" and "root" volume, device, drive, directory, or other root naming context/environment must NOT be included.

	!

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
components: anArrayOfStringsOrSymbols
	^self new
		setComponents: anArrayOfStringsOrSymbols;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext
	^self new
		setResourcePathContext: aResourcePathContext;
	beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext components: anArrayOfStringsOrSymbols 
	^self 
		context: aResourcePathContext
		pathname: (Pathname components: anArrayOfStringsOrSymbols)! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext pathname: pathname
	^self new
		setResourcePathContext: aResourcePathContext;
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol components: anArrayOfStringsOrSymbols 
	^self 
		context: aResourcePathContext
		protocol: protocol
		pathname: (Pathname components: anArrayOfStringsOrSymbols)! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol hostname: hostname namespace: namespace components: anArrayOfStringsOrSymbols 
	^self 
		context: aResourcePathContext
		protocol: protocol
		hostname: hostname
		namespace: namespace
		pathname: (Pathname components: anArrayOfStringsOrSymbols)! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol hostname: hostname namespace: namespace pathname: pathname 
	^(self basicNew)
		setResourcePathContext: aResourcePathContext;
		setProtocol: protocol;
		setHostname: hostname;
		setNamespace: namespace;
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol hostname: hostname port: portNumber components: anArrayOfStringsOrSymbols
	^self 
		context: aResourcePathContext
		protocol: protocol
		hostname: hostname
		port: portNumber
		pathname: (Pathname components: anArrayOfStringsOrSymbols)! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol hostname: hostname port: portNumber pathname: pathname 
	^(self basicNew)
		setResourcePathContext: aResourcePathContext;
		setProtocol: protocol;
		setHostname: hostname;
		setPort: portNumber;
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol namespace: namespace
	^self new
		setResourcePathContext: aResourcePathContext;
		setProtocol: protocol;
		setNamespace: namespace;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol namespace: namespace components: anArrayOfStringsOrSymbols 
	^self 
		context: aResourcePathContext
		protocol: protocol
		namespace: namespace
		pathname: (Pathname components: anArrayOfStringsOrSymbols)! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol namespace: namespace pathname: pathname
	^self new
		setResourcePathContext: aResourcePathContext;
		setProtocol: protocol;
		setNamespace: namespace;
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol pathname: pathname
	^self new
		setResourcePathContext: aResourcePathContext;
		setProtocol: protocol;
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
context: aResourcePathContext protocol: protocol user: userString password: passwordString hostname: hostname port: portNumber pathname: pathname 
	^(self basicNew)
		setResourcePathContext: aResourcePathContext;
		setProtocol: protocol;
		setUser: userString;
		setPassword: passwordString;
		setHostname: hostname;
		setPort: portNumber;
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'accessing' stamp: ''!
currentDirectory
	"ResourcePath currentDirectory"

	^self new! !

!ResourcePath class methodsFor: 'accessing' stamp: ''!
defaultDirectory
	"ResourcePath defaultDirectory"

	^self fromString: self defaultResourcePathFacade defaultDirectoryPathnameString! !

!ResourcePath class methodsFor: 'accessing' stamp: ''!
defaultResourcePathContext
	^ResourcePathContext platformDefault! !

!ResourcePath class methodsFor: 'accessing' stamp: ''!
defaultResourcePathFacade
	^self defaultResourcePathContext defaultFacade! !

!ResourcePath class methodsFor: 'parsing' stamp: ''!
from: stream defaultProtocol: defaultProtocol protocolAndSuffixStreamInto: block2
	"ResourcePath from: 'xy' readStream defaultProtocol: #platform protocolAndSuffixStreamInto: [:protocol :suffixStream | Array with: protocol with: suffixStream upToEnd]"
	"ResourcePath from: 'xyz' readStream defaultProtocol: #http protocolAndSuffixStreamInto: [:protocol :suffixStream | Array with: protocol with: suffixStream upToEnd]"
	"ResourcePath from: 'foo:bar' readStream defaultProtocol: #file protocolAndSuffixStreamInto: [:protocol :suffixStream | Array with: protocol with: suffixStream upToEnd]"
	"ResourcePath from: 'foo:bar' readStream defaultProtocol: #http protocolAndSuffixStreamInto: [:protocol :suffixStream | Array with: protocol with: suffixStream upToEnd]"
	"ResourcePath from: '//foo/bar' readStream defaultProtocol: #https protocolAndSuffixStreamInto: [:protocol :suffixStream | Array with: protocol with: suffixStream upToEnd]"
	"ResourcePath from: 'http://foo/bar' readStream defaultProtocol: #file protocolAndSuffixStreamInto: [:protocol :suffixStream | Array with: protocol with: suffixStream upToEnd]"
	"ResourcePath from: 'ldap://foo/bar' readStream defaultProtocol: #http protocolAndSuffixStreamInto: [:protocol :suffixStream | Array with: protocol with: suffixStream upToEnd]"
	"ResourcePath from: 'junk://foo/bar' readStream defaultProtocol: #file protocolAndSuffixStreamInto: [:protocol :suffixStream | Array with: protocol with: suffixStream upToEnd]"

	| startPosition protocolIndex protocol |
	startPosition := stream position.
	protocol := UtilityFunction 
					nextFrom: stream 
					while: [:ch | ch isLetter] 
					minChars: 3 
					maxChars: 5 
					onUnexpectedEOD: [:prefix :ch :position | stream skip: startPosition - position. ^block2 value: defaultProtocol value: stream].
	((stream peekFor: $:) and: [(protocolIndex := #('file' 'http' 'https' 'ftp' 'ldap') indexOf: protocol ifAbsent: [0]) > 0])
		ifFalse: [stream skip: startPosition - stream position. ^block2 value: defaultProtocol value: stream].
	^block2 value: (#(#file #http #https #ftp #ldap) at: protocolIndex) value: stream! !

!ResourcePath class methodsFor: 'parsing' stamp: ''!
fromString: aStringNamingAResource 
	"{ResourcePath fromString: ResourcePath defaultResourcePathFacade defaultDirectoryPathnameString}"

	^self readFrom: aStringNamingAResource readStream! !

!ResourcePath class methodsFor: 'parsing' stamp: ''!
fromString: aStringNamingAResource withContext: aResourcePathContext 
	"{ResourcePath fromString: '/foo/bar/baz?q=who+goes+there&context=http#boink' withContext: (ResourcePathContext new defaultProtocol: #http)}"

	^self 
		readFrom: aStringNamingAResource readStream
		withContext: aResourcePathContext! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
hostname: hostname namespace: namespace components: anArrayOfStringsOrSymbols
	^self 
		hostname: hostname
		namespace: namespace
		pathname: (Pathname components: anArrayOfStringsOrSymbols)! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
hostname: hostname namespace: namespace pathname: pathname
	^self basicNew
		setHostname: hostname;
		setNamespace: namespace;
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
namespace: namespace
	^self new
		setNamespace: namespace;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
namespace: namespace components: anArrayOfStringsOrSymbols 
	^self 
		namespace: namespace
		pathname: (Pathname components: anArrayOfStringsOrSymbols)! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
namespace: namespace pathname: pathname
	^self new
		setNamespace: namespace;
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'instance creation' stamp: ''!
pathname: pathname
	^self new
		setPathname: pathname;
		beImmutable! !

!ResourcePath class methodsFor: 'parsing' stamp: ''!
readFrom: stream 
	^self readFrom: stream withContext: self defaultResourcePathContext! !

!ResourcePath class methodsFor: 'parsing' stamp: ''!
readFrom: stream withContext: aResourcePathContext 
	| context |
	context := aResourcePathContext == nil ifTrue: [self defaultResourcePathContext] ifFalse: [aResourcePathContext].
	^self 
		from: stream
		defaultProtocol: context defaultProtocol
		protocolAndSuffixStreamInto: 
			[:protocol :suffixStream | (context facadeAt: protocol) constructResourcePathFromStream: suffixStream]! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
, aSuffix
	"Answer a new ResourcePath constructed by appending <aSuffix> to the receiver. The value of <aSuffix> may be a String, an Array of String, or an instance of Pathname."
 
	^[aSuffix appendToResourcePath: self] 
		on: MessageNotUnderstood
		do: 
			[:ex | 
			aSuffix isString 
				ifTrue: [self appending: aSuffix]
				ifFalse: [self appendingAll: aSuffix]]! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
addQueryAssociation: anAssociation 
	self assertMutability.
	query == nil 
		ifTrue: [query := Array with: anAssociation]
		ifFalse: [query := query copyWith: anAssociation]! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
append: aComponent
	self assertMutability.
	pathname := pathname, (Pathname fromString: aComponent separator: self separator)! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
appendAll: aComponentArray 
	self assertMutability.
	pathname := pathname copy.
	aComponentArray 
		do: [:each | pathname appendPathname: (Pathname fromString: each separator: self separator)]! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
appendPathname: aPathname
	self assertMutability.
	pathname := pathname copy.
	pathname appendPathname: aPathname! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
appendStream
	"Semantics defined by ANSI Smalltalk standard for external streams."

	^self writeStreamWithMode: #append! !

!ResourcePath methodsFor: 'private' stamp: ''!
appendToPathname: aPathname
	^aPathname appendingPathname: self pathname! !

!ResourcePath methodsFor: 'private' stamp: ''!
appendToResourcePath: aResourcePath
	^aResourcePath appendingPathname: self pathname! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
appending: aString
	"Answer a new ResourcePath constructed by appending <aString> to the receiver as the last component of its path."

	^self copy
		append: aString;
		beImmutable! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
appendingAll: anArrayOfStrings
	"Answer a new ResourcePath constructed by appending <anArrayOfStrings> to the receiver."

	^self copy
		appendAll: anArrayOfStrings;
		beImmutable! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
appendingExtension: aString
	"Answer a new ResourcePath constructed by appending <aString> as an extension to the last component of the receiver's path."

	^self copy
		setPathname: (pathname appendingExtension: (String with: self extensionSeparator), aString);
		beImmutable! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
appendingPathname: aPathname 
	"Answer a new ResourcePath constructed by appending <aPathname> to the receiver."

	^(self copy)
		appendPathname: aPathname;
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: 'PaulDeBruicker 03/07/2011 14:03'!
asAbsolute
	"Answer the conversion of the receiver into an absolute ResourcePath"

	"{ResourcePath defaultDirectory asAbsolute}"
	"{ResourcePath currentDirectory asAbsolute}"
	"{(ResourcePath fromString: 'foo') asAbsolute}"

^self isAbsolute 
		ifTrue: [self]
		ifFalse: 
			[| defaultDirectory |
			defaultDirectory := self class defaultDirectory.
			
			self isRemote 
				ifTrue: 
					[^(self copy)
						setNamespace: defaultDirectory namespace;
						setPathname: defaultDirectory pathname , pathname;
						beImmutable]
				ifFalse: 
					[pathname isEmpty 
						ifTrue: [defaultDirectory]
						ifFalse: [defaultDirectory , pathname]]].
				
! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asAuthority
	^(self copy)
		initializeNonAuthorityValues;
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asInvariant
	^self copy beInvariant beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asLocal
	^self withHostname: #localhost! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asNative
	"Answer the conversion of the receiver into whatever object/value would canonically be used by the host Smalltalk implementation to name/identify the same external/persistent/remote resource as does the receiver."

	^self resourcePathFacade constructNativeResourceIDFromResourcePath: self! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asOperand
	"Answer the conversion of the receiver into whatever object/value the receiver's ResourcePathFacade expects as an operand for service calls."

	^self resourcePathFacade operandFromResourcePath: self! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asPathname
	"Answer the conversion of the receiver into a Pathname."

	^self pathname! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asPlatform
	^self withProtocol: #platform! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asRelative
	^self copy beRelative beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asResourcePath

	^self! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asRoot
	"Answer the conversion of the receiver into an absolute ResourcePath that names, identifies or implies the same root volume, drive, device, directory or naming-context as does the receiver, but that only names/identifies said root volume, drive, device, directory or naming-context, without any suffix."

	"{ResourcePath defaultDirectory asRoot}"
	"{ResourcePath currentDirectory asRoot}"

	| pathless |
	pathless := 
		(self copy)
			initializePostPathValues;
			initializePathname.
	^pathless isAbsolute ifTrue: [pathless beImmutable] ifFalse: [pathless prefix asRoot]! !

!ResourcePath methodsFor: 'converting' stamp: ''!
asString
	^self asNative asString! !

!ResourcePath methodsFor: 'private' stamp: ''!
basicNamespace
	^namespace copy! !

!ResourcePath methodsFor: 'private-testing' stamp: ''!
basicSpecifiesHostname
	^hostname notNil! !

!ResourcePath methodsFor: 'private-testing' stamp: ''!
basicSpecifiesNamespace
	^namespace notNil! !

!ResourcePath methodsFor: 'private-testing' stamp: ''!
basicSpecifiesPassword
	^password notNil! !

!ResourcePath methodsFor: 'private-testing' stamp: ''!
basicSpecifiesPort
	^port notNil and: [port >= 0]! !

!ResourcePath methodsFor: 'private-testing' stamp: ''!
basicSpecifiesUser
	^user notNil! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
beAbsolute
	self assertMutability.
	namespace == nil ifTrue: [namespace := self defaultNamespace].! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
beInvariant
	| facade |
	self assertMutability.
	context == nil ifTrue: [context := ResourcePathContext platformDefault].
	protocol == nil ifTrue: [protocol := self defaultProtocol].
	facade := self resourcePathFacade.
	facade syntaxPermitsUserCredentials 
		ifTrue: 
			[user == nil ifTrue: [user := self defaultUser].
			password == nil ifTrue: [password := self defaultPassword]].
	hostname == nil ifTrue: [hostname := self defaultHostname].
	facade syntaxPermitsPort 
		ifTrue: [port == nil ifTrue: [port := self defaultPort]].
	self beAbsolute! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
beRelative
	self assertMutability.
	hostname := #localhost.
	namespace := nil! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	| stream facade |
	self assertMutability.
	namespace == nil 
		ifFalse: 
			[facade := self resourcePathFacade.
			namespace size > 1 
				ifTrue: 
					[(namespace occurrencesOf: self separator) > 1 
						ifTrue: 
							[stream := namespace readStream.
							(stream peekFor: self separator)
								ifTrue: [namespace := facade rootDirectoryMetavalueString]
								ifFalse: [namespace := stream upTo: self separator].
							pathname := (Pathname readFrom: stream separator: self separator) appendingPathname: pathname]]
				ifFalse: 
					[namespace = facade defaultRootDirectoryString 
						ifTrue: [namespace := facade rootDirectoryMetavalueString]]].
	pathname beImmutable! !

!ResourcePath methodsFor: 'comparing' stamp: ''!
compareTo: aPath
	"Compare the value of the receiver to that of <aPath>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aPath> are the same.)"

	self == aPath ifTrue: [^0].
	^[aPath compareToResourcePath: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == aPath and: [ex message selector == #compareToResourcePath:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!ResourcePath methodsFor: 'private-comparing' stamp: ''!
compareToResourcePath: otherPath 
	| diff thisQS thatQS facade thisQueryCount thatQueryCount |
	otherPath protocol > self protocol ifTrue: [^1].
	otherPath protocol < self protocol ifTrue: [^-1].
	facade := self resourcePathFacade.
	facade syntaxPermitsUserCredentials 
		ifTrue: 
			[otherPath basicSpecifiesUser 
				ifTrue: 
					[self basicSpecifiesUser ifFalse: [^1].
					otherPath user > self user ifTrue: [^1].
					otherPath user < self user ifTrue: [^-1]]
				ifFalse: [self basicSpecifiesUser ifTrue: [^-1]].
			otherPath basicSpecifiesPassword 
				ifTrue: 
					[self basicSpecifiesPassword ifFalse: [^1].
					otherPath password > self password ifTrue: [^1].
					otherPath password < self password ifTrue: [^-1]]
				ifFalse: [self basicSpecifiesPassword ifTrue: [^-1]]].
	facade syntaxPermitsHostname 
		ifTrue: 
			[otherPath basicSpecifiesHostname 
				ifTrue: 
					[self basicSpecifiesHostname ifFalse: [^1].
					otherPath hostname > self hostname ifTrue: [^1].
					otherPath hostname < self hostname ifTrue: [^-1]]
				ifFalse: [self basicSpecifiesHostname ifTrue: [^-1]]].
	facade syntaxPermitsPort 
		ifTrue: 
			[otherPath basicSpecifiesPort 
				ifTrue: 
					[self basicSpecifiesPort ifFalse: [^1].
					otherPath port > self port ifTrue: [^1].
					otherPath port < self port ifTrue: [^-1]]
				ifFalse: [self basicSpecifiesPort ifTrue: [^-1]]].
	otherPath basicSpecifiesNamespace 
		ifTrue: 
			[self basicSpecifiesNamespace ifFalse: [^1].
			otherPath namespace > self namespace ifTrue: [^1].
			otherPath namespace < self namespace ifTrue: [^-1]]
		ifFalse: [self basicSpecifiesNamespace ifTrue: [^-1]].
	diff := otherPath pathname compareTo: self pathname.
	diff = 0 ifFalse: [^diff].
	facade syntaxPermitsQueryString 
		ifTrue: 
			[otherPath hasQuery 
				ifTrue: [self hasQuery ifFalse: [^1]]
				ifFalse: [self hasQuery ifTrue: [^-1]].
			thisQueryCount := self queryCount.
			thatQueryCount := otherPath queryCount.
			thatQueryCount > thisQueryCount ifTrue: [^1].
			thatQueryCount < thisQueryCount ifTrue: [^-1].
			thisQS := self queryString.
			thatQS := otherPath queryString.
			thatQS > thisQS ifTrue: [^1].
			thatQS < thisQS ifTrue: [^-1]].
	facade syntaxPermitsFragment 
		ifTrue: 
			[otherPath hasFragment 
				ifTrue: [self hasFragment ifFalse: [^1]]
				ifFalse: [self hasFragment ifTrue: [^-1]].
			otherPath fragment > self fragment ifTrue: [^1].
			otherPath fragment < self fragment ifTrue: [^-1]].
	^0! !

!ResourcePath methodsFor: 'file queries' stamp: ''!
contents
	"Answer an Array of the ResourcePaths of all the resources contained by the directory (or namespace) named by the receiver. Fail if the receiver does not name an existing directory or namespace."

	| stream |
	stream := (Array new: 10) writeStream.
	self contentsDo: [:rp | stream nextPut: rp].
	^stream contents! !

!ResourcePath methodsFor: 'file queries' stamp: ''!
contentsDo: block1
	"Evaluate <block1> with the ResourcePath of each resource contained by the directory (or namespace) named by the receiver. Fail if the receiver does not name an existing directory or namespace."

	^self resourcePathFacade withResourcePathsOfResourcesInDirectory: self asOperand do: block1! !

!ResourcePath methodsFor: 'file operations' stamp: ''!
copyTo: aDestination 
	"Copy the contents of the resource named by the receiver so that the resource named by <aDestination> will have the same contents."

	^self 
		resourcePathFacade copyResource: self asOperand
		to: aDestination asOperand! !

!ResourcePath methodsFor: 'private' stamp: ''!
defaultHostname
	^context == nil 
		ifTrue: [#localhost]
		ifFalse: [self resourcePathContext defaultHostnameAt: self protocol]! !

!ResourcePath methodsFor: 'private' stamp: ''!
defaultNamespace
	^self resourcePathFacade defaultNamespace! !

!ResourcePath methodsFor: 'private' stamp: ''!
defaultPassword
	^context == nil 
		ifTrue: ['']
		ifFalse: [self resourcePathContext defaultPassword]! !

!ResourcePath methodsFor: 'private' stamp: ''!
defaultPort
	^(context == nil 
		ifTrue: [ResourcePathContext]
		ifFalse: [self resourcePathContext]) defaultPortAt: self protocol! !

!ResourcePath methodsFor: 'private' stamp: ''!
defaultProtocol
	^context == nil 
		ifTrue: [#platform]
		ifFalse: [self resourcePathContext defaultProtocol]! !

!ResourcePath methodsFor: 'private' stamp: ''!
defaultResourcePathContext
	^(protocol == nil or: [protocol == #platform]) 
		ifTrue: [ResourcePathContext platformDefault]
		ifFalse: [ResourcePathContext default]! !

!ResourcePath methodsFor: 'private' stamp: ''!
defaultUser
	^context == nil 
		ifTrue: ['']
		ifFalse: [self resourcePathContext defaultUser]! !

!ResourcePath methodsFor: 'file operations' stamp: ''!
delete
	"Delete the resource named by the receiver."

	self resourcePathFacade deleteResource: self asOperand! !

!ResourcePath methodsFor: 'testing' stamp: ''!
exists
	"Answer true if the resource named by the receiver exists.  Otherwise, answer false."

	^self resourcePathFacade resourceExists: self asOperand! !

!ResourcePath methodsFor: 'file queries' stamp: ''!
extensionIfNone: ifNone
	"Answer, as a String, the extension that is the suffix of the final component of the receiver. Such extensions are often used to distinguish the type of date contained in a resource.  Commonly used extensions include '.txt' and '.jpg'."

	^self extensionUsingSeparator: self extensionSeparator ifNone: ifNone! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
extensionSeparator
	^self resourcePathFacade fileExtensionSeparator! !

!ResourcePath methodsFor: 'file queries' stamp: ''!
extensionUsingSeparator: extensionSeparator ifNone: ifNone
	"Answer, as a String, the extension that is the suffix of the final component of the receiver. Such extensions are often used to distinguish the type of date contained in a resource.  Commonly used extensions include '.txt' and '.jpg'. Use <extensionSeparator> to distinguish the extension suffix from the base name prefix."

	^pathname extensionUsingSeparator: extensionSeparator ifNone: ifNone! !

!ResourcePath methodsFor: 'deprecated' stamp: ''!
fileSize
	"Answer the size in bytes of the resource named by the receiver."

	^self resourcePathFacade sizeOfResource: self asOperand! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
fragment
	^fragment == nil ifTrue: [''] ifFalse: [fragment copy]! !

!ResourcePath methodsFor: 'testing' stamp: ''!
hasDefaultPort
	^self port = (ResourcePathContext defaultPortAt: self protocol)! !

!ResourcePath methodsFor: 'testing' stamp: ''!
hasExtension
	"Answer true if the final component of the receiver's path has an extension. Otherwise, answer false."

	^self hasExtensionUsingSeparator: self extensionSeparator! !

!ResourcePath methodsFor: 'testing' stamp: ''!
hasExtensionUsingSeparator: extensionSeparator
	"Answer true if the final component of the receiver's path has an extension--using the <extensionSeparator> character to separate the extension suffix from the base prefix. Otherwise, answer false."

	^pathname hasExtensionUsingSeparator: extensionSeparator! !

!ResourcePath methodsFor: 'testing' stamp: ''!
hasFragment
	^fragment notNil! !

!ResourcePath methodsFor: 'testing' stamp: ''!
hasQuery
	^query notNil! !

!ResourcePath methodsFor: 'comparing' stamp: ''!
hash
	^pathname hash! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
hostname
	"Answer a Symbol representing the internet hostname of the internet node on which the file referenced by the receiver resides. By default, answer #localhost"

	^hostname == nil ifTrue: [self defaultHostname] ifFalse: [hostname]! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	self initializeAuthorityValues.
	self initializeNonAuthorityValues! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
initializeAuthorityValues
	self assertMutability.
	hostname := nil.
	port := nil.
	user := nil.
	password := nil.! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
initializeNamespaceAndPathname
	self assertMutability.
	namespace := nil.
	self initializePathname.! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
initializeNonAuthorityValues
	self assertMutability.
	self initializeNamespaceAndPathname.
	self initializePostPathValues! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
initializePathname
	self assertMutability.
	pathname := Pathname empty.! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
initializePostPathValues
	self assertMutability.
	query := nil.
	fragment := nil.! !

!ResourcePath methodsFor: 'testing' stamp: ''!
isAbsolute
	"Answer true if the receiver's path is absolute. Otherwise, answer false."

	^self specifiesNamespace! !

!ResourcePath methodsFor: 'testing' stamp: ''!
isCurrentDirectory
	"Answer true if the receiver is a proxy that dynamically refers to the path of the current directory. Otherwise, answer false."

	^self isRelative and: [pathname isEmpty]! !

!ResourcePath methodsFor: 'testing' stamp: ''!
isDirectory
	"Answer true if the receiver names a directory (a resource that functions as a namespece containing other named resources.) Otherwise, answer false."

	^pathname isEmpty or: [self resourcePathFacade resourceIsDirectory: self asOperand]! !

!ResourcePath methodsFor: 'testing' stamp: ''!
isLocal
	"Answer true if the receiver names a resource located on the local host. Otherwise, answer false."

	^self hostname == #localhost! !

!ResourcePath methodsFor: 'testing' stamp: ''!
isRelative
	"Answer true if the receiver's path is relative to the current directory. Otherwise, answer false."

	^self isAbsolute not! !

!ResourcePath methodsFor: 'testing' stamp: ''!
isRemote
	"Answer true if the receiver names a resource located on a remote host. Otherwise, answer false."

	^self isLocal not! !

!ResourcePath methodsFor: 'testing' stamp: ''!
isRoot
	"Answer true if the receiver names a root directory or namespace. Otherwise, answer false."

	^self isAbsolute and: [pathname isEmpty]! !

!ResourcePath methodsFor: 'file operations' stamp: ''!
makeDirectory
	"Create a resource directory at the path specified by the receiver."

	self withPrefixesFromRootAndThenWithSelfDo: 
			[:path | 
			(path isRoot or: [path exists])
				ifFalse: [self resourcePathFacade makeDirectory: path asOperand]]! !

!ResourcePath methodsFor: 'file operations' stamp: ''!
moveTo: aDestination
	"Relocate the resource named by the receiver so that it's path will be that specified by <aDestination>."

	^self resourcePathFacade moveResource: self asOperand to: aDestination asOperand! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
namespace
	"Answer a String that identifies the full absolute pathname of the root namespace in which the file referenced by the receiver resides.  If the receiver is a relative file reference, then the answered value should specify (as a native filesystem String) the full absolute pathname of the current default directory/folder. In any case, the answered String must start with (and need contain no more than) the root directory of the default volume/device (e.g., '/' on a Unix system, 'C:\' on a Windows system, 'someDriveName:' on a Macintosh.)"
	
	| stream |
	stream := (String new: (namespace == nil ifTrue: [1] ifFalse: [namespace size + 1])) writeStream.
	self resourcePathFacade basicPrintNamespaceOf: self isPrefixed: false on: stream.
	^stream contents! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
newWriteStream
	"Semantics defined by ANSI Smalltalk standard for external streams."

	^self writeStreamWithMode: #truncate check: false! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
password
	^password == nil ifTrue: [self defaultPassword] ifFalse: [password copy]! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
pathname
	^pathname! !

!ResourcePath methodsFor: 'testing' stamp: ''!
pathnameIsEmpty
	^pathname isEmpty! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
port
	^port == nil ifTrue: [self defaultPort] ifFalse: [port]! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
prefix
	"Answer a ResourcePath that is the prefix of the receiver--constructed by removing the last component of the receiver's path."

	| stream ns facade |
	^pathname isEmpty 
		ifTrue: 
			[facade := self resourcePathFacade.
			ns := self namespace.
			ns size > 1 
				ifTrue: 
					[(ns occurrencesOf: self separator) > 1 
						ifTrue: 
							[stream := ns readStream.
							(self copy)
								setNamespace: 
									((stream peekFor: self separator) 
										ifTrue: [facade rootDirectoryMetavalueString]
										ifFalse: [stream upTo: self separator]);
								setPathname: ((Pathname readFrom: stream separator: self separator) appendingPathname: pathname)]
						ifFalse: [self]]
				ifFalse: [self]]
		ifFalse: 
			[(self copy)
				setPathname: pathname withAllButLast;
				beImmutable]! !

!ResourcePath methodsFor: 'private' stamp: ''!
printNamespaceAndPathnameOn: stream 
	namespace == nil 
		ifFalse: 
			[self resourcePathFacade basicPrintNamespaceOf: self isPrefixed: false on: stream].
	pathname printOn: stream usingSeparator: self separator! !

!ResourcePath methodsFor: 'printing' stamp: ''!
printOn: stream
	self resourcePathFacade print: self on: stream! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
protocol
	^protocol == nil ifTrue: [self defaultProtocol] ifFalse: [protocol]! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
queryCount
	^query == nil ifTrue: [0] ifFalse: [query size]! !

!ResourcePath methodsFor: 'enumerating' stamp: ''!
queryKeysAndValuesDo: block2 
	query == nil ifTrue: [^self].
	query 
		do: [:association | block2 value: association key copy value: association value copy]! !

!ResourcePath methodsFor: 'printing' stamp: ''!
queryString
	| stream |
	self hasQuery ifFalse: [^''].
	stream := (String new: 32) writeStream.
	self resourcePathFacade printQueryOf: self on: stream.
	^stream contents! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
readStream
	"Semantics defined by ANSI Smalltalk standard for external streams."

	^self readStreamWithType: #text! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
readStreamWithType: ansiTypeSymbol
	"Semantics defined by ANSI Smalltalk standard for external streams."

	^self resourcePathFacade newExternalReadStream: self asOperand type: ansiTypeSymbol! !

!ResourcePath methodsFor: 'file operations' stamp: ''!
renameTo: newName
	"Change the name of the receiver to be <newName> (<newName> is a ResourcePath)."

	self resourcePathFacade renameResource: self asOperand to: newName asOperand! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
resourcePathContext
	^context == nil 
		ifTrue: [self defaultResourcePathContext]
		ifFalse: [context]! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
resourcePathFacade
	^self resourcePathContext facadeAt: self protocol! !

!ResourcePath methodsFor: 'file queries' stamp: ''!
resourceSize
	"Answer the size in bytes of the resource named by the receiver."

	^self resourcePathFacade sizeOfResource: self asOperand! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
separator
	^self resourcePathFacade pathnameSeparator! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setComponents: anArrayOfStrings
	self setPathname: (Pathname components: anArrayOfStrings)! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setFragment: aStringOrNil
	self assertMutability.
	fragment := (UtilityFunction isNilOrEmpty: aStringOrNil) ifFalse: [aStringOrNil].! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setHostname: nilOrAnInternetHostnameString
	"See #hostname"

	self assertMutability.
	hostname := (UtilityFunction isNilOrEmpty: nilOrAnInternetHostnameString) ifFalse: [nilOrAnInternetHostnameString asSymbol] "without any URI prefix"! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setNamespace: nilOrAStringSpecifyingTheRootVolumeOrDeviceName 
	"See #namespace"

	self assertMutability.
	namespace := 
		(UtilityFunction isNilOrEmpty: nilOrAStringSpecifyingTheRootVolumeOrDeviceName)
			ifFalse: 
				[nilOrAStringSpecifyingTheRootVolumeOrDeviceName = self resourcePathFacade currentDirectoryMetavalueString 
					ifFalse: [nilOrAStringSpecifyingTheRootVolumeOrDeviceName]]! !

!ResourcePath methodsFor: 'utilities' stamp: ''!
setNonDefaultSpecifiedAttributesAsDefaultsInContext: aResourcePathContext
	| stream |
	protocol == nil ifFalse: [aResourcePathContext defaultProtocol: self protocol].
	user == nil ifFalse: [aResourcePathContext defaultPassword: self password].
	password == nil ifFalse: [aResourcePathContext defaultHostnameAt: self protocol put: self hostname].
	hostname == nil ifFalse: [aResourcePathContext defaultHostnameAt: self protocol put: hostname].
	self specifiesNonDefaultPort ifTrue: [aResourcePathContext defaultPortAt: self protocol put: self port].
	stream := (String new: 32) writeStream.
	self printNamespaceAndPathnameOn: stream.
	aResourcePathContext defaultNamspaceAt: self protocol put: stream contents.! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setPassword: aString
	self assertMutability.
	password := (UtilityFunction isNilOrEmpty: aString) ifFalse: [aString]! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setPathname: aPathame
	self assertMutability.
	pathname := aPathame == nil ifTrue: [Pathname empty] ifFalse: [aPathame]! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setPort: portNumber
	self assertMutability.
	port := portNumber! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setProtocol: protocolSymbol
	self assertMutability.
	protocol := protocolSymbol! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setResourcePathContext: aResourcePathContext 
	self assertMutability.
	context := 
		aResourcePathContext == nil 
			ifFalse: [aResourcePathContext isPlatformDefault ifFalse: [aResourcePathContext]]! !

!ResourcePath methodsFor: 'initialize-release' stamp: ''!
setUser: aString
	self assertMutability.
	user := (UtilityFunction isNilOrEmpty: aString) ifFalse: [aString]! !

!ResourcePath methodsFor: 'testing' stamp: ''!
specifiesNamespace
	^namespace notNil or: 
			[context == nil 
				ifTrue: [false]
				ifFalse: [self resourcePathContext specifiesDefaultNamespaceAt: self protocol]]! !

!ResourcePath methodsFor: 'testing' stamp: ''!
specifiesNonDefaultPort
	^(port notNil and: [port >= 0]) and: [port ~= (context == nil ifTrue: [ResourcePathContext] ifFalse: [self resourcePathContext]) defaultPortAt: self protocol]! !

!ResourcePath methodsFor: 'testing' stamp: ''!
specifiesPassword
	^password notNil or: [context notNil and: [self resourcePathContext hasDefaultPassword]]! !

!ResourcePath methodsFor: 'testing' stamp: ''!
specifiesUser
	^user notNil or: [context notNil and: [self resourcePathContext hasDefaultUser]]! !

!ResourcePath methodsFor: 'testing' stamp: ''!
specifiesUserCredentials
	^self specifiesUser or: [self specifiesPassword]! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
suffix
	"Answer a ResourcePath that is the suffix of the receiver--constructed by removing all but the last component of the receiver's path."

	^pathname isEmpty 
		ifTrue: 
			[| ns |
			ns := self namespace.
			(ns includes: self separator) 
				ifTrue: 
					[(self class fromString: ns) suffix]
				ifFalse: [self]]
		ifFalse: 
			[(ResourcePath new)
				setPathname: pathname withLast;
				beImmutable]! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
suffixString
	"Answer a String that corresponds to the last component of the receiver's path."

	^pathname lastComponentIfNone: 
			[| ns |
			ns := self basicNamespace.
			(ns notNil and: [ns includes: self separator]) 
				ifTrue: [(self class fromString: ns) suffixString]
				ifFalse: [self asString]]! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
user
	^user == nil ifTrue: [self defaultUser] ifFalse: [user copy]! !

!ResourcePath methodsFor: 'accessing' stamp: ''!
value
	"Answer the contents of the resource referenced by the receiver. Fail if the referenced resource is a directory, does not exist or is not accessible."

	| writeStream |
	writeStream := (String new: 4096) writeStream.
	self withReadStreamDo: 
			[:readStream | 
			[readStream atEnd] whileFalse: [writeStream nextPut: readStream next]].
	^writeStream contents! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withContext: aResourcePathContext
	"Answer a copy of the receiver whose protocol is <protocolSymbol>."

	context == aResourcePathContext ifTrue: [^self].

	^(self copy)
		setResourcePathContext: aResourcePathContext;
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withHostname: aHostname 
	"Answer a copy of the receiver whose hostname is <aHostname>."

	hostname = ((UtilityFunction isNilOrEmpty: aHostname) ifFalse: [aHostname]) ifTrue: [^self].

	^(self copy)
		setHostname: aHostname;
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withHostname: aHostname namespace: aNamespace 
	"Answer a copy of the receiver whose hostname is <aHostname> and whose namespace is <aNamespace>."

	(hostname = ((UtilityFunction isNilOrEmpty: aHostname) ifFalse: [aHostname]) and: [namespace = ((UtilityFunction isNilOrEmpty: aNamespace) ifFalse: [aNamespace])]) ifTrue: [^self].

	^(self copy)
		setHostname: aHostname;
		setNamespace: aNamespace;
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withHostname: aHostname port: portNumber 
	"Answer a copy of the receiver whose hostname is <aHostname> and whose port is <portNumber>."

	(hostname = ((UtilityFunction isNilOrEmpty: aHostname) ifFalse: [aHostname]) and: [port = portNumber]) ifTrue: [^self].

	^(self copy)
		setHostname: aHostname;
		setPort: portNumber;
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withNamespace: aNamespace 
	"Answer a copy of the receiver whose namespace is <aNamespace>."

	namespace = ((UtilityFunction isNilOrEmpty: aNamespace) ifFalse: [aNamespace]) ifTrue: [^self].
	^(self copy)
		setNamespace: aNamespace;
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withNamespace: aNamespace pathname: aPathname


	(namespace = ((UtilityFunction isNilOrEmpty: aNamespace) ifFalse: [aNamespace]) and: [pathname = aPathname]) ifTrue: [^self].

	^(self copy)
		setNamespace: aNamespace;
		setPathname: aPathname;
		beImmutable! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
withNewWriteStreamDo: block1
	| stream |
	stream := self newWriteStream.
	^[block1 value: stream] ensure: [stream close]! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withPathname: aPathname 
	"Answer a copy of the receiver whose pathname is <aPathname>."

	pathname = aPathname ifTrue: [^self].

	^(self copy)
		setPathname: aPathname;
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withPort: portNumber
	"Answer a copy of the receiver whose port is <portNumber>."

	port = portNumber ifTrue: [^self].

	^(self copy)
		setPort: portNumber;
		beImmutable! !

!ResourcePath methodsFor: 'enumerating' stamp: ''!
withPrefixesFromRootAndThenWithSelfDo: block1 
	"Evaluate <block1> with each prefix of the receiver as the argument, such that each prefix is a ResourcePath representing the complete path from the receiver's root to that prefix, starting with the ResourcePath of the receiver's root component and ending with the receiver itself."

	"ResourcePath defaultDirectory withPrefixesFromRootAndThenWithSelfDo: [:each | Transcript cr; show: each printString]"

	| prefix |
	prefix := self prefix.
	prefix == self ifFalse: [prefix withPrefixesFromRootAndThenWithSelfDo: block1 ].
	block1 value: self! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withProtocol: protocolSymbol
	"Answer a copy of the receiver whose protocol is <protocolSymbol>."

	protocol = protocolSymbol ifTrue: [^self].

	^(self copy)
		setProtocol: protocolSymbol;
		beImmutable! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
withReadStreamDo: block1
	| stream |
	stream := self readStream.
	^[block1 value: stream] ensure: [stream close]! !

!ResourcePath methodsFor: 'enumerating' stamp: ''!
withSelfAndThenWithPrefixesUpToRootDo: block1 
	"Evaluate <block1> with each prefix of the receiver as the argument, such that each prefix is a ResourcePath representing the complete path from the receiver's root to that prefix, starting with the receiver itself and ending with the ResourcePath of the receiver's root component."

	"ResourcePath defaultDirectory withSelfAndThenWithPrefixesUpToRootDo: [:each | Transcript cr; show: each printString]"

	| next prev |
	prev := nil.
	next := self.
	[next == prev] whileFalse: 
			[prev := next.
			next := next prefix.
			block1 value: prev]! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withUser: userName password: psswd

	(user = ((UtilityFunction isNilOrEmpty: userName) ifFalse: [userName]) and: [password = ((UtilityFunction isNilOrEmpty: psswd) ifFalse: [psswd])]) ifTrue: [^self].

	^(self copy)
		setUser: userName;
		setPassword: psswd;
		beImmutable! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
withWriteStreamDo: block1
	| stream |
	stream := self writeStream.
	^[block1 value: stream] ensure: [stream close]! !

!ResourcePath methodsFor: 'path operations' stamp: ''!
withoutExtension
	"Answer a ResourcePath constructed by removing an extension from the final component of the receiver's path."

	^(self copy)
		setPathname: (pathname withoutExtension: self extensionSeparator);
		beImmutable! !

!ResourcePath methodsFor: 'converting' stamp: ''!
withoutFragment
	^self hasFragment 
		ifTrue: 
			[(self copy)
				setFragment: nil;
				beImmutable]
		ifFalse: [self]! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
writeStream
	"Semantics defined by ANSI Smalltalk standard for external streams."

	^self writeStreamWithMode: #create! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
writeStreamWithMode: ansiModeSymbol
	"Semantics defined by ANSI Smalltalk standard for external streams."

	^self writeStreamWithMode: ansiModeSymbol check: false! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
writeStreamWithMode: ansiModeSymbol check: enforceExistentialConstraint
	"Semantics defined by ANSI Smalltalk standard for external streams."

	^self writeStreamWithMode: ansiModeSymbol check: enforceExistentialConstraint type: #text! !

!ResourcePath methodsFor: 'stream creation' stamp: ''!
writeStreamWithMode: ansiModeSymbol check: enforceExistentialConstraint type: ansiTypeSymbol 
	"Semantics defined by ANSI Smalltalk standard for external streams."

	^self resourcePathFacade 
		newExternalWriteStream: self asOperand
		mode: ansiModeSymbol
		check: enforceExistentialConstraint
		type: ansiTypeSymbol! !

Immutable subclass: #Registratable
	instanceVariableNames: 'registrationKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

Registratable class
	instanceVariableNames: 'registry'!

!Registratable commentStamp: '<historical>' prior: 0!
Registratable

	Concept:

		Registratable is an abstract class that establishes a framework for classes whose instances may optionally be registered in a registry maintained by the class. The implementation/creation of the instance registry is the responsibility of each concrete subclass.

		A Registratable has a #registrationKey (for which the synonym #key is provided for polymorphism with other keyed objects.) A Registratable may be registered in its class' instance registry under its #registrationKey, and it may additionally be registered using an alias (a key other than its #registrationKey.)
	
		Registratable also provides/implements Immutable behvavior/protocol and ChronosObject behavior/protocol (by inheritance.)

	Usage:

		By default, instances will only be registered when explicitly sent one of the registration messages--registration does not automatically occur when an instance is created or initialized.  Subclasses may override this behavior.

		Registration forces an instance to become immutable (see the superclass Immutable.)

		An instance can be retrieved from the instance registry by sending #at: or #at:ifAbsent: to its class. Also, the class method #referencedBy: (protocol inherited from ChronosObject) is subimplemented so that, if the argument is a String, the argument will be used as the key by which to retrieve an instance from the instance registry.

		An instance will be deregistered when sent either the message #deregister or the message #release.  Also, if the instance registry happens to be a WeakDictionary, then the instance will be deregistered by the garbage collection mechanism once it is found to have no active references.

	Implementation:
		
		Instance Variables

			registrationKey	<Object>	The key that will be used to register the instance in the instance registry.

	Subclassing:

		Concrete subclasses must subimplement the following class methods (see the method comments for more details):

		#aliasRegistryIfNone:
		#basicAliasRegistry
		#basicRegistry
		#default
		#registryIfNone:
		#setAliasRegistry
		#setRegistry
!

Registratable class
	instanceVariableNames: 'registry'!

Registratable subclass: #ExternalResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!ExternalResource class methodsFor: 'accessing' stamp: ''!
alias: canonicalKey as: aliasingKey 
	^self registry alias: canonicalKey as: aliasingKey! !

!ExternalResource class methodsFor: 'accessing' stamp: ''!
aliasingKeysOf: canonicalKey
	^self registry aliasingKeysOf: canonicalKey! !

!ExternalResource class methodsFor: 'accessing' stamp: ''!
allAliasedKeys
	^self registry aliasedKeys! !

!ExternalResource class methodsFor: 'accessing' stamp: ''!
allAliasingKeys
	^self registry aliasingKeys! !

!ExternalResource class methodsFor: 'accessing' stamp: ''!
allCanonicalKeys
	^self registry canonicalKeys! !

!ExternalResource class methodsFor: 'accessing' stamp: ''!
at: aKey ifAbsent: ifAbsent 
	^[super at: aKey ifAbsent: ifAbsent] on: Error do: [:ex | ex return: ifAbsent value]! !

!ExternalResource class methodsFor: 'accessing' stamp: ''!
canonicalKeyAt: aKey ifNone: ifNone
	"TimeZonePolicyFactory canonicalKeyAt: #GB ifNone: []"

	^self registry canonicalKeyAt: aKey ifNone: ifNone! !

!ExternalResource class methodsFor: 'accessing' stamp: ''!
define: aKey
	self registry define: aKey.! !

!ExternalResource class methodsFor: 'private' stamp: ''!
newRegistry
	^ExternalResourceRepository defaultBroker: self resourceBroker! !

!ExternalResource class methodsFor: 'private' stamp: ''!
registrationKeyFrom: stream 
	UtilityFunction skipSeparators: stream.
	^(stream upTo: $:) asSymbol! !

!ExternalResource class methodsFor: 'repository management' stamp: ''!
writeAliasesOn: stream 
	self registry writeAliasesOn: stream! !

!ExternalResource class methodsFor: 'repository management' stamp: ''!
writeCanonicalKeysOn: stream 
	self registry writeCanonicalKeysOn: stream! !

!ExternalResource methodsFor: 'registration' stamp: ''!
aliasAs: aliasingKey onCollision: keyCollision 
	aliasingKey == nil ifTrue: [^self signalError: 'Aliasing requires a non-nil alias key'].
	self hasKey ifFalse: [^self registerAs: aliasingKey ifPresent: keyCollision].
	(self class registry includesKey: aliasingKey) ifTrue: [^keyCollision value: (self class registry at: aliasingKey)].
	self class alias: self registrationKey as: aliasingKey.
	^self! !

!ExternalResource methodsFor: 'accessing' stamp: ''!
aliasingKeys
	^self class aliasingKeysOf: self registrationKey! !

!ExternalResource methodsFor: 'registration' stamp: ''!
registerAs: aKey ifPresent: keyCollision 
	aKey == nil ifTrue: [^self signalError: 'Registration requires a non-nil registration key'].
	self hasKey
		ifTrue: [self registrationKey == aKey ifFalse: [^self aliasAs: aKey onCollision: keyCollision]]
		ifFalse: [self assertMutability].
	^(self class registry includesKey: aKey) 
		ifTrue: [keyCollision value: (self class registry at: aKey)]
		ifFalse: 
			[self setRegistrationKey: aKey.
			self class registry at: self registrationKey put: self beImmutable].! !

!Registratable class methodsFor: 'accessing' stamp: ''!
allRegisteredKeys
	^self registry keys! !

!Registratable class methodsFor: 'instance creation' stamp: ''!
applying: initializationSpec
	^self newConfigurable
		apply: initializationSpec! !

!Registratable class methodsFor: 'accessing' stamp: ''!
at: aKey
	^self at: aKey ifAbsent: [self handleUnregistered: aKey]! !

!Registratable class methodsFor: 'accessing' stamp: ''!
at: aKey do: block1
	| referent value |
	referent := self at: aKey. 
	value := block1 value: referent.
	referent yourself.
	^value! !

!Registratable class methodsFor: 'accessing' stamp: ''!
at: aKey ifAbsent: ifAbsent 
	^aKey == nil 
		ifTrue: [ifAbsent value]
		ifFalse: 
			[| value |
			aKey == #default ifTrue: [^self default].
			value := self registry at: aKey ifAbsent: [0].
			(value == nil or: [value = 0])
				ifTrue: [ifAbsent value]
				ifFalse: [value]]! !

!Registratable class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!Registratable class methodsFor: 'class initialization' stamp: ''!
basicInitialize

	registry := nil.! !

!Registratable class methodsFor: 'class initialization' stamp: ''!
basicInitializeAll
	self basicInitialize.
	self subclasses do: [:each | each basicInitializeAll]! !

!Registratable class methodsFor: 'private' stamp: ''!
basicRegistry
	"Answer the registry of instances, which must be a Dictionary-like object where each key is the canonical registration key of an instance, and where each value is a registered instance. Answer nil if the registry has not been created."

	^registry! !

!Registratable class methodsFor: 'accessing' stamp: ''!
default
	"Answer the default instance of the receiver"

	^self subclassResponsibility! !

!Registratable class methodsFor: 'accessing' stamp: ''!
handleUnregistered: aKey
	^self signalError: 'No value registered at ', aKey printString! !

!Registratable class methodsFor: 'class initialization' stamp: ''!
initialize
	self basicInitializeAll.! !

!Registratable class methodsFor: 'class initialization' stamp: ''!
initializeAll
	"ChronosRegistratable initializeAll"

	self initialize.
	self subclasses do: [:each | each initializeAll]! !

!Registratable class methodsFor: 'instance creation' stamp: ''!
newConfigurable
	^self new! !

!Registratable class methodsFor: 'private' stamp: ''!
newRegistry
	^EnvironmentFacade current newWeakDictionary! !

!Registratable class methodsFor: 'accessing' stamp: ''!
referencedBy: aChronosRegistratableOrChronosRegistratableKey 
	"Anser the value referenced by <aChronosRegistratableOrChronosRegistratableKey>. If the value is a key, answer the value bound to the key. Otherwise, answer aChronosRegistratableOrChronosRegistratableKey itself."

	^aChronosRegistratableOrChronosRegistratableKey == nil 
		ifTrue: [self default]
		ifFalse: 
			[aChronosRegistratableOrChronosRegistratableKey isString 
				ifTrue: [self at: aChronosRegistratableOrChronosRegistratableKey]
				ifFalse: [aChronosRegistratableOrChronosRegistratableKey]]! !

!Registratable class methodsFor: 'private' stamp: ''!
registry
	"Answer the registry of instances, which must be a Dictionary-like object where each key is the canonical registration key of an instance, and where each value is a registered instance. Create the instance registry if that has not yet been done."

	^self registryIfNone: 
			[self
				setRegistry;
				basicRegistry]! !

!Registratable class methodsFor: 'private' stamp: ''!
registryIfNone: ifNone 
	"Answer the registry of instances, which must be a Dictionary-like object where each key is the canonical registration key of an instance, and where each value is a registered instance. If the instance registry has not been created, answer the result of evaluating the zero-argument block <ifNone>."

	^registry == nil ifTrue: [ifNone value] ifFalse: [registry]! !

!Registratable class methodsFor: 'private' stamp: ''!
setRegistry
	"Set the value of the class variable (or class instance variable) that will contain the registry of instances, which must be a Dictionary-like object."

	registry := self newRegistry! !

!Registratable methodsFor: 'initialize-release' stamp: ''!
apply: initializationSpec
	"ChronosPrintPolicy new 
		apply: #(hideTimeOfDay useTwoDigitYears dateSeparator: $- useMonthName useMonthDayYearOrder);
		yourself"

	| argStack argCount selector | 
	self isImmutable ifTrue: [^self copy apply: initializationSpec].
	argStack := nil.
	argCount := 0.
	selector := nil.
	initializationSpec do: [:selectorOrArg | 
		argCount > 0
			ifTrue: 
				[argStack nextPut: (UtilityFunction ansiValueOfLiteralArrayElement: selectorOrArg).
				argCount := argCount - 1.
				argCount > 0
					ifFalse: 
						[self perform: selector withArguments: argStack contents.
						argStack := nil]]
			ifFalse: 
				[(argCount := selectorOrArg numArgs) > 0
					ifTrue: 
						[selector := selectorOrArg.
						argStack := (Array new: argCount) writeStream]
					ifFalse: [self perform: selectorOrArg]]].
		(argCount > 0 or: [argStack notNil]) ifTrue: [self signalError: 'Selector numArgs inconsistent with number of supplied arguments'].! !

!Registratable methodsFor: 'registration' stamp: ''!
deregister
	^(self class registryIfNone: [^self]) removeKey: self registrationKey ifAbsent: []! !

!Registratable methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self registrationKey! !

!Registratable methodsFor: 'registration' stamp: ''!
forceRegistration
	self hasKey ifFalse: [self signalError: 'Key required for registration'].
	self class registry at: self registrationKey put: self beImmutable! !

!Registratable methodsFor: 'testing' stamp: ''!
hasKey
	^registrationKey notNil! !

!Registratable methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self setRegistrationKey: (literalArray at: 2)! !

!Registratable methodsFor: 'testing' stamp: ''!
isRegistered
	^self hasKey
		ifTrue: [(self class registryIfNone: [^false]) includesKey: self registrationKey]
		ifFalse: [false]! !

!Registratable methodsFor: 'accessing' stamp: ''!
key
	^registrationKey! !

!Registratable methodsFor: 'printing' stamp: ''!
printOn: stream
	stream nextPutAll: self globalNameOfClass.
	registrationKey == nil 
		ifFalse: 
			[stream
				nextPut: $(;
				print: registrationKey;
				nextPut: $)]! !

!Registratable methodsFor: 'registration' stamp: ''!
register
	self registerButIfPresent: [:collision | self signalError: 'Unable to register--another value is registered with the same key (', self registrationKey printString, ')']! !

!Registratable methodsFor: 'registration' stamp: ''!
registerAs: aKey ifPresent: keyCollision 
	| collision |
	aKey == nil ifTrue: [^self signalError: 'Registration requires a non-nil registration key'].
	self hasKey 
		ifTrue: 
			[self key = aKey 
				ifFalse: 
					[self isImmutable 
						ifTrue: [^self asMutable registerAs: aKey ifPresent: keyCollision]
						ifFalse: [self setKey: aKey]]]
		ifFalse: [self assertMutability].
	collision := self class registry at: aKey ifAbsentPut: [self beImmutable].
	^(collision == self or: [collision == nil])
		ifTrue: 
			[self setRegistrationKey: aKey.
			self]
		ifFalse: [keyCollision value: collision]! !

!Registratable methodsFor: 'registration' stamp: ''!
registerButIfPresent: keyCollision
	^self registerAs: self registrationKey ifPresent: keyCollision! !

!Registratable methodsFor: 'accessing' stamp: ''!
registrationKey
	^registrationKey! !

!Registratable methodsFor: 'initialize-release' stamp: ''!
release
	super release.
	self deregister! !

!Registratable methodsFor: 'initialize-release' stamp: ''!
setKey: aKey
	self assertMutability.
	self setRegistrationKey: aKey.! !

!Registratable methodsFor: 'private' stamp: ''!
setRegistrationKey: aKey
	registrationKey := aKey == nil ifFalse: [aKey asSymbol]! !

Immutable subclass: #ReversibleTransformer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!ReversibleTransformer methodsFor: 'transformation' stamp: ''!
applyTo: aDate
	^self subclassResponsibility! !

!ReversibleTransformer methodsFor: 'transformation' stamp: ''!
inverseApplyTo: aDate
	^self subclassResponsibility! !

!PassportObject class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Passport'! !

!PassportObject class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self subclassResponsibility! !

!PassportObject class methodsFor: 'instance creation' stamp: ''!
decodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>."

	| class |
	class := self resolveClassFromLiteralArray: literalArray.
	^class basicDecodeFromLiteralArray: literalArray! !

!PassportObject class methodsFor: 'instance creation' stamp: ''!
new
	^self basicNew initialize! !

!PassportObject class methodsFor: 'console reporting' stamp: ''!
newLineToConsole
	EnvironmentFacade newLineToConsole! !

!PassportObject class methodsFor: 'console reporting' stamp: ''!
reportToConsole: message
	"EnvironmentFacade reportToConsole: 'Hello, world'"

	self reportToConsole: message newLineCount: 1! !

!PassportObject class methodsFor: 'console reporting' stamp: ''!
reportToConsole: contextName message: message
	"EnvironmentFacade reportToConsole: 'Hello, world'"

	self reportToConsole: contextName message: message newLineCount: 1! !

!PassportObject class methodsFor: 'console reporting' stamp: ''!
reportToConsole: contextName message: message newLineCount: newLineCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 2"

	self reportToConsole: contextName message: message newLineCount: newLineCount tabCount: 0! !

!PassportObject class methodsFor: 'console reporting' stamp: ''!
reportToConsole: contextName message: message newLineCount: newLineCount tabCount: tabCount
	"EnvironmentFacade reportToConsole: 'Test' message: 'Hello, world' newLineCount: 1 tabCount: 0"
	"EnvironmentFacade reportToConsole: 'Test' message: 'Hello, world' newLineCount: 0 tabCount: 2"

	EnvironmentFacade reportToConsole: contextName message: message newLineCount: newLineCount tabCount: tabCount! !

!PassportObject class methodsFor: 'console reporting' stamp: ''!
reportToConsole: message newLineCount: newLineCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 2"

	self reportToConsole: message newLineCount: newLineCount tabCount: 0! !

!PassportObject class methodsFor: 'console reporting' stamp: ''!
reportToConsole: message newLineCount: newLineCount tabCount: tabCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 0 tabCount: 2"

	self reportToConsole: self appOrLibraryName message: message newLineCount: newLineCount tabCount: tabCount! !

!PassportObject class methodsFor: 'private' stamp: ''!
resolveClassFromLiteralArray: literalArray 
	| className |
	className := literalArray first asSymbol.
	^EnvironmentFacade current resolveClassFromFullyQualifiedName: className
		ifAbsent: 
			[(EnvironmentFacade current namespaceOfClass: self) "namespace of the receiver, not necessarility that of the class in which this method is defined"
				at: className
				ifAbsent: [self signalError: '<#decodeFromLiteralArray:> The class named in the first element of the literal Array can not be resolved.']]! !

!PassportObject class methodsFor: 'error signalling' stamp: ''!
signal: anExceptionFactory message: message
	^EnvironmentFacade signal: anExceptionFactory message: message contextName: self name! !

!PassportObject class methodsFor: 'error signalling' stamp: ''!
signal: anExceptionFactory message: message contextName: contextName
	"Using <anExceptionFactory>, raise an exception with the given <message>"

	^EnvironmentFacade signal: anExceptionFactory message: message contextName: contextName! !

!PassportObject class methodsFor: 'error signalling' stamp: ''!
signalError: message
	"Using the general 'Error' exception factory, raise an exception with the given <message>"

	^self signal: Error message: message! !

!PassportObject methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^self class appOrLibraryName! !

!PassportObject methodsFor: 'accessing' stamp: ''!
comparisonClassIdentifier	
	"Answer a value that identifies the group of comparable values to which the receiver belongs.  The value might be a Smalltalk class, or might be a Symbol, or might be something else."

	^self globalNameOfClass! !

!PassportObject methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	stream nextPut: self globalNameOfClass! !

!PassportObject methodsFor: 'finalization' stamp: ''!
executor
	"Answer an object to execute the finalization for the receiver. Subclasses might want to override this method.
	
	This method is necessary in VisualWorks. Without it, WeakDictionaries fail to properly release their members when they no longer have any active references."

	^nil "If the receiver needs to take finalization action just before being garbage-collected, it should answer either a shallowCopy, or some other object empowered to act as the executor for the receiver's 'last wishes.'"! !

!PassportObject methodsFor: 'accessing' stamp: ''!
globalNameOfClass
	"Answer the fully-qualified (usable anywhere) name of the receiver's class."

	^EnvironmentFacade current fullyQualifiedNameOfClass: self class! !

!PassportObject methodsFor: 'initialize-release' stamp: ''!
initialize	
	"Initialize a newly created instance. This method must answer the receiver."

	"By default, do nothing"! !

!PassportObject methodsFor: 'converting' stamp: ''!
literalArrayEncoding
	"Answer an Array of values that canonically represent the value of the receiver, where each value is stored in a canonical position of the Array, such that the Array can be used as the argument to the message #initializeFromLiteralArray: to initialize a different instance of the receiver's class to have the same value as the receiver, and can be used as an argument to the class message #decodeFromLiteralArray: to instantiate a new instance of the receiver's class whose value is the same as the receiver's.  The first element of the Array must be the name of the receiver's class."

	"{Timepoint now literalArrayEncoding decodeAsLiteralArray}"
	"{(CalendarDuration years: 4 months: 3 days: 15) literalArrayEncoding decodeAsLiteralArray}"
	"{Timeperiod today literalArrayEncoding decodeAsLiteralArray}"
	"{ChronosPrintPolicy universal literalArrayEncoding decodeAsLiteralArray}"
	"{ChronosLocale unitedStates literalArrayEncoding decodeAsLiteralArray}"
	"{TimeZoneLocalizationPolicy unitedStates literalArrayEncoding decodeAsLiteralArray}"
	"{SemanticDatePolicy default literalArrayEncoding decodeAsLiteralArray}"
	"{(VariableOffsetTimezone
		key: #nonGlobalKey name: #SouthernHemisphereNormalOrder
		initialOffset: (Duration hours: 10) withAbbreviation: #WADT 
			until: (WeekOfMonthDayOfWeek month: 4 week: 0 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #nominal
		thenOffset: (Duration hours: 9)  withAbbreviation: #WAST  
			until: (WeekOfMonthDayOfWeek month: 9 week: 1 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #nominal)
				nowToTheSecond literalArrayEncoding decodeAsLiteralArray}"

	| stream |
	stream := Array new writeStream.
	self encodeAsLiteralArrayOn: stream.
	^stream contents! !

!PassportObject methodsFor: 'console reporting' stamp: ''!
newLineToConsole
	EnvironmentFacade newLineToConsole! !

!PassportObject methodsFor: 'console reporting' stamp: ''!
reportToConsole: message
	"EnvironmentFacade reportToConsole: 'Hello, world'"

	self reportToConsole: message newLineCount: 1! !

!PassportObject methodsFor: 'console reporting' stamp: ''!
reportToConsole: contextName message: message
	"EnvironmentFacade reportToConsole: 'Hello, world'"

	self reportToConsole: contextName message: message newLineCount: 1! !

!PassportObject methodsFor: 'console reporting' stamp: ''!
reportToConsole: contextName message: message newLineCount: newLineCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 2"

	self reportToConsole: contextName message: message newLineCount: newLineCount tabCount: 0! !

!PassportObject methodsFor: 'console reporting' stamp: ''!
reportToConsole: contextName message: message newLineCount: newLineCount tabCount: tabCount
	"EnvironmentFacade reportToConsole: 'Test' message: 'Hello, world' newLineCount: 1 tabCount: 0"
	"EnvironmentFacade reportToConsole: 'Test' message: 'Hello, world' newLineCount: 0 tabCount: 2"

	EnvironmentFacade reportToConsole: contextName message: message newLineCount: newLineCount tabCount: tabCount! !

!PassportObject methodsFor: 'console reporting' stamp: ''!
reportToConsole: message newLineCount: newLineCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 2"

	self reportToConsole: message newLineCount: newLineCount tabCount: 0! !

!PassportObject methodsFor: 'console reporting' stamp: ''!
reportToConsole: message newLineCount: newLineCount tabCount: tabCount
	"EnvironmentFacade reportToConsole: 'Hello, world' newLineCount: 0 tabCount: 2"

	self reportToConsole: self appOrLibraryName message: message newLineCount: newLineCount tabCount: tabCount! !

!PassportObject methodsFor: 'error signalling' stamp: ''!
signal: anExceptionFactory message: message
	^EnvironmentFacade signal: anExceptionFactory message: message contextName: self class name! !

!PassportObject methodsFor: 'error signalling' stamp: ''!
signal: anExceptionFactory message: message contextName: contextName
	"Using <anExceptionFactory>, raise an exception with the given <message>"

	^EnvironmentFacade signal: anExceptionFactory message: message contextName: contextName! !

!PassportObject methodsFor: 'error signalling' stamp: ''!
signalError: message
	"Using the general 'Error' exception factory, raise an exception with the given <message>"

	^self signal: Error message: message! !

PassportObject subclass: #ResourceBroker
	instanceVariableNames: 'context baseDirectoryKey factory decodeSelector encodeSelector streamType elementExtension'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!ResourceBroker methodsFor: 'accessing-remote values' stamp: ''!
at: key ifAbsent: ifAbsentBlock 
	^self 
		readStreamAt: key
		do: [:stream | self valueFromStream: stream]
		ifAbsent: [^ifAbsentBlock value]! !

!ResourceBroker methodsFor: 'accessing-remote values' stamp: ''!
at: key ifAbsentPut: valueBlock 
	^self 
		readStreamAt: key
		do: [:stream | self valueFromStream: stream]
		ifAbsentThenWriteStreamAt: key do: [:stream | self storeValue: valueBlock value on: stream]! !

!ResourceBroker methodsFor: 'accessing-remote values' stamp: ''!
at: readKey ifAbsentThenAt: writeKey put: valueBlock 
	^self 
		readStreamAt: readKey
		do: [:stream | self valueFromStream: stream]
		ifAbsentThenWriteStreamAt: writeKey do: [:stream | self storeValue: valueBlock value on: stream]! !

!ResourceBroker methodsFor: 'accessing-remote values' stamp: ''!
at: key put: aValue
	self 
		writeStreamAt: key
		do: [:stream | self storeValue: aValue on: stream].
	^aValue! !

!ResourceBroker methodsFor: 'private' stamp: ''!
baseDirectory
	^self context 
		resourcePathTo: self baseDirectoryKey
		ifNone: [self context defaultResourcePath]! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
baseDirectoryKey
	^baseDirectoryKey! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
baseDirectoryKey: anObject
	baseDirectoryKey := anObject! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
context
	^context == nil
		ifTrue: [ResourcePathContext default]
		ifFalse: [context]! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
context: aResourcePathContext
	context := aResourcePathContext! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
decodeSelector
	^decodeSelector! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
decodeSelector: aSymbol
	decodeSelector := aSymbol! !

!ResourceBroker methodsFor: 'private' stamp: ''!
defaultDecodeSelector
	^#decodeFrom:! !

!ResourceBroker methodsFor: 'private' stamp: ''!
defaultEncodeSelector
	^#encodeOn:! !

!ResourceBroker methodsFor: 'private' stamp: ''!
defaultStreamType
	^#text! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
elementExtension
	^elementExtension! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
elementExtension: anObject
	elementExtension := anObject! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
encodeSelector
	^encodeSelector! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
encodeSelector: aSymbol
	encodeSelector := aSymbol! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
factory
	^factory! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
factory: anObject
	factory := anObject! !

!ResourceBroker methodsFor: 'queries' stamp: ''!
includesKey: key
	^(self resourcePathForKey: key createBaseDirIfAbsent: false) exists! !

!ResourceBroker methodsFor: 'initialize-release' stamp: ''!
initialize
	encodeSelector := self defaultEncodeSelector.
	decodeSelector := self defaultDecodeSelector.! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
newReferenceTo: key
	^ExternalResourceReference new
		broker: self;
		key: key! !

!ResourceBroker methodsFor: 'private' stamp: 'pad 03/07/2011 16:31'!
readStreamAt: key do: block1 ifAbsent: ifAbsentBlock
	| rp stream value |
	rp := self resourcePathForKey: key createBaseDirIfAbsent: false.

	rp exists ifFalse: [^ifAbsentBlock value].

	[stream := self readStreamFrom: rp.	
	value := block1 value: stream.
	] ensure: [stream close].

	^value! !

!ResourceBroker methodsFor: 'private' stamp: ''!
readStreamAt: readKey do: readStreamBlock1 ifAbsentThenWriteStreamAt: writeKey do: writeStreamBlock1
	| rp stream value |
	rp := self resourcePathForKey: readKey createBaseDirIfAbsent: false.
	rp exists 
		ifTrue: 
			[[stream := self readStreamFrom: rp.
			value := readStreamBlock1 value: stream] ensure: [stream close]]
		ifFalse: 
			[readKey = writeKey ifFalse: [rp := self resourcePathForKey: writeKey createBaseDirIfAbsent: true].
			rp prefix makeDirectory.
			[stream := self writeStreamFrom:  rp.
			value := writeStreamBlock1 value: stream] ensure: [stream close]].
	^value! !

!ResourceBroker methodsFor: 'private' stamp: ''!
readStreamFrom: aResoucePath
	^aResoucePath readStreamWithType: self streamType! !

!ResourceBroker methodsFor: 'accessing-remote values' stamp: ''!
removeKey: aKey ifAbsent: aBlock
	| rp inactive |
	rp := self resourcePathForKey: aKey createBaseDirIfAbsent: false.
	rp exists ifFalse: [^aBlock value].
	inactive := rp withoutExtension.
	inactive exists ifTrue: [inactive delete].
	rp renameTo: inactive.
	^nil! !

!ResourceBroker methodsFor: 'private' stamp: ''!
resourcePathForKey: aKey createBaseDirIfAbsent: createBaseDirIfAbsent 
	| rp |
	rp := self baseDirectory.
	rp exists
		ifFalse: 
			[createBaseDirIfAbsent 
				ifTrue: [rp makeDirectory]
				ifFalse: 
					[(self context handleNonExistenceOfResourcePathReferencedBy: self baseDirectoryKey)
						ifTrue: [rp := self baseDirectory]
						ifFalse: [rp := self context defaultResourcePath]]].
	^(rp , ((Pathname fromString: aKey)) appendingExtension: elementExtension)! !

!ResourceBroker methodsFor: 'private' stamp: ''!
storeValue: aValue on: stream
	aValue perform: encodeSelector with: stream.
	self streamTypeIsText ifTrue: [stream cr].
	^aValue! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
streamType
	^streamType == nil ifTrue: [self defaultStreamType]! !

!ResourceBroker methodsFor: 'accessing' stamp: ''!
streamType: aSymbol
	streamType := aSymbol! !

!ResourceBroker methodsFor: 'testing' stamp: ''!
streamTypeIsBinary
	^self streamType == #binary! !

!ResourceBroker methodsFor: 'testing' stamp: ''!
streamTypeIsText
	^self streamType == #text! !

!ResourceBroker methodsFor: 'private' stamp: 'PaulDeBruicker 03/07/2011 17:48'!
valueFromStream: stream
|x|

	x:=factory perform: decodeSelector with: stream.
	
	
	
	
	
	^x! !

!ResourceBroker methodsFor: 'private' stamp: ''!
writeStreamAt: key do: block1
	| rp stream value |
	rp := self resourcePathForKey: key createBaseDirIfAbsent: true.
	rp prefix makeDirectory.
	[stream := self writeStreamFrom: rp.	
	value := block1 value:  stream] ensure: [stream close].
	^value! !

!ResourceBroker methodsFor: 'private' stamp: ''!
writeStreamFrom: aResoucePath
	^aResoucePath writeStreamWithMode: #truncate check: false type: self streamType! !

PassportObject subclass: #ResourcePathContext
	instanceVariableNames: 'defaultProtocol facadesByProtocol defaultHostNamesAndPortsByProtocol defaultNamespacesByProtocol pathMap pathDescriptions defaultUser defaultPassword'
	classVariableNames: 'Default DefaultPortsByProtocol PlatformDefault'
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!ResourcePathContext class methodsFor: 'class initialization' stamp: ''!
basicInvalidateFacades
	self allInstancesDo: [:each | each initializeFacades]! !

!ResourcePathContext class methodsFor: 'accessing' stamp: ''!
default
	"Answer the default instance of the receiver"

	"ResourcePathContext default"

	Default == nil ifTrue: [^self platformDefault].
	^Default! !

!ResourcePathContext class methodsFor: 'accessing' stamp: ''!
defaultPortAt: protocolSymbol
	DefaultPortsByProtocol == nil ifTrue: [self setDefaultPortsByProtocol].
	^DefaultPortsByProtocol at: protocolSymbol ifAbsent: [-1]! !

!ResourcePathContext class methodsFor: 'class initialization' stamp: ''!
initialize
	"ResourcePathContext initialize"

	Default := nil.
	PlatformDefault := nil.
	DefaultPortsByProtocol := nil! !

!ResourcePathContext class methodsFor: 'private' stamp: ''!
initializeWithDefaultPorts: aResourcePathContext
	DefaultPortsByProtocol == nil ifTrue: [self setDefaultPortsByProtocol].
	DefaultPortsByProtocol 
		keysAndValuesDo: [:protocol :port | aResourcePathContext defaultPortAt: protocol put: port]! !

!ResourcePathContext class methodsFor: 'class initialization' stamp: ''!
invalidateFacades
	self basicInvalidateFacades.
	self subclasses do: [:each | each invalidateFacades]! !

!ResourcePathContext class methodsFor: 'accessing' stamp: ''!
platformDefault
	"Answer the default instance of the receiver for use with resources on the host platform"

	"ResourcePathContext platformDefault"

	PlatformDefault == nil ifTrue: [self new bePlatformDefault].
	^PlatformDefault! !

!ResourcePathContext class methodsFor: 'private' stamp: ''!
setDefaultPortsByProtocol
	DefaultPortsByProtocol := IdentityDictionary new.
	DefaultPortsByProtocol
		at: #platform put: -1;
		at: #file put: -1;
		at: #http put: 80;
		at: #https put: 443;
		at: #ftp put: 21;
		at: #ldap put: 389! !

!ResourcePathContext methodsFor: 'initialize-release' stamp: ''!
beDefault
	Default := self! !

!ResourcePathContext methodsFor: 'initialize-release' stamp: ''!
bePlatformDefault
	PlatformDefault := self! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultFacade
	^self facadeAt: self defaultProtocol! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultHostnameAt: protocolSymbol
	^self defaultHostnameAt: protocolSymbol ifAbsent: [#localhost]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultHostnameAt: protocolSymbol ifAbsent: ifAbsent 
	| hostname |
	hostname := (defaultHostNamesAndPortsByProtocol at: protocolSymbol ifAbsent: [^ifAbsent value]) key.
	^hostname == nil 
		ifTrue: [ifAbsent value]
		ifFalse: [hostname]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultHostnameAt: protocolSymbol put: aStringOrSymbol 
	^(defaultHostNamesAndPortsByProtocol at: protocolSymbol
		ifAbsentPut: [Association new]) key: 
			(aStringOrSymbol == nil 
				ifTrue: [#localhost]
				ifFalse: [aStringOrSymbol asSymbol])! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultNamespaceAt: protocolSymbol ifAbsent: ifAbsent 
	^defaultNamespacesByProtocol at: protocolSymbol ifAbsent: ifAbsent! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultNamspaceAt: protocolSymbol put: aStringOrNil
	(UtilityFunction isNilOrEmpty: aStringOrNil)
		ifTrue: [defaultNamespacesByProtocol removeKey: protocolSymbol ifAbsent: []]
		ifFalse: [defaultNamespacesByProtocol at: protocolSymbol put: aStringOrNil]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultPassword
	^defaultPassword! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultPassword: aString
	defaultPassword := aString == nil ifTrue: [''] ifFalse: [aString]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultPortAt: protocolSymbol
	^self defaultPortAt: protocolSymbol ifAbsent: [-1]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultPortAt: protocolSymbol ifAbsent: ifAbsent 
	| port |
	port := (defaultHostNamesAndPortsByProtocol at: protocolSymbol ifAbsent: [^ifAbsent value]) value.
	^port == nil 
		ifTrue: [ifAbsent value]
		ifFalse: [port]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultPortAt: protocolSymbol put: portNumber
	^(defaultHostNamesAndPortsByProtocol at: protocolSymbol ifAbsentPut: [nil->nil]) value: portNumber! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultProtocol
	^defaultProtocol! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultProtocol: protocolSymbol
	defaultProtocol := protocolSymbol == nil ifTrue: [#platform] ifFalse: [protocolSymbol asSymbol]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultResourcePath
	^ResourcePath context: self! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultUser
	^defaultUser! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
defaultUser: aString
	defaultUser := aString == nil ifTrue: [''] ifFalse: [aString]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
facadeAt: protocolSymbol
	protocolSymbol == nil ifTrue: [self signalError: 'Resource access protocol must not be nil'].
	^self facadeAt: protocolSymbol ifAbsent: [self signalError: 'Resource access protocol not supported: ', protocolSymbol]! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
facadeAt: protocolSymbol ifAbsent: ifAbsent 
	^facadesByProtocol at: protocolSymbol
		ifAbsentPut: 
			[((EnvironmentFacade current
				resourcePathFacadeFactoryReferenceAt: protocolSymbol
				ifAbsent: [^ifAbsent value]) valueIfNone: [^ifAbsent value]) resourcePathContext: self]! !

!ResourcePathContext methodsFor: 'error signalling/handling' stamp: ''!
handleNonExistenceOfResourcePathReferencedBy: semanticKey
	self reportInaccessibleResourcePath: semanticKey.	
	^false! !

!ResourcePathContext methodsFor: 'testing' stamp: ''!
hasDefaultPassword
	^(UtilityFunction isNilOrEmpty: self defaultPassword) not! !

!ResourcePathContext methodsFor: 'testing' stamp: ''!
hasDefaultUser
	^(UtilityFunction isNilOrEmpty: self defaultUser) not! !

!ResourcePathContext methodsFor: 'initialize-release' stamp: ''!
initialize
	self initializeFacades.
	self initializeDefaults.
	self initializePathMap! !

!ResourcePathContext methodsFor: 'initialize-release' stamp: ''!
initializeDefaults
	defaultProtocol := #platform.
	self initializePasswords.	
	defaultHostNamesAndPortsByProtocol := IdentityDictionary new.
	defaultNamespacesByProtocol := IdentityDictionary new.
	self class initializeWithDefaultPorts: self.! !

!ResourcePathContext methodsFor: 'initialize-release' stamp: ''!
initializeFacades
	facadesByProtocol := IdentityDictionary new.! !

!ResourcePathContext methodsFor: 'initialize-release' stamp: ''!
initializePasswords
	defaultUser := ''.
	defaultPassword := ''.! !

!ResourcePathContext methodsFor: 'initialize-release' stamp: ''!
initializePathMap
	pathMap := IdentityDictionary new.
	pathDescriptions := IdentityDictionary new.! !

!ResourcePathContext methodsFor: 'testing' stamp: ''!
isDefault
	^self == self class default! !

!ResourcePathContext methodsFor: 'testing' stamp: ''!
isNonBinding
	^self isPlatformDefault! !

!ResourcePathContext methodsFor: 'testing' stamp: ''!
isPlatformDefault
	^self == PlatformDefault! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
pathDescriptionAt: semanticKey ifNone: ifNone
	^pathDescriptions at: semanticKey ifAbsent: ifNone! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
pathDescriptionAt: semanticKey put: aString
	pathDescriptions at: semanticKey put: aString! !

!ResourcePathContext methodsFor: 'copying' stamp: ''!
postCopy
	"PRECONDTION: The receiver has just been instantiated as a #shallowCopy of another object.  
	POSTCONDITION: In response to this message, the receiver is required to make itself satisfy the following conditions and constraints: 1) It must be mutable,  2) It must compare (#=) as equal to the object from which it was shallowCopied, and 3) It must satisfy the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the object from which it was shallowCopied must not be changed, and b) whenever the object from which the receiver was shallowCopied mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the receiver must not be changed.  An associative reference is one where the semantics of the reference depend in any way on the object identity (#==) of the referenced object.  An attributive reference is one where any referenced object with the same value can transparently be substituted for any other such value-equivalent object without causing any error."

	"Subclasses may need to subimplement this message in order to satisfy the required semantics.  All subimplementers should send #postCopy to super."

	EnvironmentFacade current makeMutable: self.
	facadesByProtocol := facadesByProtocol copy.
	defaultHostNamesAndPortsByProtocol := defaultHostNamesAndPortsByProtocol copy.
	defaultNamespacesByProtocol := defaultNamespacesByProtocol copy.
	pathMap := pathMap copy.! !

!ResourcePathContext methodsFor: 'error signalling/handling' stamp: ''!
reportInaccessibleResourcePath: aResourcePathKey 
	| rp description |
	rp := self resourcePathTo: aResourcePathKey ifNone: [].
	description := self pathDescriptionAt: aResourcePathKey
				ifNone: ['The ' , aResourcePathKey , ' persistent/remote resource'].
	self reportToConsole: description , ' was not accessible at the path ' 
				, (rp == nil 
						ifTrue: [aResourcePathKey printString]
						ifFalse: [rp printString])! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
resourcePathTo: semanticKey ifNone: ifNone
	"Answer a ResourcePath to the absolute resource pathname signified by the specified <semanticKey> (aSymbol.) The <semanticKey> identifies the logical role, function, purpose or intended usage of the resource, and does not explicitly describe or contain the name of any resource. It is the responsibility of the receiver to maintain a mapping from resource semantic keys to resource pathnames, and to construct ResourcePaths based on the name of the resource identified by the <semanticKey>.  Since Chronos only needs to use a small set of semantic keys for resources, it is acceptable to simply 'hard code' the mappings from <semanticKey> to resource pathname.  But ideally, the mapping information sould be maintained in a configuration file, database or remote reference data server.

	The well-known pathnames and associated semantic keys used by the Chronos codebase:
		
		Semantic Key							Role/function/purpose/usage of associated pathname

		#TZRepository							The directory that contains the Chronos TimeZone specification files, and the zone alias file
													(these files are generated by the Chronos TimeZone Administrator.)
		#TZLocalizationPolicyRepository		The directory that contains the Chronos TimeZoneLocalizationPolicy definition files
													(the default versions of these files are generated by the Chronos TimeZone Administrator.)
		#TZForeignKeyMappings				The directory that contains files that associate foreign timezone keys with those used by Chronos.
		#OlsonZoneInfoSourcesDirectory	The directory/folder containing the source files (text) for the Olson Timezone Database 
													(used only by the Chronos TimeZone Administrator.)"

	^pathMap at: semanticKey ifAbsent: ifNone! !

!ResourcePathContext methodsFor: 'accessing' stamp: ''!
resourcePathTo: semanticKey put: aResourcePath
	pathMap at: semanticKey put: aResourcePath! !

!ResourcePathContext methodsFor: 'enumerating' stamp: ''!
resourcePathsDo: block2
	pathMap keysAndValuesDo: block2! !

!ResourcePathContext methodsFor: 'queries' stamp: ''!
resourcePathsExist

	self resourcePathsDo: [:key :rp | rp exists ifFalse: [^false]].
	^true! !

!ResourcePathContext methodsFor: 'testing' stamp: ''!
specifiesDefaultNamespaceAt: protocolSymbol 
	^defaultNamespacesByProtocol includesKey: protocolSymbol! !

PassportObject subclass: #ResourcePathFacade
	instanceVariableNames: 'resourcePathContext rootDirectoryMetavalueString defaultRootDirectoryString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!ResourcePathFacade commentStamp: '<historical>' prior: 0!
ResourcePathFacade

	Concept:

		The Passport inter-Smalltalk portability library uses an instance of a concrete subclass of the abstract class ResourcePathFacade as a facade for accessing remote and/or persistent resources--resources that would usually, but not necessarily, reside in files contained in a file system. Unfortunately the API (or perhaps the language syntax) for performing such functions is generally different accross implementations of Smalltalk--and that fact is the primary motivation for the existence of this class. 

		In addition to cross-platform portability, ResourcePathFacade is intended to enable access to resources that don't reside as local flat files--and perhaps aren't resident in files at all..

	Usage:

		Instances of concrete subclasses may or may not be stateless--so in general there is no canonical instance, and neither the Singleton nor the Flyweight patterns are assumed by the abstract superclass.

		Instantiation  

			A new instance of a ResourcePathFacade is created by sending the message #new to its class. 

		External/Persistent/Remote Resource Operations

			The Passport inter-Smalltalk portability library uses instances of the class ResourcePath (which see) in order to open external streams connected to external resources (e.g, files) for the purpose of storing/retrieving application reference data.  ResourcePaths depend upon services provided by a ResourcePathFacade instance for the implementation of their functionality.  Such services include: a) interconversion between ResourcePaths and whatever objects the native Smalltalk implementation uses to specify external/persistent/remote resources (instances of Filename in VisualWorks, instances of String more typically)--although URIs could also be used; b) "directory operations" by which external resources can be created, copied, removed, relocated and renamed, and by which external "file systems" (or more generally, namespaces containing external/persistent/remote resources  (e.g.. LDAP)) can be introspected/navigated; and c) stream creation operations for opening streams on the contents of external/persistent/remote resources (whose API is based on the API for external stream creation specified by the ANSI Smalltalk standard.)   Such services/operations must be provided by the ResourcePathFacade because their implementation is highly non-portable among the various Smalltalk implementations, and also because some applications and/or  code libraries may want/need to use something other than disk files to store/reftrieve their reference data.

	Motivation:

		By concentrating all system-specific code in the class hierarchies of ResourcePathFacade and EnvironmentFacade, and by defining a standard API for the invocation of non-portable services, ResourcePathFacade enhances the portability of the applications and libraries written in Smalltalk, both with respect to different implementations/versions of Smalltalk and also with respect to the varying needs and preferences of applications and/or code libraries.

	Implementation:

	Subclassing:

		ResourcePathFacade is an abstract class.  A concrete subclass appropriate for use on a particular platform, in a particular system environment, for use by a particular client application, must be provided.  The instance methods that MUST be subimplemented in order to provide a fully operational ResourcePathFacade object (all of which have method comments documenting the behavior for which the method is responsible) are as follows:

			Method Selector																		Subimplmentation Requirement

			#constructResourcePathFromNativeResourceID:								Mandatory--must have substantive implementation
			#resourceExists:																	Mandatory--must have substantive implementation
			#resourceIsDirectory:																Mandatory--must have substantive implementation
			#makeDirectory:																	Mandatory--must have substantive implementation
			#newExternalReadStream:type:													Mandatory--must have substantive implementation
			#newExternalWriteStream:mode:check:type: 									Mandatory--must have substantive implementation
			#renameResource:to:																Mandatory--must have substantive implementation
			#withResourcePathsOfResourcesInDirectory:do:								Mandatory--must have substantive implementation

		Additionaly, the following instance methods may require subimplementation in some cases--Chronos doesn't use them, but users of Chronos might:

			Method Selector																		Subimplmentation Requirement

			#copyResource:to:																	Optional--can be no-op (present solely for API completeness.)
			#deleteResource:																	Optional--can be no-op (present solely for API completeness.)
			#moveResource:to:																	Optional--can be no-op (present solely for API completeness.)
			#sizeOfResource:																	Optional--can be no-op (present solely for API completeness.)


!

!ResourcePathFacade class methodsFor: 'instance creation' stamp: ''!
resourcePathContext: aResourcePathManager 
	^self new resourcePathContext: aResourcePathManager! !

!ResourcePathFacade methodsFor: 'private' stamp: ''!
basicPrintNamespaceOf: aResourcePath isPrefixed: isPrefixed on: stream 
	| ns |
	ns := aResourcePath basicNamespace.
	ns == nil ifTrue: [ns := self defaultNamespace].
	ns = self rootDirectoryMetavalueString 
		ifTrue: [stream nextPutAll: self defaultRootDirectoryString]
		ifFalse: 
			[ns isEmpty 
				ifTrue: [isPrefixed ifTrue: [stream nextPut: self pathnameSeparator]]
				ifFalse: 
					[isPrefixed ifTrue: [ns first = self pathnameSeparator ifFalse: [stream nextPut: self pathnameSeparator]].
					stream nextPutAll: ns.
					ns last = self pathnameSeparator 
						ifFalse: [stream nextPut: self pathnameSeparator]]]! !

!ResourcePathFacade methodsFor: 'conversion services' stamp: ''!
constructNativeResourceIDFromResourcePath: aResourcePath
	"Answer whatever value the current Smalltalk execution environment canonically would use to name/identify the external/persistent/remote resouce (e.g, a file) referenced by <aResourcePath> (.e.g, a String in Squeak, a Filename in VisualWorks, etc.)"

	^self constructNativeResourceIDFromString: (aResourcePath withProtocol: self protocol) printString! !

!ResourcePathFacade methodsFor: 'conversion services' stamp: ''!
constructNativeResourceIDFromStream: aStream
	"Answer whatever value the current Smalltalk execution environment canonically would use to name/identify the external/persistent/remote resource (e.g, a file) whose name is contained as the remaining characters in <aStream> (.e.g, a String in Squeak, a Filename in VisualWorks, etc.)"

	^self constructNativeResourceIDFromString: aStream upToEnd! !

!ResourcePathFacade methodsFor: 'conversion services' stamp: ''!
constructNativeResourceIDFromString: aString
	"Answer whatever value the current Smalltalk execution environment canonically would use to name/identify the external/persistent/remote resource (e.g, a file) referenced by <aString> (.e.g, a String in Squeak, a Filename in VisualWorks, etc.)"

	^aString
	"This may not work in any Smalltalk environment that doesn't use Strings as the canonical form of file identifiers (e.g., VisualWorks, which uses Filename objects.)"! !

!ResourcePathFacade methodsFor: 'conversion services' stamp: ''!
constructResourcePathFromNativeResourceID: aNativeResourceID
	"Construct and answer a ResourcePath that identifies the same resource (e.g, a file) as does <aNativeResourceID> (where <aNativeResourceID> is an object canonically used by the host Smalltalk implementation to name/identify external/persistent/remote resources;) in most Smalltalk implementations such an object would be a String.)"

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'conversion services' stamp: ''!
constructResourcePathFromStream: aStream
	"Construct and answer a ResourcePath that identifies the same resource (e.g., a file) as does the characters remaining in <aStream> (where those characters are assumed to specify a pathname to a resource with the same syntax as would be used by the host Smalltalk environment.)"

	^self constructResourcePathFromString: aStream upToEnd! !

!ResourcePathFacade methodsFor: 'conversion services' stamp: ''!
constructResourcePathFromString: aString
	"Construct and answer a ResourcePath that identifies the same resource (e.g., a file) as does <aString> (where <aString> is a pathname to a resource with the same syntax as would be used by the host Smalltalk environment.)"

	^self constructResourcePathFromNativeResourceID: (self constructNativeResourceIDFromString: aString)! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
copyResource: sourceOperand to: destinationOperand 
	"Copy the contents of the resource (e.g., a file) named/identified by <sourceOperand> to <destinationOperand>.  If the resource named/identified by <destinationOperand> does not exist, create it. If a resource so-named already exists, make it have exactly the same contents as the resource named/identified by <sourceNativeFileID>."

	| sourceStream targetStream |
	sourceStream := self newExternalReadStream: sourceOperand type: #binary.
	[targetStream := 
		self 
			newExternalWriteStream: destinationOperand
			mode: #truncate
			check: false
			type: #binary.
	[[sourceStream atEnd] whileFalse: [targetStream nextPut: sourceStream next]] 
		ensure: [targetStream close]] 
			ensure: [sourceStream close]! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
currentDirectoryMetavalueString
	"Answer a String that is a metavalue signifying the current derfault directory/folder." 

	^'.' "Unix/WIndows; won't work on the Macintosh (which uses ':')"! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
defaultDirectoryPathnameString
	"Answer a String that names/identifies the pathname of the external-file namespace relative to which non-absolute filenames will be interpreted.  In more conventional terminology, answer a String naming/identifying the actual full absolute pathname of the current default directory/folder.  It is acceptable, but not ideal, to answer a metavalue that serves as an indirect reference to the default directory (e.g., '.' on UNIX/Windows systems, and ':' on the Macintosh.) If not answering a metavalue, the answered String must start with the root directory of the current default volume/device (e.g., '/' on a Unix system, 'C:\' or 'D:\' (or whatever volume is the default) on a Windows system.)" 

	^self currentDirectoryMetavalueString "Not ideal--subimplementing is recommended."! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
defaultNamespace
	^self resourcePathContext isPlatformDefault 
		ifTrue: [self defaultDirectoryPathnameString]
		ifFalse: 
			[self resourcePathContext defaultNamespaceAt: self protocol
				ifAbsent: [self defaultDirectoryPathnameString]]! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
defaultRootDirectoryString
	defaultRootDirectoryString == nil ifTrue: [defaultRootDirectoryString := self newDefaultRootDirectoryString].
	^defaultRootDirectoryString! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
deleteResource: operand
	"Delete the resource (e.g., a file) named/identified by <operand>. If the resource named/identified by <operand> does not exist, raise an exception."

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
encodeString: aString on: stream
	stream nextPutAll: aString! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
fileExtensionSeparator
	"Answer the character that is used to separate file extensions from the rest of the file's name."

	^$.! !

!ResourcePathFacade methodsFor: 'initialize-release' stamp: ''!
initialize
	rootDirectoryMetavalueString := self newRootDirectoryMetavalueString.
	defaultRootDirectoryString := self newDefaultRootDirectoryString! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
makeDirectory: operand
	"Create a directory named <operand>. If the resource named/identified by <operand> already exists, raise an exception. A 'directory'  is a resource that serves as a namespace containing other resources."

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
moveResource: sourceOperand to: destinationOperand
	"Move the resource (e.g., a file) named/identified by <sourceOperand> to <destinationOperand>. If possible, implement the 'move' by removing and adding directory entries, instead of by actually copying the contents of the source resource. However, if that is not possible, then a) copy <sourceOperand> to <destinationOperand>, and then b) delete <sourceOperand>."

	self copyResource: sourceOperand to: destinationOperand.
	self deleteResource: sourceOperand! !

!ResourcePathFacade methodsFor: 'private' stamp: ''!
newDefaultRootDirectoryString
	| separator |
	separator := self pathnameSeparator.
	^separator = $: ifTrue: [''] ifFalse: [String with: separator]! !

!ResourcePathFacade methodsFor: 'stream creation' stamp: ''!
newExternalReadStream: operand type: fileType
	"Synopsis

		Returns an external readStream that reads from the external data source with the given name.

	Specification (based on ANSI Smalltalk standard)

		Locate an external data source that is identified by the value of <operand>. The <operand> parameter is an instance of whatever class the host Smalltalk implementation would canonically use to identify an external data source (e.g., a Strring, a Filename, a URL, etc.)  If <operand> is a String (or if its content requires syntactical interpretation,) then its syntax is implementation-dependent.

		Return an object conforming to the ANSI <readFileStream> protocol whose future sequence values initially consist of the elements of the external data source and which initially has no past sequence values. The ordering of the sequence values is the same as the ordering within the external data source. The external data source serves as the stream backing store of the returned object. The value of <fileType> determines the external stream type and sequence value type of the result object.

	Parameters

		operand 		<readableString> 	identifies the external data source (typically, but not necessarily, a disk file)
		fileType		<symbol> 			an enumeration constant that specifies the type of the external data source, as defined by the ANSI Smalltalk standard

	Return Value

		<readFileStream> new

	Errors

		It is an error if the data source identified by <operand> does not exist, or if the user does not have read access permission"

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'stream creation' stamp: ''!
newExternalWriteStream: operand mode: mode check: enforceExistentialConstraint type: fileType
	"Synopsis

		Returns an external writeStream that writes to the external data source with the given name.

	Specification (based on ANSI Smalltalk standard)

		Depending upon the values of <enforceExistentialConstraint> and <mode>, either a) create a new external data source, or b) locate an existing external data source, which in either case is identified by the value of <operand>. The <operand> parameter is an instance of whatever class the host Smalltalk implementation would canonically use to identify an external data source (e.g., a Strring, a Filename, a URL, etc.)  If <operand> is a String (or if its content requires syntactical interpretation,) then its syntax is implementation-dependent.

		Return an object conforming to the ANSI Smalltalk <writeFileStream> protocol. The external data source serves as the stream backing store of the returned object. The returned object is a write-back stream. The value of <fileType> determines the external stream type and sequence value type of the result object.

		Valid values for <mode> are: #create, #append, and #truncate. The meaning of these values are:

				#create create a new external data source, with initial position at the beginning
				#append use an existing external data source, with initial position at its end
				#truncate use an existing external data source, initially truncating it.

		The value of <mode> determines the initial state of the past sequence values and future sequence values of the result object. If <mode> is #create or #truncate the past sequence values and future sequence values are both initially empty. If <mode> is #append the past sequence values initially consist of the elements of the external data source and future sequence values is initially empty. The ordering of the sequence values is the same as the ordering within the external data source. The <enforceExistentialConstraint> flag determines whether the data source specified by <operand> must exist or not exist.

		If <mode> = #create and <enforceExistentialConstraint> = false and the data source exists, then the existing file is used.
		If <mode> = #append and <enforceExistentialConstraint> = false and the data source does not exist, then it is created.
		If <mode> = #truncate and <enforceExistentialConstraint> = false and the data source  does not exist, then it is created.

		This operation is undefined if a value other than #create, #append or #truncate is used as the <mode> argument.

	Parameters

		operand 						<readableString> 	identifies the external data source (typically, but not necessarily, a disk file)
		mode 						<symbol> 			an enumeration constant that specifies the initial state of the external stream, as defined by the ANSI Smalltalk standard
		enforceExistentialConstraint 	<boolean> 			specifies whether or not the existence or non-existence of the data source identified by <operand> is an error
		fileType						<symbol> 			an enumeration constant that specifies the type of the external data source, as defined by the ANSI Smalltalk standard

	Return Value

		<writeFileStream> new

	Errors

		If <mode> = #create and <enforceExistentialConstraint> = true and the file exists.
		If <mode> = #append and <enforceExistentialConstraint> = true and the file does not exist.
		If <mode> = #truncate and <enforceExistentialConstraint> = true and the file does not exist.
		If the user does not have write permissions for the external data source.
		If the user does not have creation permissions for an external data source that is to be created."

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'private' stamp: ''!
newResourcePath
	^(ResourcePath new)
		setResourcePathContext: self resourcePathContext;
		setProtocol: self protocol! !

!ResourcePathFacade methodsFor: 'private' stamp: ''!
newRootDirectoryMetavalueString
	^String with: (Character codePoint: 0)! !

!ResourcePathFacade methodsFor: 'conversion services' stamp: 'PaulDeBruicker 03/04/2011 14:10'!
operandFromResourcePath: aResourcePath
	^aResourcePath asNative! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
pathnameSeparator
	"Answer the character that is used to separate file pathname components (in other words, the directory separator character.)"

	^$/! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
print: aResourcePath on: stream 
	self syntaxPermitsProtocol ifTrue: [self printProtocolOf: aResourcePath on: stream].
	(self syntaxRequiresHostname or: [aResourcePath isRemote])
		ifTrue: 
			[self printAuthorityOf: aResourcePath on: stream.
			self printNamespaceOf: aResourcePath isPrefixed: true on: stream]
		ifFalse: [self printNamespaceOf: aResourcePath isPrefixed: false on: stream].
	self printPathnameOf: aResourcePath on: stream.
	self syntaxPermitsQueryString ifTrue: [self printQueryOf: aResourcePath on: stream].
	self syntaxPermitsFragment ifTrue: [self printFragmentOf: aResourcePath on: stream].! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
printAuthorityOf: aResourcePath on: stream 
	| separator credentialsPrinted hasDefaultPort |
	separator := self pathnameSeparator.
	stream
		nextPut: separator;
		nextPut: separator.
	credentialsPrinted := false.
	self syntaxPermitsUserCredentials 
		ifTrue: [credentialsPrinted := self printUserAndPasswordOf: aResourcePath on: stream].
	hasDefaultPort := aResourcePath hasDefaultPort.
	(credentialsPrinted or: [self syntaxRequiresHostname or: [aResourcePath isRemote or: [hasDefaultPort not]]]) 
		ifTrue: [stream nextPutAll: aResourcePath hostname].
	hasDefaultPort 
		ifFalse: 
			[stream 
				nextPut: $:;
				print: aResourcePath port].! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
printFragmentOf: aResourcePath on: stream 
	aResourcePath hasFragment 
		ifTrue: 
			[stream nextPut: $#.
			self encodeString: aResourcePath fragment on: stream]! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
printNamespaceOf: aResourcePath isPrefixed: isPrefixed on: stream 
	| separator |
	separator := self pathnameSeparator.
	aResourcePath specifiesNamespace 
		ifTrue: [self basicPrintNamespaceOf: aResourcePath isPrefixed: isPrefixed on: stream]
		ifFalse: 
			[isPrefixed 
				ifTrue: [stream nextPut: separator]
				ifFalse: 
					[stream nextPutAll: self currentDirectoryMetavalueString.
					aResourcePath pathnameIsEmpty ifFalse: [stream nextPut: separator]]]! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
printPathnameOf: aResourcePath on: stream 
	aResourcePath pathnameIsEmpty 
		ifFalse: [aResourcePath pathname printOn: stream usingSeparator: self pathnameSeparator]! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
printProtocolOf: aResourcePath on: stream 
	stream
		nextPutAll: self protocol;
		nextPut: $:! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
printQueryOf: aResourcePath on: stream 
	| count |
	count := aResourcePath queryCount.
	count > 0
		ifTrue: 
			[stream nextPut: $?.
			aResourcePath 
				queryKeysAndValuesDo:
					[:key :value | 
					self encodeString: key isInQuery: true on: stream.
					stream nextPut: $=.
					self encodeString: value isInQuery: true on: stream.
					count := count - 1.
					count > 0 ifTrue: [stream nextPut: $&]]]! !

!ResourcePathFacade methodsFor: 'printing services' stamp: ''!
printUserAndPasswordOf: aResourcePath on: stream 
	^aResourcePath specifiesUser 
		ifTrue: 
			[self encodeString: aResourcePath user on: stream.
			aResourcePath specifiesPassword 
				ifTrue: 
					[stream nextPut: $:.
					self encodeString: aResourcePath password on: stream].
			stream nextPut: $@.
			true]
		ifFalse: 
			[aResourcePath specifiesPassword 
				ifTrue: 
					[stream nextPut: $:.
					self encodeString: aResourcePath password on: stream.
					stream nextPut: $@.
					true]
				ifFalse: [false]]! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
protocol
	^#platform! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
renameResource: originalOperand to: newOperand
	"Rename the resource (e.g., a file) named/identified by <originalOperand> to <newOperand>"

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
resourceExists: operand
	"Answer whether the resource (e.g., a file) named/identified by <operand> exists"

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
resourceIsDirectory: operand
	"Answer whether the resource (e.g., a file) named/identified by <operand> is a directory.  A resource is a directory if it acts as a namespace containing other resources."

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
resourcePathContext
	^resourcePathContext == nil 
		ifTrue: 
			[self protocol == #platform 
				ifTrue: [ResourcePathContext platformDefault]
				ifFalse: [ResourcePathContext default]]
		ifFalse: [resourcePathContext]! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
resourcePathContext: aResourcePathContext
	resourcePathContext := aResourcePathContext.! !

!ResourcePathFacade methodsFor: 'accessing' stamp: ''!
rootDirectoryMetavalueString
	"Answer a String that is a metavalue signifying the current derfault directory/folder." 

	rootDirectoryMetavalueString == nil ifTrue: [rootDirectoryMetavalueString := self newRootDirectoryMetavalueString].
	^rootDirectoryMetavalueString! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
sizeOfResource: operand
	"Answer the size (in bytes) of the resource (e.g., a file) named/identified by <operand>"

	^self subclassResponsibility! !

!ResourcePathFacade methodsFor: 'testing' stamp: ''!
syntaxPermitsFragment
	^false! !

!ResourcePathFacade methodsFor: 'testing' stamp: ''!
syntaxPermitsHostname
	^true! !

!ResourcePathFacade methodsFor: 'testing' stamp: ''!
syntaxPermitsPort
	^false! !

!ResourcePathFacade methodsFor: 'testing' stamp: ''!
syntaxPermitsProtocol
	^false! !

!ResourcePathFacade methodsFor: 'testing' stamp: ''!
syntaxPermitsQueryString
	^false! !

!ResourcePathFacade methodsFor: 'testing' stamp: ''!
syntaxPermitsUserCredentials
	^false! !

!ResourcePathFacade methodsFor: 'testing' stamp: ''!
syntaxRequiresHostname
	^false! !

!ResourcePathFacade methodsFor: 'directory services' stamp: ''!
withResourcePathsOfResourcesInDirectory: operand do: block1
	"For each external/persistent/remote resource (e.g., a file) contained by the resource directory named/identified by <operand>, evaluate the one-argument Block <block1> with an argument that is a ResourcePath (which see) naming/identifying the external/persistent/remote resource (e.g, a file.) If <operand> does not name/identify a directory, raise an exception."

	^self subclassResponsibility! !

ResourcePathFacade subclass: #UrlPathFacade
	instanceVariableNames: ''
	classVariableNames: 'TransparentCharSet'
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!UrlPathFacade class methodsFor: 'class initialization' stamp: ''!
initialize
	"UrlPathFacade initialize"

	TransparentCharSet := Set new.
	$A codePoint to: $Z codePoint do: [:codePoint | TransparentCharSet add: (Character codePoint: codePoint)].
	$a codePoint to: $z codePoint do: [:codePoint | TransparentCharSet add: (Character codePoint: codePoint)].
	$0 codePoint to: $9 codePoint do: [:codePoint | TransparentCharSet add: (Character codePoint: codePoint)].
	TransparentCharSet 
		add: $';
		addAll: '-_.!!~*()'! !

!UrlPathFacade methodsFor: 'conversion services' stamp: ''!
constructResourcePathFromNativeResourceID: aNativeResourceID
	"Construct and answer a ResourcePath that identifies the same resource (e.g, a file) as does <aNativeResourceID> (where <aNativeResourceID> is an object canonically used by the host Smalltalk implementation to name/identify external/persistent/remote resources;) in most Smalltalk implementations such an object would be a String.)"

	^ResourcePath 
		fromString: aNativeResourceID asString 
		withContext: self resourcePathContext! !

!UrlPathFacade methodsFor: 'conversion services' stamp: ''!
constructResourcePathFromStream: stream
	"Construct and answer a ResourcePath that identifies the same resource (e.g., a file) as does the characters remaining in <aStream> (where those characters are assumed to specify a pathname to a resource with the same syntax as would be used by the host Smalltalk environment.)"
	| slashCount rp index pathname component |
	rp := self newResourcePath.
	slashCount := 0.
	(stream peekFor: $/) ifTrue: [slashCount := slashCount + 1].
	(stream peekFor: $/) ifTrue: [slashCount := slashCount + 1].
	slashCount = 2 ifTrue: [self parseAuthorityFrom: stream into: rp].
	index := 0.
	pathname := UtilityFunction nextFrom: stream until: [:ch | (index := #($? $#) indexOf: ch ifAbsent: [0]) > 0].
	pathname := Pathname readFrom: pathname readStream separator: $/ transformer: [:segment | self decodeStringFrom: segment readStream].
	slashCount > 0 
		ifTrue: 
			[pathname componentCount > 0
				ifTrue:
					[component := pathname componentAt: 1.
					(component size > 0 and: [component last = $:]) 
						ifTrue: 
							[rp setNamespace: component.
							pathname := pathname suffixFrom: 2]
						ifFalse: [rp setNamespace: self rootDirectoryMetavalueString]]
				ifFalse: [rp setNamespace: self rootDirectoryMetavalueString]].
	rp setPathname: pathname.
	index > 0 ifTrue: [self parseQueryStringAndFragmentFrom: stream into: rp].
	^rp beImmutable! !

!UrlPathFacade methodsFor: 'conversion services' stamp: ''!
constructResourcePathFromString: aString
	"Construct and answer a ResourcePath that identifies the same resource (e.g., a file) as does <aString> (where <aString> is a pathname to a resource with the same syntax as would be used by the host Smalltalk environment.)"

	^self constructResourcePathFromStream: aString readStream! !

!UrlPathFacade methodsFor: 'conversion services' stamp: ''!
decodeFrom: readStream isInQuery: isInQuery onto: writeStream 
	| ch |
	[readStream atEnd] whileFalse: 
			[(readStream peekFor: $%) 
				ifTrue: 
					[writeStream nextPut: 
						(Character codePoint: readStream next digitValue * 16 + readStream next digitValue)]
				ifFalse: 
					[isInQuery 
						ifTrue: 
							[ch := readStream next.
							ch = $+
								ifTrue: [writeStream space]
								ifFalse: [writeStream nextPut: ch]]
						ifFalse: [writeStream nextPut: readStream next]]]! !

!UrlPathFacade methodsFor: 'conversion services' stamp: ''!
decodeStringFrom: readStream
	"UrlPathFacade new decodeStringFrom: 'A%20B' readStream"

	| writeStream |
	writeStream := (String new: 32) writeStream.
	self decodeFrom: readStream isInQuery: false onto: writeStream.
	^writeStream contents! !

!UrlPathFacade methodsFor: 'conversion services' stamp: ''!
decodeStringInQueryFrom: readStream
	"UrlPathFacade new decodeStringInQueryFrom: 'A+B' readStream"

	| writeStream |
	writeStream := (String new: 32) writeStream.
	self decodeFrom: readStream isInQuery: true onto: writeStream.
	^writeStream contents! !

!UrlPathFacade methodsFor: 'accessing' stamp: ''!
defaultDirectoryPathnameString
	"Answer a String that names/identifies the pathname of the external-file namespace relative to which non-absolute filenames will be interpreted.  In more conventional terminology, answer a String naming/identifying the actual full absolute pathname of the current default directory/folder.  It is acceptable, but not ideal, to answer a metavalue that serves as an indirect reference to the default directory (e.g., '.' on UNIX/Windows systems, and ':' on the Macintosh.) If not answering a metavalue, the answered String must start with the root directory of the current default volume/device (e.g., '/' on a Unix system, 'C:\' or 'D:\' (or whatever volume is the default) on a Windows system.)" 

	^self protocol, ':///'! !

!UrlPathFacade methodsFor: 'accessing' stamp: ''!
defaultNamespace
	| ns |
	ns := self resourcePathContext defaultNamespaceAt: self protocol ifAbsent: [^self rootDirectoryMetavalueString].
	^ns = self defaultRootDirectoryString ifTrue: [self rootDirectoryMetavalueString] ifFalse: [ns]! !

!UrlPathFacade methodsFor: 'printing services' stamp: ''!
encodeString: aString isInQuery: isInQuery on: stream 
	aString do: 
			[:ch | 
			(self isTransparentChar: ch) 
				ifTrue: [stream nextPut: ch]
				ifFalse: 
					[(isInQuery and: [ch = Character space]) 
						ifTrue: [stream nextPut: $+]
						ifFalse: 
							[stream nextPut: $%.
							ch codePoint printOn: stream base: 16]]]! !

!UrlPathFacade methodsFor: 'printing services' stamp: ''!
encodeString: aString on: stream 
	self encodeString: aString isInQuery: false on: stream! !

!UrlPathFacade methodsFor: 'printing services' stamp: ''!
encodingOfString: aString
	"UrlPathFacade new encodingOfString: 'Hello, world!! / and burn?'"

	| stream |
	stream := aString copy writeStream.
	self encodeString: aString on: stream.
	^stream contents! !

!UrlPathFacade methodsFor: 'queries' stamp: ''!
isTransparentChar: ch
	^TransparentCharSet includes: ch! !

!UrlPathFacade methodsFor: 'conversion services' stamp: ''!
parseAuthorityFrom: stream into: aResourcePath 
	| port index string1 string2 |
	port := nil.
	index := 0.
	string1 := UtilityFunction nextFrom: stream until: [:ch | (index := #($/ $: $@) indexOf: ch ifAbsent: [0]) > 0].
	stream next.
	index = 1 
		ifTrue: [aResourcePath setHostname: string1]
		ifFalse: 
			[index = 2 
				ifTrue: 
					[string2 := UtilityFunction nextFrom: stream until: [:ch | (index := #($/ $@) indexOf: ch ifAbsent: [0]) > 0].
					stream next.
					index = 1 
						ifTrue: 
							[aResourcePath setHostname: string1.
							port := string2 asNumber]
						ifFalse: 
							[aResourcePath 
								setUser: (self decodeStringFrom: string1 readStream);
								setPassword: (self decodeStringFrom: string2 readStream)]]
				ifFalse: [aResourcePath setUser: (self decodeStringFrom: string1 readStream)].
			port == nil 
				ifTrue: 
					[aResourcePath setHostname: (UtilityFunction nextFrom: stream until: [:ch | (index := #($/ $:) indexOf: ch ifAbsent: [0]) > 0]).
					stream next.
					index = 2 ifTrue: [aResourcePath setPort: (stream upTo: $/) asNumber]]
				ifFalse: [aResourcePath setPort: port]].! !

!UrlPathFacade methodsFor: 'conversion services' stamp: ''!
parseQueryStringAndFragmentFrom: stream into: aResourcePath 
	| continue index |
	(stream peekFor: $?) 
		ifTrue: 
			[continue := stream atEnd not.
			[continue] whileTrue: 
					[aResourcePath 
						addQueryAssociation: 
							(self decodeStringInQueryFrom: (stream upTo: $=) readStream)
							-> (self decodeStringInQueryFrom: (UtilityFunction nextFrom: stream
										until: [:ch | (index := #($& $; $#) indexOf: ch ifAbsent: [0]) > 0]) 
											readStream).
					stream atEnd 
						ifTrue: [continue := false]
						ifFalse: 
							[stream next.
							continue := stream atEnd not and: [index < 3]]].
			index = 3 
				ifTrue: [aResourcePath setFragment: (self decodeStringFrom: stream)]]
		ifFalse: 
			[(stream peekFor: $#) 
				ifTrue: [aResourcePath setFragment: (self decodeStringFrom: stream)]]! !

!UrlPathFacade methodsFor: 'printing services' stamp: ''!
printPathnameOf: aResourcePath on: stream 
	aResourcePath pathnameIsEmpty 
		ifFalse: 
			[aResourcePath pathname 
				printOn: stream
				usingSeparator: self pathnameSeparator
				andTransformer: [:component | self encodingOfString: component]]! !

!UrlPathFacade methodsFor: 'directory services' stamp: ''!
resourceIsDirectory: operand
	"Answer whether the resource (e.g., a file) named/identified by <operand> is a directory.  A resource is a directory if it acts as a namespace containing other resources."

	^false! !

!UrlPathFacade methodsFor: 'testing' stamp: ''!
syntaxPermitsPort
	^true! !

!UrlPathFacade methodsFor: 'testing' stamp: ''!
syntaxPermitsProtocol
	^true! !

!UrlPathFacade methodsFor: 'testing' stamp: ''!
syntaxRequiresHostname
	^true! !

PassportObject subclass: #ResourceReference
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

ResourceReference subclass: #ExternalResourceReference
	instanceVariableNames: 'broker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
broker
	^broker! !

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
broker: aResourceBroker
	broker := aResourceBroker! !

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
key: aKey value: aValue
	key := aKey.
	^broker at: key put: aValue! !

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
removeIfAbsent: ifAbsent
	^broker removeKey: self key ifAbsent: ifAbsent! !

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
value
	^self valueIfNone: []! !

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
value: aValue
	^broker at: self key put: aValue! !

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNone: ifNone
	^broker at: self key ifAbsent: ifNone! !

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNonePut: valueBlock
	^broker at: self key ifAbsentPut: valueBlock! !

!ExternalResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNoneThenAt: writeKey put: valueBlock 
	^broker 
		at: key
		ifAbsentThenAt: writeKey
		put: 
			[key := writeKey.
			valueBlock value]! !

!ExternalResourceReference methodsFor: 'testing' stamp: ''!
valueIsDefined
	^broker includesKey: self key! !

ResourceReference subclass: #LocalResourceReference
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!LocalResourceReference methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	value := nil! !

!LocalResourceReference methodsFor: 'accessing' stamp: ''!
key: aKey value: aValue
	key := aKey.
	value := aValue! !

!LocalResourceReference methodsFor: 'accessing' stamp: ''!
value: aValue
	value := aValue! !

!LocalResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNone: ifNone
	^value == nil
		ifTrue: [ifNone value]
		ifFalse: [value]! !

!LocalResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNonePut: valueBlock
	^value == nil
		ifTrue: [value := valueBlock value]
		ifFalse: [value]! !

!LocalResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNoneThenAt: writeKey put: valueBlock 
	^value == nil 
		ifTrue: 
			[key := writeKey.
			value := valueBlock value]
		ifFalse: [value]! !

!LocalResourceReference methodsFor: 'testing' stamp: ''!
valueIsDefined
	^value ~~ nil! !

!ResourceReference methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	key := nil! !

!ResourceReference methodsFor: 'accessing' stamp: ''!
key
	^key! !

!ResourceReference methodsFor: 'accessing' stamp: ''!
key: aKey
	key := aKey! !

!ResourceReference methodsFor: 'accessing' stamp: ''!
key: aKey value: aValue
	self subclassResponsibility! !

!ResourceReference methodsFor: 'accessing' stamp: ''!
value
	^self valueIfNone: []! !

!ResourceReference methodsFor: 'accessing' stamp: ''!
value: aValue
	^self subclassResponsibility! !

!ResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNone: ifNone
	^self subclassResponsibility! !

!ResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNonePut: valueBlock
	^self subclassResponsibility! !

!ResourceReference methodsFor: 'accessing' stamp: ''!
valueIfNoneThenAt: writeKey put: valueBlock 
	^self subclassResponsibility! !

!ResourceReference methodsFor: 'testing' stamp: ''!
valueIsDefined
	^self subclassResponsibility! !

Object subclass: #UtilityFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Passport-Kernel'!

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
allElementsOf: aCollection satisfy: predicate
	"Answer true if the result of evaluating the one-argument block <predicate> with each element of <aCollection> as the argument is the value true for all members."

	aCollection do: [:element | (predicate value: element) ifFalse: [^false]].
	^true! !

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
ansiValueOfArrayLiteral: aLiteralArray 
	"UtilityFunction ansiValueOfArrayLiteral: #(1 #nil 2 #true 3 #false)"

	aLiteralArray == nil ifTrue: [^nil].
	^aLiteralArray collect: [:literalArrayElement | self ansiValueOfLiteralArrayElement: literalArrayElement]! !

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
ansiValueOfLiteralArrayElement: anArrayLiteralElement 
	"#(1 #nil 2 #true 3 #false) collect: [:literalArrayElement | UtilityFunction ansiValueOfLiteralArrayElement: literalArrayElement]"

	anArrayLiteralElement == #nil ifTrue: [^nil].
	anArrayLiteralElement == #true ifTrue: [^true].
	^anArrayLiteralElement == #false 
		ifTrue: [false]
		ifFalse: [anArrayLiteralElement]! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
componentsFromStream: source separator: separator
	"Answer an Array containing the 'components' ('tokens') parsed from the <source> Stream.  Each component (token) is separated from others by one or more occurrences of the <separator> value."

	"{UtilityFunction componentsFromStream: 'foo.bar.mitzvah' readStream separator: $.}"
 
	^self componentsFromStream: source separator: separator transformer: nil! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
componentsFromStream: source separator: separator transformer: block1
	"Answer an Array containing the 'components' ('tokens') parsed from the <source> Stream.  Each component (token) is separated from others by one or more occurrences of the <separator> value."

	"{UtilityFunction componentsFromStream: 'foo.bar.mitzvah' readStream separator: $. transformer: [:component | component asUppercase]}"
 
	| components |
	components := (Array new: 5) writeStream.
	[source peekFor: separator] whileTrue.
	block1 == nil
		ifTrue: [[source atEnd] whileFalse: [components nextPut: (source upTo: separator)]]
		ifFalse: [[source atEnd] whileFalse: [components nextPut: (block1 value: (source upTo: separator))]].
	^components contents! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
componentsFromString: source separator: separator 
	"Answer an Array containing the 'components' ('tokens') parsed from the <source> String.  Each component (token) is separated from others by one or more occurrences of the <separator> value."

	"{UtilityFunction componentsFromString: 'foo/bar/mitzvah' separator: $/}"

	^self componentsFromStream: source readStream separator: separator! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
componentsFromString: source separator: separator  transformer: block1
	"Answer an Array containing the 'components' ('tokens') parsed from the <source> String.  Each component (token) is separated from others by one or more occurrences of the <separator> value."

	"{UtilityFunction componentsFromString: 'foo/bar/mitzvah' separator: $/ transformer: [:component | component asUppercase]}"

	^self componentsFromStream: source readStream separator: separator transformer: block1! !

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
decodeDictionaryFromLiteralArray: literalArray 
	"Construct a `Dictionary' from the values containted in <literalArray>, which is an array that contains the keys and values of a Dictionary encoded as literal Arrays. This method must successfully consume any literalArray produced by UtilityFunction>>encodeDictionaryAsLiteralArray:."

	"{| dict |
	dict := IdentityDictionary new.
	dict at: #foo put: 'bar'.
	dict at: #bar put: #(1 2 3).
	UtilityFunction decodeDictionaryFromLiteralArray: (ChronosUtility encodeDictionaryAsLiteralArray: dict)}"

	| dictClass dict |
	literalArray == nil ifTrue: [^nil].
	dictClass := 
		EnvironmentFacade current
			resolveClassFromFullyQualifiedName: (literalArray at: 1)
			ifAbsent: [Dictionary].
	dict := dictClass new: literalArray size * 2.
	2 to: literalArray size
		by: 2
		do: 
			[:index | 
			| key value |
			key := (literalArray at: index) decodeAsLiteralArray.
			value := literalArray at: index + 1.
			value := value class == Array 
						ifTrue: 
							[value size > 0 
								ifTrue: 
									[| firstElement |
									firstElement := value first.
									(firstElement isSymbol and: 
											[(EnvironmentFacade current
												resolveClassFromFullyQualifiedName: firstElement
												ifAbsent: []) notNil]) 
										ifTrue: [value decodeAsLiteralArray]
										ifFalse: [value]]
								ifFalse: [value]]
						ifFalse: [value].
			dict at: key put: value].
	^dict! !

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
encodeDictionaryAsLiteralArray: aDictionary
	"Answer the literal Array encoding of <aDictionary>.'"

	"{| dict |
	dict := IdentityDictionary new.
	dict at: #foo put: 'bar'.
	dict at: #bar put: #(1 2 3).
	UtilityFunction encodeDictionaryAsLiteralArray: dict}"

	| dictStream |
	aDictionary == nil ifTrue: [^nil].
	dictStream := (Array new: aDictionary size * 2 + 1) writeStream.
	dictStream nextPut: (EnvironmentFacade current fullyQualifiedNameOfClass: aDictionary class).
	aDictionary keysAndValuesDo: 
		[:key :value | dictStream nextPut: key literalArrayEncoding; nextPut: value literalArrayEncoding].
	^dictStream contents! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
expandMacrosFrom: sourceStream withBindings: argBindings
	"{| bindings |
	bindings := Dictionary new.
	bindings
		at: #page put: [(3 + 4) printString];
		at: #whatever put: 'mitzvah';
		at: #localTimeZone put: 'Australia/Adelaide';
		at: #timeOnServer put: (Timepoint now withDefaultPrintPolicy: #rfc2822).
	UtilityFunction 
		expandMacrosFrom: 
			'
			Page: <v:page>. <s:unknown>
			Foo bar <s:whatever> 
			Local time: <e:localTimeZone | (DateAndTime now >> localTimeZone) % #rfc2822!!>.
			Server time: <p:timeOnServer>' readStream 
		withBindings: bindings}"

	"{| bindings date printInt |
	date := YearMonthDay today.
	printInt := [:int :width |
		| stream |
		stream := (String new: 10) writeStream.
	  	int printOn: stream paddedWith: $  to: width base: 10.
		stream contents].
	bindings := Dictionary new.
	bindings
		at: #year put: [printInt value: date year value: 4];
		at: #month put: [date monthName];
		at: #day put: [printInt value: date dayOfMonth value: 2].
	UtilityFunction expandMacrosFrom: 'Date: <v:day> <v:month> <v:year>' readStream withBindings: bindings}"

	| outStream processor |
	[outStream := (String new: 1024) writeStream.
	processor := Array with: [:v | v printString] with: [:v | v] with: [:v | v value].
	[sourceStream atEnd] 
		whileFalse: 
			[| ch0 ch1 |
			ch0 := sourceStream next.
			ch0 = $<
				ifTrue: 
					[| index |
					ch1 := sourceStream next. 
					ch1 = $e
						ifTrue: 
							[(sourceStream peekFor: $:)
								ifTrue:
									[| string argKey argValue |
									string := sourceStream upTo: $|.
									argKey := (self nextFrom: string readStream until: [:ch | ch isSeparator]) asSymbol.
									argValue := argBindings at: argKey ifAbsent: [].
									argValue == nil
										ifTrue: [outStream nextPut: ch0; nextPut: ch1; nextPut: $:; nextPutAll: string; nextPut: $!!]
										ifFalse: 
											[| expression |
											expression := (String new: 32) writeStream.
											expression nextPutAll: '[:'; nextPutAll: argKey; nextPutAll: ' |'.
											[expression nextPutAll: (sourceStream upTo: $!!).
											sourceStream peekFor: $>] whileFalse.
											expression nextPut: $].
											outStream nextPutAll: ((EnvironmentFacade current evaluateExpression: expression contents) value: argValue)]]
								ifFalse: [outStream nextPut: ch0; nextPut: ch1]]
						ifFalse:
							[(((index := #($p $s $v) indexOf: ch1) > 0) and: [sourceStream peekFor: $:])
								ifTrue: 
									[| argKey argValue |
									argKey := (sourceStream upTo: $>) asSymbol.
									argValue := argBindings at: argKey ifAbsent: [].
									argValue == nil
										ifTrue: [outStream nextPut: ch0; nextPut: ch1; nextPut: $:; nextPutAll: argKey; nextPut: $>]
										ifFalse: [outStream nextPutAll: ((processor at: index) value: argValue)]]
								ifFalse: [outStream nextPut: ch0; nextPut: ch1]]]
						ifFalse: [outStream nextPut: ch0]]] ensure: [sourceStream close].
	^outStream contents! !

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
indexOfName: aStringOrSymbol in: aCollectionOfStringsOrSymbols
	"Answer the index of <aStringOrSymbol> in <aCollectionOfStringsOrSymbols>.  If not present, raise an exception.  Ignore case differences in matching <aStringOrSymbol> to the elements of <aCollectionOfStringsOrSymbols>."

	"{UtilityFunction indexOfName: #may in: #(January February March April May June July August September October November December)}"

	^self indexOfName: aStringOrSymbol in: aCollectionOfStringsOrSymbols ifAbsent: [self signalError: 'Element not found: ', aStringOrSymbol printString]! !

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
indexOfName: aStringOrSymbol in: aCollectionOfStringsOrSymbols ifAbsent: block0 
	"Answer the index of <aStringOrSymbol> in <aCollectionOfStringsOrSymbols>.  If not present, answer the evaluation of <block0>.  Ignore case differences in matching <aStringOrSymbol> to the elements of <aCollectionOfStringsOrSymbols>."

	"{UtilityFunction indexOfName: #may in: #(January February March April May June July August September October November December) ifAbsent: [0]}"

	| canonicalName |
	canonicalName := aStringOrSymbol asUppercase.
	1 to: aCollectionOfStringsOrSymbols size
		do: 
			[:index | 
			(aCollectionOfStringsOrSymbols at: index) asUppercase = canonicalName 
				ifTrue: [^index]].
	^block0 value! !

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
isNilOrEmpty: aValue
	"UtilityFunction isNilOrEmpty: #()"

	aValue == nil ifTrue: [^true].
	^aValue isEmpty! !

!UtilityFunction class methodsFor: 'collection services' stamp: ''!
map: aDictionary by: transformer
	"Same as the ANSI-Standard defined behavior of #collect: when sent to <aDictionary>."
 
	| map |
	map := aDictionary species new: aDictionary size.
	aDictionary 
		keysAndValuesDo: [:key :value | map at: key put: (transformer value: value)].
	^map! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
nextFrom: stream until: predicate
	"Starting with the next element of the Stream <stream>, for each element in the <stream> that does NOT satisfy the <predicate>, up to (but not including) the first element that DOES satisfy the <predicate>, answer a SequenceableCollection containing all such elements in the same order as they occur in the <stream>. An element of the <stream> satisfies the <predicate> if and only if <predicate value: element> evaluates to true.  Leave the stream positioned before the first elment that DOES satsify the <predicate>."

	"{UtilityFunction nextFrom: '123abc' readStream until: [:each | each isAlphabetic]}"

	| tokenStream |
	tokenStream := (String new: 13) writeStream.
	[stream atEnd or: [predicate value: stream peek]]
		whileFalse: 
			[tokenStream nextPut: stream next].
	^tokenStream contents! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
nextFrom: stream while: predicate
	"Starting with the next element of the Stream <stream>, for each element in the <stream> that DOES satisfy the <predicate>, up to (but not including) the first element that does NOT satisfy the <predicate>, answer a SequenceableCollection containing all such elements in the same order as they occur in the <stream>. An element of the <stream> satisfies the <predicate> if and only if <predicate value: element> evaluates to true.  Leave the stream positioned before the first elment that does NOT satsify the <predicate>."

	"{UtilityFunction nextFrom: '123abc' readStream while: [:each | each isDigit]}"

	| tokenStream |
	tokenStream := (String new: 13) writeStream.
	[stream atEnd or: [(predicate value: stream peek) not]]
		whileFalse: 
			[tokenStream nextPut: stream next].
	^tokenStream contents! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
nextFrom: inStream while: predicate minChars: minChars maxChars: maxChars onUnexpectedEOD: unexpectedEODAction
	"UtilityFunction nextFrom: '1234abc' readStream while: [:ch | ch isDigit] minChars: 4 maxChars: 7 onUnexpectedEOD: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"UtilityFunction nextFrom: '1234abc' readStream while: [:ch | true] minChars: 1 maxChars: nil onUnexpectedEOD: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"UtilityFunction nextFrom: '1234abc' readStream while: [:ch | ch isDigit] minChars: 1 maxChars: 2 onUnexpectedEOD: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"UtilityFunction nextFrom: '1234abc' readStream while: [:ch | ch isDigit] minChars: 5 maxChars: 5 onUnexpectedEOD: [:prefix :ch :position | prefix->(Array with: ch with: position)]"

	| continue count ch outStream |
	count := 0.
	outStream := (String new: 8) writeStream.
	continue := inStream atEnd not.
	[continue]
		whileTrue:
			[ch := inStream peek.
			(predicate value: ch)
				ifTrue: 
					[count := count + 1.
					outStream nextPut: inStream next.
					continue := (inStream atEnd or: [maxChars notNil and: [count >= maxChars]]) not]
				ifFalse:
					[continue := false]].
	^count >= minChars
		ifTrue: [outStream contents]
		ifFalse: [unexpectedEODAction value: outStream contents value: ch value: inStream position]! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
nextLineFrom: stream 
	"Answer a String containing the next line of text from the Stream <stream>. Do not include the end-of-line character(s) in the answered String. Leave the <stream> positioned at the beginning of the next line. Transparently handle all three common line-end conventions (CR, LF and CRLF.)"

	| lineStream ch cr lf atEnd |
	lineStream := (String new: 37) writeStream.
	cr := Character cr.
	lf := Character lf.
	atEnd := stream atEnd.
	[atEnd] whileFalse: 
			[ch := stream next.
			ch = lf 
				ifTrue: [atEnd := true]
				ifFalse: 
					[ch = cr 
						ifTrue: 
							[stream peekFor: lf.
							atEnd := true]
						ifFalse: 
							[lineStream nextPut: ch.
							atEnd := stream atEnd]]].
	^lineStream contents! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
nextScaledDecimalFrom: stream minDigits: minDigits maxDigits: maxDigits maxValue: maxValue handleRejection: handleRejection
	"UtilityFunction nextScaledDecimalFrom: '59' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: '60' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: '05' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: '0' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: '00.123' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: '01.999999999' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: '60.999999999' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: '00.x' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: '61' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"UtilityFunction nextScaledDecimalFrom: 'x7' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"

	| second |
	second := 
		UtilityFunction 
			nextUnsignedIntegerFrom: stream
			minDigits: minDigits
			maxDigits: maxDigits
			acceptancePredicate: [:int :digitCount | maxValue == nil or: [int <= maxValue]]
			handleRejection: [:value :count :rejectionReason | ^handleRejection value: value value: count value: rejectionReason].
	((stream peekFor: $.) or: [stream peekFor: $,]) 
		ifTrue: 
			[| subSeconds |
			subSeconds := 
				UtilityFunction 
					nextFrom: stream
					while: [:ch | ch isDigit]
					minChars: 0
					maxChars: 99999999
					onUnexpectedEOD: [:prefix :ch :position | ^handleRejection value: prefix value: 0 value: #notAnInteger].
			subSeconds size > 0 
				ifTrue: 
					[| scale denominator |
					scale := subSeconds size.
					denominator := 10 raisedToInteger: scale.
					second := (ScaledDecimal  numerator: second * denominator + (Integer readFrom: subSeconds readStream) denominator: denominator scale: scale)]].
	^second! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
nextUnsignedIntegerFrom: stream minDigits: minDigits maxDigits: maxDigits acceptancePredicate: acceptancePredicate handleRejection: handleRejection 
	"{| stream result |
	stream := ' 14 Feb 2006' readStream.
	result := UtilityFunction nextUnsignedIntegerFrom: stream minDigits: 1 maxDigits: 4 
				acceptancePredicate: [:int :digitCount | digitCount <= 2] 
				handleRejection: [:value :digitCount :rejectionReason | rejectionReason->(Array with: value with: digitCount)].
	Array with: result with: stream upToEnd}"

	"{| stream result |
	stream := ' 2006-02-14' readStream.
	result := UtilityFunction nextUnsignedIntegerFrom: stream minDigits: 1 maxDigits: 4 
				acceptancePredicate: [:int :digitCount | digitCount <= 2 or: [digitCount = 4]] 
				handleRejection: [:value :digitCount :rejectionReason | rejectionReason->(Array with: value with: digitCount)].
	Array with: result with: stream upToEnd}"

	"{| stream result |
	stream := ' 20060214' readStream.
	result := UtilityFunction nextUnsignedIntegerFrom: stream minDigits: 1 maxDigits: 4 
				acceptancePredicate: [:int :digitCount | digitCount <= 2] 
				handleRejection: [:value :digitCount :rejectionReason | rejectionReason->(Array with: value with: digitCount)].
	Array with: result with: stream upToEnd}"

	"{| stream result |
	stream := ' 238' readStream.
	result := UtilityFunction nextUnsignedIntegerFrom: stream minDigits: 1 maxDigits: 3 
				acceptancePredicate: [:int :digitCount | digitCount <= 2] 
				handleRejection: [:value :digitCount :rejectionReason | rejectionReason->(Array with: value with: digitCount)].
	Array with: result with: stream upToEnd}"

	| integer ch digitCount |
	self skipSeparators: stream.
	stream atEnd 
		ifTrue: 
			[^handleRejection 
				value: nil
				value: 0
				value: #streamAtEnd].
	digitCount := 0.
	integer := 0.
	ch := stream peek.
	[(maxDigits == nil or: [digitCount < maxDigits]) and: [ch notNil and: [ch isDigit]]] whileTrue: 
			[digitCount := digitCount + 1.
			integer := integer * 10 + stream next digitValue.
			ch := stream peek].
	^digitCount >= minDigits 
		ifTrue: 
			[(acceptancePredicate value: integer value: digitCount) 
				ifTrue: [integer]
				ifFalse: 
					[stream skip: digitCount negated.
					handleRejection 
						value: integer
						value: digitCount
						value: #notAccepted]]
		ifFalse: 
			[digitCount > 0 
				ifTrue: 
					[handleRejection 
						value: integer
						value: digitCount
						value: #lessThanMinDigits]
				ifFalse: 
					[handleRejection 
						value: nil
						value: digitCount
						value: #notAnInteger]]! !

!UtilityFunction class methodsFor: 'printing services' stamp: ''!
print: anInteger asPostDecimalOn: stream decimalPoint: decimalPointChar scale: scale minPrecision: minPrecision maxPrecision: maxPrecision prependingZero: shouldPrependZero

	"Vary the scale:
		{(5 to: 9) collect: [:scale | 
			| stream |
			stream := String new writeStream.
			UtilityFunction
				print: 91827
				asPostDecimalOn: stream 
				decimalPoint: $. 
				scale: scale 
				minPrecision: 1
				maxPrecision: #all
				prependingZero: true.
			stream contents]}"

	"Vary the minPrecision:
		{(2 to: 4) collect: [:minPrecision | 
			| stream |
			stream := String new writeStream.
			UtilityFunction
				print: 9
				asPostDecimalOn: stream 
				decimalPoint: $. 
				scale: 2 
				minPrecision: minPrecision
				maxPrecision: 4
				prependingZero: true.
			stream contents]}"

	"Vary the maxPrecision:
		{(0 to: 6) collect: [:maxPrecision | 
			| stream |
			stream := String new writeStream.
			UtilityFunction
				print: 91827
				asPostDecimalOn: stream 
				decimalPoint: $. 
				scale: 6 
				minPrecision: 1
				maxPrecision: maxPrecision
				prependingZero: true.
			stream contents]}"

	| isZero absValue n divisor d maxDigits z |
	isZero := anInteger isZero.
	(isZero and: [minPrecision < 1]) ifTrue: [^self].
	shouldPrependZero 
		ifTrue: 
			[anInteger negative ifTrue: [stream nextPut: $-].
			stream nextPut: $0].
	maxDigits := maxPrecision == #all ifTrue: [scale max: minPrecision] ifFalse: [maxPrecision].
	maxDigits = 0 ifTrue: [^self].
	stream nextPut: decimalPointChar.

	isZero 
		ifTrue: 
			[(minPrecision min: maxPrecision) timesRepeat: [stream nextPut: $0]. 
			^self].

	absValue := anInteger abs.
	d := 1.
	n := 1.
	divisor := 10.
	[divisor <= absValue] 
		whileTrue: 
			[d := d + 1.
			n := divisor.
			divisor := divisor * 10].

	z := scale - d.
	(z min: maxDigits) timesRepeat: [stream nextPut: $0].
	z >= maxDigits ifTrue: [^self].

	d := z.
	divisor := n.
	n := absValue.
	[d := d + 1.
	divisor > 1] 	
		whileTrue: 
			[stream nextPut: (Character digitValue: (n quo: divisor)).
			d >= maxDigits ifTrue: [^self].
			n := n rem: divisor.
			n isZero ifTrue: 
				[(minPrecision min: maxDigits) - d  timesRepeat: [stream nextPut: $0].
				^self].
			divisor := divisor // 10].
	stream nextPut: (Character digitValue: n).
	(minPrecision min: maxDigits) - d  timesRepeat: [stream nextPut: $0].! !

!UtilityFunction class methodsFor: 'printing services' stamp: ''!
print: anInt paddedWith: padChar to: minDigits on: stream 
	"There is no ANSI-standard message to an Integer that performs this operation.  One of the unfortunate sins of omission on the part of the ANSI Smalltalk Committee.  VisualWorks provides this functionality--but as of VW 7.2.1, it doesn't work correctly for negative integers."

	"{| stream | 
	stream := (String new: 10) writeStream.
	UtilityFunction print: -1 paddedWith: $0 to: 4 on: stream.
	stream contents}"

	| digits padCount |
	padChar == nil ifTrue: [^anInt printOn: stream].
	digits := anInt abs printString.
	anInt negative ifTrue: [stream nextPut: $-].
	padCount := minDigits - digits size.
	[padCount > 0] whileTrue: 
			[stream nextPut: padChar.
			padCount := padCount - 1].
	stream nextPutAll: digits! !

!UtilityFunction class methodsFor: 'printing services' stamp: ''!
printFractional: aNumber asDecimalOn: stream decimalPoint: decimalPointChar precision: precision
	"{| stream |
	stream := String new writeStream.
	UtilityFunction
		printFractional: 123.5d 
		asDecimalOn: stream 
		decimalPoint: $. 
		precision: 2.
	stream contents}"

 	"{| stream |
	stream := String new writeStream.
	UtilityFunction
		printFractional: 1/3
		asDecimalOn: stream 
		decimalPoint: $. 
		precision: 33.
	stream contents}"

	aNumber isInteger
		ifTrue: [aNumber printOn: stream]
		ifFalse: 
			[| int |
			int := aNumber truncated.
			int printOn: stream.
			self
				print: ((aNumber - int) * (10 raisedToInteger: precision)) rounded
				asPostDecimalOn: stream
				decimalPoint: decimalPointChar
				scale: precision
				minPrecision: precision
 				maxPrecision: precision
				prependingZero: false]! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
skipOver: stream until: predicate
	"Advance the position of the <stream> up to (but not past) the first element that DOES satisfy the <predicate>. An element of the <stream> satisfies the <predicate> if and only if <predicate value: element> evaluates to true."

	[stream atEnd or: [predicate value: stream peek]]
		whileFalse: 
			[stream next].! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
skipOver: stream while: predicate
	"Advance the position of the <stream> up to (but not past) the first element that does NOT satisfy the <predicate>. An element of the <stream> satisfies the <predicate> if and only if <predicate value: element> evaluates to true."

	[stream atEnd or: [(predicate value: stream peek) not]]
		whileFalse: 
			[stream next].! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
skipSeparators:  stream
	"Advance the position of the <stream> up to (but not past) the first element of the <stream> that is not a separator character."

	self skipOver: stream while: [:ch | ch isSeparator]! !

!UtilityFunction class methodsFor: 'stream/parsing services' stamp: ''!
skipToNextLineOf: stream 
	"Advance the position of the <stream> to the beginning of the next line of text. Transparently handle all three common line-end conventions (CR, LF and CRLF.)"

	| ch cr lf atEnd |
	cr := Character cr.
	lf := Character lf.
	atEnd := stream atEnd.
	[atEnd] whileFalse: 
			[ch := stream next.
			ch = lf 
				ifTrue: [atEnd := true]
				ifFalse: 
					[ch = cr 
						ifTrue: 
							[stream peekFor: lf.
							atEnd := true]
						ifFalse: [atEnd := stream atEnd]]]! !
UrlPathFacade initialize!
HttpOperation initialize!
ResourcePathContext initialize!
EnvironmentFacade initialize!
PassportNotANumber initialize!
PassportInfinitesimal initialize!
Registratable initialize!
Pathname initialize!
PassportInfinity initialize!
